---------------------------------------------------------------------------
                                                            October 9, 2018
amavisd-new-2.11.1 release notes

- removed a trailing dot element from @INC, as a workaround for a perl
  vulnerability CVE-2016-1238;

- amavis-services: bumping up syslog level from LOG_NOTICE to LOG_ERR
  for a message "PID <pid> went away", and removed redundant newlines
  from some log messages;

- safe_decode() and safe_decode_utf8(): avoid warning messages
    "Use of uninitialized value in subroutine entry"
  in Encode::MIME::Header when the $check argument is undefined;

- @sa_userconf_maps has been extended to allow loading of per-recipient
  (or per- policy bank, or global) SpamAssassin configuration set from
  LDAP. For consistency with SQL a @sa_userconf_maps entry prefixed with
  'ldap:' will load SpamAssassin configuration set using the
  load_scoreonly_ldap() method;  a patch by Atanas Karashenski;

- add some Sanesecurity.Foxhole false positives to the default
  list @virus_name_to_spam_score_maps;

- updated some comments;

---------------------------------------------------------------------------
                                                             April 26, 2016
amavisd-new-2.11.0 release notes

Contents:
  DEPRECATION NOTICE
  COMPATIBILITY
  BUG FIXES
  NEW FEATURES
  OTHER
  SUPERVISED PROCESS NOTES


DEPRECATION NOTICE

- The old DomainKey signatures (a predecessor to DKIM) has been published
  as a historic document RFC 4870 and obsoleted by RFC 4871 in May 2007;
  Support for DomainKey signatures is likely to be removed with a next
  version of amavisd.

- It is expected that the next release of amavisd will start using some
  of the features made available with perl 5.10.0 (such as a defined-or
  operator, or a possessive quantifier in regular expressions), so
  consider running amavisd under perl 5.8.9 or earlier as unsupported.
  In practice, using such old version of perl is problematic even now,
  as their support for Unicode / UTF-8 is incomplete and unreliable.


COMPATIBILITY

There are some minor incompatibilities between versions 2.10.1 and 2.11.0:

- During startup more detailed testing is performed for taint bugs of
  a module Encode and the function utf8::is_utf8(), which may produce
  warnings on old versions of perl with its old core module Encode,
  or may exit on detecting more sinister bugs in these modules.
  Note that the module Encode may be upgraded independently of perl,
  if desired;

- with MySQL: changed character set 'utf8' to 'utf8mb4' for fields
  msgs.subject and msgs.from_addr, as previously some of the UTF-8
  characters could not be stored in a database;

- when logging to stderr a timestamp prefix to each message is only
  still inserted if $DEBUG is true.  When $DEBUG is false each message
  is prefixed with a syslog log level in angle brackets, and a timestamp
  is omitted (for compatibility with systemd);

- a perl module Digest::SHA is now a required module. It is a perl core
  module since perl 5.10, so it shouldn't introduce a new dependency,
  and it was a de-facto required module even previously, as it was needed
  for DKIM processing;


BUG FIXES

- delivery method was undefined when always_bcc was used;
  reported by Marieke Janssen;

- avoid warnings issued by perl 5.21.7 and later:
    Negative repeat count does nothing at ./amavisd line 16408
  and similarly in amavisd-status;

- releasing from an SQL quarantine failed to provide the original
  envelope sender address to a released message;
  reported, and a fix suggested by Tom Johnson and Tobias;

- remove a stale database file __db.nanny.db on a reload or restart,
  as it can prevent a successful start when a previous start failed
  for some reason; a patch by Trent Lloyd;


NEW FEATURES

- Polished rough corners to facilitate running amavisd as a non-daemonized
  supervised process, e.g. under systemd:

  * make it possible/easier to disable use of a pid_file;

  * send status notifications to systemd when a NOTIFY_SOCKET environment
    variable is provided;

  * improved logging to stderr when $do_syslog and $logfile are undefined
    (although logging through syslog might still be preferred, as writing
    to a shared pipe from multiple child processes only guarantees atomicity
    of writes shorter than PIPE_BUF, which is typically 512 bytes on *BSD,
    and 4096 bytes on Linux systems);

  See below for a sample amavisd.service file.

- A log template macro 'report_json' can now take arguments, which can
  include or exclude fields (key/values) from the JSON report object.
  Arguments to a macro are either field names (keys) to be included
  in a report, or are field names to be excluded, each prefixed with
  an exclamation mark, to produce a report with all but excluded fields.

  Field names are case-sensitive. The order of fields in a serialized
  JSON object is unaffected by the order of field names in a filter.
  Unknown or non-present field names in a filter are silently ignored.

  Example:
    [:report_json|mail_id|action|content_type|queued_as|mail_from|size]
  or:
    [:report_json|!recipients|!elapsed|!os_fp|!subject|!subject_rot13]

  For better clarity, instead of listing field names as individual
  arguments to a macro, it is also possible to provide a single argument
  to a macro, in which field names are separated by whitespace:
    [:report_json|mail_id action content_type queued_as mail_from size]
  or:
    [:report_json|  !message !recipients !to_addr   !elapsed !os_fp
       !subject !subject_rot13 !user_agent !tests !tests_ham !tests_spam]

  As an example, a setting in a config file may look like:
    $log_templ = '[:report_json|mail_id action queued_as mail_from]';

  If at least one field name has an exclamation mark (i.e. is to be
  excluded), all but excluded fields are implied, so any field names
  without an exclamation mark are redundant.

  Currently this is a simple filter where subfields of a structured
  object cannot be selectively filtered (e.g. elapsed.SpamCheck).
  For finer control on JSON content use some external JSON-processing
  utility.  Based on a patch by Markus Benning.

- Two new configuration settings are added: %smtpd_tls_server_options
  and %smtp_tls_client_options. These two associative arrays are passed
  to IO::Socket::SSL->start_SSL when establishing a server-side or a
  client-side TLS session with an MTA, and provide more control over
  a TLS session - like providing certificates and restricting ciphers.
  See documentation of a perl module IO::Socket::SSL for a list of
  all options with their descriptions and their defaults.

  When TLS is in use, it is recommended to stick to fresh versions
  of the module IO::Socket::SSL and the underlying ssl library,
  as it can provide a safer set of defaults (e.g. excluded SSLv2).

  Existing config options $smtpd_tls_cert_file and $smtpd_tls_key_file
  are now deprecated in favour of a more generic %smtpd_tls_server_options.
  Preferably set fields 'SSL_key_file' and 'SSL_cert_file' directly in
  %smtpd_tls_server_options instead. For compatibility with 2.10 the
  values of $smtpd_tls_cert_file and $smtpd_tls_key_file are fed into
  the associative array %smtpd_tls_server_options if fields 'SSL_key_file'
  and 'SSL_cert_file' are not provided (do not exist) there.

  Example:

  %smtp_tls_client_options = (
    SSL_verifycn_scheme => 'smtp',
    SSL_version => '!SSLv2,!SSLv3',
    SSL_cipher_list => 'HIGH:!MD5:!DSS:!aNULL',
#   SSL_client_ca_file => ... ,
  );

  %smtpd_tls_server_options = (
    SSL_verifycn_scheme => 'smtp',
    SSL_session_cache => 2,
    SSL_key_file  => "$MYHOME/cert/amavisd-key.pem",
    SSL_cert_file => "$MYHOME/cert/amavisd-cert.pem",
    SSL_dh_file   => "$MYHOME/cert/amavisd-dh.dat",
  # SSL_ca_file   => ... ,
    SSL_version   => '!SSLv2,!SSLv3',
    SSL_cipher_list => 'HIGH:!MD5:!DSS:!aNULL',
  );

  Or just to change some field and leave the rest at their default:

    $smtp_tls_client_options{SSL_verify_mode} = 0;  # SSL_VERIFY_NONE

  Suggested by Marc Grooz and Patrick Ben Koetter, based on a patch
  by Markus Benning.

- Supports receiving SMTP/LMTP connections through a HAProxy,
  recognizing 'PROXY protocol Version 1' data on the first line read,
  after a connection from HAProxy to amavisd has been established.
  Connection data (IP addresses and ports) received via this protocol
  end up replacing such data in the the Amavis::In::Connection object
  ($conn).  Set configuration variable $haproxy_target_enabled (also
  a member of policy banks) to true in order to enable this protocol.

- redis: allow a scoped / link-local IP address specification
  (avoiding current limitation in IO::Socket::IP [rt.cpan.org #89608]);

- the Amavis::Unpackers::Part::digest method now holds a digest (SHA1,
  hex) of a decoded (base64 or quoted-printable) MIME part contents,
  followed by a colon and a lowercased Content-Type of the MIME part.
  Canonical line endings CRLF in decoded textual parts are normalized
  to a native newline (\n) before feeding them to a digest algorithm.

  These digests are passed to SpamAssassin through a 'mimepart_digests'
  supplementary attribute, and are available to custom hooks. As of
  version SpamAssassin 3.4.1, these are used as additional tokens in
  a Bayes plugin. Even though SpamAssassin is capable of computing
  the same or similar digests on its own, the advantage of computing
  them in amavisd is that they reflect all and completely unmodified
  and untruncated MIME parts of a mail message, including non-textual
  attachments.

  For debugging, search the log for "mimepart digest: ", logged at
  log level 5, and ".* Content-Type: .*, size:" at log level 2.
  Based on a suggestion by Andreas Schulze back in 2014.

  A configuration setting $mail_part_digest_algorithm was added, which
  chooses an algorithm name for generating digests of decoded MIME
  parts of a message. The value is an algorithm name as accepted by
  Digest::SHA->new(), e.g. 'sha1' or 'SHA-1' or 'SHA-256' or 'sha256',
  or a string 'MD5' (case-insensitive) which chooses the MD5 algorithm
  as implemented by a module Digest::MD5. An undefined value disables
  generating digests of MIME parts. The $mail_part_digest_algorithm
  setting is a dynamic setting, i.e. it is a member of policy banks.

  For compatibility with SpamAssassin the chosen algorithm should be
  SHA1 (which is a default), otherwise bayes tokens won't match those
  generated by sa-learn (which is typically used for off-line learning).
  Bayes auto-learning in SpamAssassin is unaffected by a mismatch of
  the algorithm, as it believes digests received from amavisd.

- Policy bank names in a @client_ipaddr_policy setting can now accept
  a comma-separated list of policy names to be loaded on a match
  (for loading of policy banks based on an IP address of a SMTP client).
  Whitespace around each policy name is allowed and is stripped.
  Previously only a single policy bank name was allowed in each entry
  of @client_ipaddr_policy.

  This makes it consistent with loading of policy banks based on a
  DKIM-based setting @author_to_policy_bank_maps, and on virus checker
  results via the @virus_name_to_policy_bank_maps setting.

- Experimental feature: IP lookups (as implemented by lookup_ip_acl()
  and used by @client_ipaddr_policy) can now also do DNS-based lookups,
  in addition to array- and hash- based lookups.
  Suggested by Patrick Ben Koetter and loosely based on his patch.

  DNS lookups follow RFC 5782 conventions (DNS Blacklists and Whitelists:
  DNSBL, DNSWL, collectively known as DNSxL).  A DNS query of a type 'A'
  is performed on a reversed IP address prepended to a specified domain
  name (zone name).  RFC 5782 suggests that only type-A resource records
  of a DNS reply in an address range 127.0.0.0/8 may be considered.

  For example, given a zone name 'rbl.example.org' and a SMTP client's
  IP address 198.51.100.12, a DNS type-A query for a domain name
  "12.100.51.198.rbl.example.org" would be sent to a specified or to a
  default DNS resolver or server. Similarly, an IP address 2001:db8::2:f
  would produce a DNS type-A query for a domain name "f.0.0.0.2.0.0.0.0.
  0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.8.b.d.0.1.0.0.2.rbl.example.org" .

  The setting @client_ipaddr_policy contains a list of pairs, each pair
  consisting of a lookup object (arrayref or hashref, or now also an
  Amavis::Lookup::DNSxL object), followed by a policy bank name (which
  is a string: one or more policy bank names, comma-separated).

  The object constructor Amavis::Lookup::DNSxL->new accepts as its
  arguments: a dns zone name, expected result(s) for a match, and a
  resolver object. Only the first argument (a DNSxL zone name) is
  required, the remaining two arguments are optional. A default
  expected result is '127.0.0.2', and a default Net::DNS::Resolver
  persistent object is provided implicitly if not provided by a caller
  (it reads a DNS resolver's IP address from /etc/resolv.conf).

  The "expected result(s) for a match" argument (the second argument)
  is compared to the address found in a DNS reply (in a 127.0.0.0/8 range).
  It can be:
  a) an integer between 0 and 255 (or a string representing such
    integer), which is used to match the last byte on the 127.0.0.x quad;
  b) a string in a dotted-quad form of an IPv4 address in a 127.0.0.0/8
    range, where leading bytes may be omitted (e.g. '1.8' == '127.0.1.8');
  c) a reference to an array consisting of entries in an (a) or (b) form,
     where a match with any of the array elements suffices for a match;
  d) a perl regular expression object (e.g.  qr{^127\.[3-8]\.0\.\d*$} ).

  If an IP address in a DNS reply matches the provided "expected result"
  argument, the policy banks associated with that entry are loaded,
  and a search through a @client_ipaddr_policy list stops.

  As a shorthand a subroutine Amavis::Conf::q_dns_a() is provided,
  which is just a convenient wrapper for Amavis::Lookup::DNSxL->new().

  Example:

  @client_ipaddr_policy = (
    [qw( 0.0.0.0/8 127.0.0.0/8 [::] [::1] )] => 'MYNETS, LOCALHOST',
    [qw( 169.254.0.0/16 [fe80::]/10 )]       => 'MYNETS, LINKLOCAL',
    [qw( 10.0.0.0/8 172.16.0.0/12 192.168.0.0/16 )] => 'MYNETS, PRIVATENET',
    \@mynetworks => 'MYNETS',
    q_dns_a('rbl.example.org')           => 'MY-CUSTOMER-A',    # 127.0.0.2
    q_dns_a('rbl.example.org', 3) => 'MYNETS,MY-CUSTOMER-B',    # 127.0.0.3
    q_dns_a('rbl.example.org', '0.2.99') => 'MY-CUSTOMER-C',    # 127.0.2.99
    q_dns_a('rbl.example.org', '127.0.0.7') => 'MY-CUSTOMER-D', # 127.0.0.7
    q_dns_a('rbl.example.org', qr/^127\.1\.\d+\.2\d*\z/) =>'X', # 127.1.*.2*
    q_dns_a('rbl.example.org', '192.0.2.0.2')=>'never matches', # not in 127/8
  );

  Below is an example of an amavisd.conf section with an explicitly
  provided Net::DNS::Resolver object, which offers finer control over
  its settings:

  use Net::DNS;
  my $dnsxl_res = Net::DNS::Resolver->new(
    config_file => '/etc/resolv.conf',
    port => 5333, retry => 1, persistent_udp => 1,
    tcp_timeout => 2, udp_timeout => 2, retrans => 1,
  );
  $dnsxl_res or die "Module Net::DNS not available for DNSxL usage";
  $dnsxl_res->udppacketsize(1220);

  my $myrbl = 'rbl.example.org';

  @client_ipaddr_policy = (
    \@mynetworks => 'MYNETS',
    q_dns_a($myrbl, 2,       $dnsxl_res) => 'MY-CUSTOMER-A',  # 127.0.0.2
    q_dns_a($myrbl, [3,4,5], $dnsxl_res) => 'MY-CUSTOMER-B',  # 127.0.0.{3,4,5}
  );

  This DNS-lookup feature is considered experimental in a sense that
  its API may change in future versions. As it is currently implemented,
  each q_dns_a() entry in a @client_ipaddr_policy results in its own
  DNS query, which is quite inefficient with more that one or two such
  entries. It would make more sense to do a single DNS lookup and provide
  some mapping between results returned and policy bank names to be
  loaded. Note also that DNS lookups are performed synchronously and
  sequentially (one at a time, one after another), so a slowly responding
  DNS server combined with multisecond timeouts and retries could severely
  bog down the amavisd response time, easily to exceed the time a MTA or
  a SMTP client is willing to wait for a response. YOU HAVE BEEN WARNED!


OTHER

- Relax a check on a PID number found in a pid file, considering
  that amavisd may run as PID #1 under Docker; reported by Imre Rad.

- Relax a check on $pid_file being configured or provided by a command
  line option -P.  Amavisd can now run without checking or providing a
  PID file of a running master process, which is appropriate for running
  non-daemonized amavisd as a supervised process (e.g. under supervision
  suites such as systemd, s6, nosh, runit, launchd or similar).  Also,
  specifying a command line option -P '' (i.e. giving it an empty name
  of a pid_file) overrides a configuration option $pid_file and is a
  quick way to disable usage of a pid_file.

  A default value of $pid_file is now only provided if a global
  setting $daemonize is true (which is a default, unless running
  with 'foreground' or 'debug' command line options).
  A non-daemonized amavisd leaves $pid_file undefined as a default,
  which facilitates running amavisd as a supervised process, e.g.
    $daemonize = $pid_file = $daemon_user = undef;

  When a pid_file is disabled and running under systemd, amavisd obtains
  a PID of a master process from systemd through environment variable
  MAINPID, which allows operations like 'amavisd reload' and 'amavisd stop'
  from a .service file  (ExecReload and ExecStop in systemd.exec(5)).

  Btw, a command line argument 'foreground' is a quick way to override
  a configuration setting $daemonize - it sets its value to 0.

  To let amavisd provide and use a PID file even when not daemonized,
  configure a PID file explicitly, e.g.: $pid_file = "$MYHOME/amavisd.pid";


- provide sensible diagnostics when $daemon_user is undefined and
  starting as root;

- 'sanitize_nul' function is now enabled by default (this is currently
  not configurable). Null octets found in a message are replaced by a
  pair of octets \xC0 \x80, which is a "Modified UTF-8" encoding of a
  NUL. This is done to avoid a mailbox server (like Cyrus) or a mail
  client on choking on such mail. The downside is that such sanitation
  can invalidate a DKIM signature - but non-encoded NUL octets are not
  allowed in mail anyway, so not much harm is done;

- overhauled a client side of the ClamAV clamd protocol;

- updated decoder for 7z archives to improve handling of encrypted
  content; based on a patch by Markus Benning;

- recognize and handle completely encrypted zip archives by 7z
  (in do_7zip); a patch provided by Thomas Jarosch;

- adjusted log levels of some log/debug messages;

- reject a message with an 8BITMIME body type if a back-end MTA does
  not announce 8bit-MIMEtransport capability in its EHLO response
    ( 550 5.6.3 Conversion to 7BIT required but not supported );

- replaced calls to Encode::is_utf8() by utf8::is_utf8() - less buggy
  in old versions of perl, but requires perl 5.8.1 or later;

- replaced calls to Encode::encode_utf8() by utf8::encode() - is
  much faster, and is less buggy in old versions of perl;

- more detailed testing for taint bugs of a module Encode and in
  utf8::is_utf8() during startup;

- decode a supposedly (or guessably) character set ISO-8859-1 as
  Windows-1252, which is a proper superset of ISO-8859-1 and often
  mistaken for ISO-8859-1; (this follows advice of HTML5);

- with MySQL: changed character set 'utf8' to 'utf8mb4' for fields
  msgs.subject and msgs.from_addr;

- in case the Net::Server receives a connection over a Unix socket
  (e.g. from amavisd-release) but is unable to determine a socket name,
  supply a dummy socket name 'UNKNOWN' so that a policy bank 'SOCK'
  can still be loaded;

- the setting $mail_digest_algorithm is now a dynamic setting, i.e.
  can be configured per policy bank. The change makes it consistent
  with a new setting $mail_part_digest_algorithm, which is also dynamic;

- updated the @av_scanners Avast entry ( http://www.avast.com/ )
  in the sample config file amavisd.conf to a new version
  of their scanner:
    ['avast! Antivirus', '/bin/scan', '{}', [0], [1], qr/\t(.+)/m]
  Thanks to Martin Tůma from Avast for the new entry;

- updated a default @$map_full_type_to_short_type_re to distinguish
  encrypted PGP/GnuPG files from other PGP/GnuPG containers like
  a detached signature, exported public key files, etc., if a
  newer version of a file(1) utility is in use (5.20?);

- relaxed the  /\bscript\b.* text executable\b/  regexp entry in the
  default @$map_full_type_to_short_type_re list so that a mail part
  such as qualified by a file(1) utility as:
    Python script, Non-ISO extended-ASCII text executable
  does not qualify as an executable; reported by Tilman Schmidt;

- updated a default @$map_full_type_to_short_type_re to recognize
  a Microsoft Word document as type doc; thanks to Jörg Backschues;

- added PhishTank.Phishing to a default @virus_name_to_spam_score_maps;

- reworded some notification texts;


SUPERVISED PROCESS NOTES

Socket activation (running under a superserver with fd-holding) is
currently not available. Note that 'amavisd reload' does fd-holding
and socket passing to a new incarnation of amavisd server on its own,
which means that a client (an MTA) does not see a disruption on a
reload (= warm restart), unlike in case of restarting amavisd.

As a reminder: a full restart is only necessary when changing the set
of listening sockets in a configuration file. For all other needs
(like changing other settings, updating SpamAssassin rules, upgrading
the amavisd program, or perl modules, or perl itself) a reload suffices.

Here is a sample file amavisd.service for use under systemd
(indented for clarity).  Lightly tested on Debian 8.0 (Jessie)
on a Raspberry Pi.

/lib/systemd/system/amavisd.service

  [Unit]
  Description=amavisd-new mail filter
  Before=shutdown.target
  After=systemd-journald-dev-log.socket network-online.target local-fs.target
  Wants=network-online.target
  Conflicts=shutdown.target

  [Service]
  Type=notify
  NotifyAccess=main
  KillMode=mixed
  TimeoutStartSec=1min
  TimeoutStopSec=3min
  User=amavis
  Group=amavis
  WorkingDirectory=/var/lib/amavis/tmp
  StandardOutput=syslog
  SyslogFacility=mail
  SyslogIdentifier=amavis
  ProtectSystem=full
  ProtectHome=yes
  NoNewPrivileges=yes
  ExecStart  = /usr/sbin/amavisd-new -P '' foreground
  ExecReload = /usr/sbin/amavisd-new -P '' reload
  ExecStop   = /usr/sbin/amavisd-new -P '' stop

  [Install]
  WantedBy = multi-user.target


Consider the following amavisd.conf settings when running as a
supervised process:

  $pid_file = '';  # can be overridden by a command line option -P ''
  $daemonize = 0;  # also implied by a command line argument 'foreground'
  $do_syslog = 0;  # or set it to 1 to log to syslog instead of stderr


---------------------------------------------------------------------------
                                                           October 25, 2014
amavisd-new-2.10.1 release notes

Contents:
  COMPATIBILITY
  BUG FIXES
  OTHER


COMPATIBILITY

There are no incompatibilities between versions 2.10.0 and 2.10.1.


BUG FIXES

- fixed a missing import of mail_addr_idn_to_ascii() and idn_to_utf8()
  when SQL is in use, resulting in:
    Undefined subroutine &Amavis::Out::SQL::Log::mail_addr_idn_to_ascii
    Undefined subroutine &Amavis::Out::SQL::Log::idn_to_utf8
  reported by Jim Knuth;


OTHER

- avoid warnings issued by perl 5.21.5:
    Negative repeat count does nothing at ./amavisd line 17218
    Missing argument in sprintf at ./amavisd line 3678

- updated documentation in 2.10.0 release notes (new macros);


---------------------------------------------------------------------------
                                                           October 22, 2014
amavisd-new-2.10.0 release notes

Contents:
  COMPATIBILITY
  BUG FIXES
  NEW FEATURES
  OTHER


COMPATIBILITY

- New requirement: perl module Net::LibIDN needs to be installed.

- Uses a perl module File::LibMagic if installed, instead of spawning
  a file(1) utility.

- Support for international email relies heavily on perl to do the
  right thing in its support of Unicode, so using a reasonably recent
  version of perl is recommended. Amavisd was tested with perl 5.18
  and 5.20.1.  Versions of perl older than 5.12 may cause problems
  with handling, encoding, and decoding of Unicode characters.
  It is reasonable to expect that versions 5.14 and 5.16 are fine too,
  but have not been tested extensively.

- Default log templates and notification templates have changed
  in details (like in decoding of international e-mail addresses), so
  if locally customized templates are in use these will benefit from
  updating - otherwise expect some mojibake in log and notifications.

- International domain names (IDN) encoded in ASCII-compatible encoding
  found in e-mail addresses and in Message-ID header field will be decoded
  to Unicode for presentation purposes (syslog, JSON structured log,
  notifications). This decoding does not affect a mail message itself.

- Logging via syslog expects that syslogd (or equivalent) will not
  clobber UTF-8 octets. It may be necessary to tell syslogd to accept
  C1 control characters unchanged, e.g. by adding a command line option
  "-8" to syslogd. Failing to do so may leave logged entries (like
  sender and recipient address, From, Subject) in international mail
  garbled or poorly readable in syslog.
  On FreeBSD one should add:  syslogd_flags="-8"  to /etc/rc.conf.

- Third party log parsers may need updating to accept logs with Unicode
  characters in UTF-8 encoding.

- A SMTP response to an EHLO command will now announce SMTPUTF8 capability
  by default.


BUG FIXES

- releasing a message from an SQL quarantine was broken in version
  2.9.1 due to introduction of parent_mail_id(); patches provided by
  Stef Simoens and Gionatan Danti;

- if checking of a message was aborted prematurely (like due to a
  timeout or some fatal error), JSON log could receive a copy of a
  previous log entry;

- prevent non-ASCII non-UTF-8 octets from reaching a JSON log/report
  (which produced an invalid JSON object and Elasticsearch complaining);

- allow SMTP commands MAIL FROM and RCPT TO to accept options without
  values, as allowed by the RFC 5321 syntax;

- in delivery status notification (DSN) the field Received-From-MTA
  specified 'smtp' as mta-name-type, instead of a 'dns' as prescribed
  in RFC 3464;

- releasing from a quarantine left envelope sender address as '<>'
  instead of using the address found in a Return-Path header field
  of a quarantined message, while also logging a warning:
    Quarantine release $QID: missing X-Envelope-From or Return-Path
  reported by Pascal Volk;

- avoid failure in os_fingerprint or in smtp forwarding in certain cases
  where the $os_fingerprint_method or $forward_method or $notify_method
  uses an asterisk in place of a host IP address or port number.
  The reported error in os_fingerprint (reported by -ben) was:
    os_fingerprint FAILED: Insecure dependency in socket
      while running with -T switch
      at /usr/lib/perl/5.18/IO/Socket.pm line 80
  and in SMTP forwarding or notification (reported by Dennis Boone):
    (!)connect to *:10025 attempt #1:
      Insecure dependency in socket while running with -T switch
      at /usr/lib/perl/5.18/IO/Socket.pm line 80.

- files LDAP.ldif and LDAP.schema: added a missing attribute
  amavisDisclaimerOptions to objectClass; reported by Quanah Gibson-Mount;


NEW FEATURES

- added support for Internationalized Email:
  * RFC 6530 - Overview and Framework for Internationalized Email
  * RFC 6531 - SMTP Extension for Internationalized Email (SMTPUTF8)
  * RFC 6532 - Internationalized Email Headers
  * RFC 6533 - Internationalized Delivery Status Notifications

  This supports UTF-8 (EAI) in SMTP/LMTP sender addresses, recipient
  addresses, and message header section. Feature parity with Postfix
  version 2.12 (support introduced in development snapshot 20140715).

  The SMTPUTF8 extension is supported by Gmail since 2014-08-05:
    http://googleblog.blogspot.com/2014/08/a-first-step-toward-more-global-email.html


- added support for Internationalized Domain Names (IDN) according
  to IDNA (RFC 5890, RFC 5891; RFC 3490);

  * A-labels in ASCII-compatible encoding of domain names are converted
    to U-labels for presentation/logging purposed;

  * U-labels are converted to A-labels when feeding a mail message
    to an MTA which does not announce support for SMTPUTF8 extension
    (instead of rejecting them as invalid mail address);

  * For lookup purposes an international domain name is converted to
    ASCII-compatible encoding when used as a query key in DNS lookups
    and in lookups into hash, list, SQL and LDAP lookup tables (but not
    in regexp table lookups). These tables are expected to contain domain
    names in their ASCII representation (ACE). For convenience of config
    files subroutines idn_to_ascii() and mail_idn_to_ascii() are available,
    which encode a Unicode domain name to ACE (like ToASCII in RFC 3490);

  * Many configuration settings may have their domain names in UTF-8.
    These will be converted to ACE automatically where necessary
    (e.g. when creating a Received and Authentication-Results header
    fields, DKIM signatures, mail addresses in notifications, ...).
    These settings include:

      $myhostname, $localhost_name, $myauthservid, $mydomain,
      notification sender and recipient mail addresses
        ($mailfrom_notify_*, $hdrfrom_notify_*, @*_admin_maps),
      domain names and selectors in DKIM signing keys (in calls
        to dkim_key() );


- delivery notifications and admin notifications now show the following
  information encoded as UTF-8 (which is a default $bdy_encoding) in the
  plain text part of the message: IDN domain names in sender and recipient
  mail addresses and Message-ID are first decoded to Unicode, Subject and
  author display names are MIME-decoded;

- 'amavisd showkeys' and 'amavisd testkeys' can now deal with IDN
  (international domain names): domain names in DNS zone comments
  end up as UTF-8, DNS labels are in ASCII (A-labels); domain names in
  calls to dkim_key() may be specified either as UTF-8 or in ASCII (ACE);

- new macro 'mail_addr_decode' takes an e-mail address as a string of
  octets, where a local part may be encoded as UTF-8, and the domain part
  may be an international domain name (IDN) consisting either of U-labels
  or A-labels or NR-LDH labels. Decodes A-labels to U-labels in domain
  name. Returns a string of logical characters (Unicode), suitable for
  notification templates. If the mail address is not a valid UTF-8 string,
  it is interpreted as ISO-8859-1 (Latin-1).

- new macro 'mail_addr_decode_octets' is like 'mail_addr_decode', except
  that the result is a string of octets, only valid as UTF-8 if the
  provided address was a valid UTF-8 (garbage-in/garbage-out);

- new macro 'header_field_octets' is like 'header_field', except that
  a result is a string of octets in UTF-8 encoding, suitable for a log
  template;

- new macro 'ip_proto_trace_all' expands into a list of information
  items from a Received header trace; each item consists of a protocol
  name (the WITH clause) and an IP address, optionally followed by a
  source port number if known;
  Example:
    ESMTP://[2001:db8::143:1]:39141 < ESMTP://2001:db8::25 <
      esmtps://203.0.113.172 < ESMTPSA://192.168.9.9
  or:
    UTF8SMTP://[203.0.113.172]:51208 < UTF8SMTPSA://192.168.9.9

- new macro 'ip_proto_trace_public' is like ip_proto_trace_all, except
  that entries with non-public IP address are excluded from the list;

  'Received' trace information in $log_verbose_templ and in notifications
  now include results from this macro call;

- new macro 'protocol' evaluates to a protocol name by which a message
  was received by amavisd, according to RFC 3848 ("Transmission Types
  Registration") and "Mail Transmission Types" / "WITH protocol types"
  IANA registration
    http://www.iana.org/assignments/mail-parameters/mail-parameters.xhtml
  e.g.: SMTP, ESMTP, ESMTPA, ESMTPS, ESMTPSA, LMTP, LMTPA, LMTPS, LMTPSA,
        UTF8SMTP, UTF8SMTPA, UTF8SMTPS, UTF8SMTPSA,
        UTF8LMTP, UTF8LMTPA, UTF8LMTPS, UTF8LMTPSA, ...

- new macro 'client_protocol' expands into a protocol name by which
  a message was received from a client by MTA; the information is passed
  from MTA to amavisd through XFORWARD PROTO SMTP protocol extension or
  through AM.PDP (milter); typical values are 'ESMTP' or 'SMTP';

- use a perl module File::LibMagic when available, instead of spawning
  a file(1) utility for classifying contents of mail parts.
  By using a direct interface to a libmagic library the startup cost
  of spawning an external process is avoided. Benchmarking shows that
  using libmagic is significantly faster especially for checking a small
  number of files - takes 4 ms for checking one file with libmagic
  vs. 27 ms with a spawned file(1); based on a patch by Markus Benning;


OTHER

- RFC 6533: recognize a MIME type 'message/global' as similar
  to 'message/rfc822', and 'message/global-headers' as similar
  to 'text/rfc822-headers' where appropriate (e.g. in bounce killer);

- header validity check now distinguishes 'non-ASCII and invalid UTF-8'
  from 'non-ASCII but valid UTF-8' characters in a mail header section.
  By default valid UTF-8 strings in a mail header section are not treated
  as error even if mail is not flagged as international mail (SMTPUTF8),
  as these are quite common in practice. To treat non- MIME-encoded UTF-8
  in a header section as error the test can be enabled by:
    $allowed_header_tests{'utf8'} = 1;

- ORCPT attribute in SMTP 'RCPT TO' command now accepts the original
  recipient mail address in any of these encodings: utf-8-address,
  utf-8-addr-unitext, utf-8-addr-xtext, or as a legacy xtext,
  as required by RFC 6533;

- updated do_cabextract (extraction of Microsoft cabinet .cab archives)
  to recognize a slightly changed output of cabextract version 1.2;
  patch by Thomas Jarosch;

- adjusted some timeouts to leave more reserve for later stages of
  mail processing and forwarding;

- prefer sanitizing/protecting control characters as hex code (like \x7F)
  instead of octal (like \177) (e.g. in logging and DSN);


---------------------------------------------------------------------------
                                                              June 27, 2014
amavisd-new-2.9.1 release notes

Contents:
  COMPATIBILITY
  BUG FIXES
  OTHER


COMPATIBILITY

There are no known incompatibilities between versions 2.9.0 and 2.9.1.


BUG FIXES

- when a $final_bad_header_destiny is set to D_BOUNCE and a mail
  message was a DSN or coming from a mailing list, spam checks were
  inappropriately skipped (logged as: "bypassing of spam checks,
  message will be blocked anyway", which was not true as the blocking
  was overruled at a later stage); reported by Bruce Pennypacker;

- perl 5.20.0 may occasionally report:
    "Malformed UTF-8 character (unexpected end of string)"
  due to a bug in perl [perl #122148].  Treat this error as non-fatal
  and only log a warning in two such cases: when SpamAssassin is called
  as a spawned subprocess ($sa_spawned=1) and is returning a result
  to a parent process, or when constructing a structured report.


OTHER

- updated decoding of RAR archives to recognize a changed format in output
  of 'unrar' utility version 5; based on a patch by amavis17(at)iotti.biz

- avoid tempfailing a message if a redis server is down, just log the
  error and carry on;

- some minor logging changes to facilitate troubleshooting;


---------------------------------------------------------------------------
                                                                May 9, 2014
amavisd-new-2.9.0 release notes

Contents:
  COMPATIBILITY
  NEW FEATURES SUMMARY
  RELAXED LICENSE
  BUG FIXES
  NEW FEATURES
  OTHER
  WHY REDIS?


COMPATIBILITY

This version drops dependency on a Perl module Redis, and makes
dependencies on modules Convert::TNEF and Convert::UUlib truly optional.

The following change may affect third-party log parsers:

To facilitate forensic log analysis and troubleshooting, log entries
'FWD from' and 'SEND from' at level 1 now carry one additional
prefixed information field which is the unique internal mail_id of
the message, possibly followed by a parent_mail_id in parenthesis,
e.g.:
  (00525-02) XE9xnQYjrWyd FWD from <...> -> <...>, ...
  (00495-02) v1pyIOMQkUYD(CIcqao-vCDO9) SEND from <...> -> <...>, ...

No other incompatibilities with a previous version 2.8.1 are expected.


NEW FEATURES SUMMARY

- structured log/reporting to a Redis server in JSON format;

- IP address reputation (uses a Redis server);

- added two minor content categories to the major ccat CC_UNCHECKED
  (encrypted (=1) and over-limits/mail-bomb (=2) );

- introduced a by-recipient setting %final_destiny_maps_by_ccat.


RELAXED LICENSE

Some utility / auxiliary programs that were previously released under a
3-clause BSD license, are now available under a more relaxed 2-clause BSD
license (also known as a "Simplified BSD License" or a "FreeBSD License").

Affected programs are: amavis-mc, amavis-services, amavisd-status,
amavisd-snmp-subagent-zmq, amavisd-release, amavisd-submit, p0f-analyzer.pl,
amavisd-nanny, amavisd-agent, amavisd-snmp-subagent, amavisd-signer,
JpegTester.pm, and TinyRedis.pm.

Note that TinyRedis.pm is provided in the package as a separate file
and includes a documentation section. Its copy is also included in
the file amavisd, so that the separate file is not needed for Amavis
operation. The separate copy is provided under a 2-clause BSD license
so that it may be useful for third parties if desired. Eventually it
could be moved to CPAN as an independent module.

A license of the main program 'amavisd' remains unchanged GPLv2.


BUG FIXES

- fixed "Insecure dependency in sprintf" in Sophos SAVI av-scanner,
  reported by Maciej Uhlig;

- fixed the interface code to virus scanners Sophie, Trophie and fpscand,
  where a time-out on a long-running virus scan would leave a connection
  to the virus scanner open and a late response from a scanner to a
  previous request could be interpreted as a result of the current scan;
  reported by David Schweikert;

- fixed a bug in transforming an IPv6 alternative form IP address into
  a preferred form. One effect of this bug was declaring an IPv4-mapped
  IPv6 address as syntactically incorrect; reported by Patrick Domack;

- if SQL logging was disabled a pen pals feature was non-functional even
  when a Redis storage back-end was available and collecting data; now
  pen pals is fully functional with a Redis database back-end and no SQL;

- provided our own Redis client code, avoiding Redis CPAN module bugs,
  its slowness and non-support for IPv6.
  The noteworthy Redis CPAN module bug is the #38 (failing to re-select
  a non-zero-index database after an automatic re-connect to a server).
  See: https://github.com/melo/perl-redis/issues/38
       https://github.com/melo/perl-redis/issues/28

- fixed a regexp in parsing wildcarded signing domain in a DKIM key
  declaration and in a wildcarded sender pattern of signing options
  (this feature is rarely used, exists for compatibility with dkim_milter);

- dropped hard-coded dependency on modules Convert::TNEF and Convert::UUlib.
  The Convert::TNEF was made optional in amavisd-new-2.8.0, but the
  program still failed if the module could not be loaded at startup.

  Both of these modules are now loaded at run time when first used, if
  specified in the @decoders setting. The use of module Convert::UUlib
  (the do_ascii entry) is disabled in a default setting of @decoders,
  and the module Convert::TNEF (the do_tnef entry) is not used
  if an external TNEF decoder (the do_tnef_ext entry) is available,
  or if disabled in the @decoders list;

- import a missing do_log_safe() in Amavis::LDAP::Connection to avoid
  a warning: _WARN: \t(in cleanup)
    Undefined subroutine &Amavis::LDAP::Connection::do_log_safe
    called at (eval 101) line 76 during global destruction;
  a patch by Quanah Gibson-Mount;

- at startup amavis may try to find a decoder for 7z and zip extensions
  twice; a fix by Quanah Gibson-Mount;

- fixed the amavisd-new-courier.patch which resulted in two instances
  of sub post_bind_hook(). Only tested for syntax. Thanks to Eray Aslan.


NEW FEATURES

- Structured logging/reporting in JSON format is now available through
  a redis server.

  Each processed mail message and each generated mail message (e.g.
  a delivery status notification) generates a structured data object
  (internally a perl associative array). Its fields carry information
  on most attributes of a mail message and its processing, similar
  to what is available for logging via macros. Unlike a plain text
  log which can be difficult to parse and inconsistent due to user
  configurability of the log template, the data object contains
  information in a structured form as key/value pairs, where each
  value can be a scalar or a list or an associative array.

  This internal data object is then serialized to a JSON format and
  sent to a redis server, where it is appended to a list under a key
  (arbitrary string) configured by $redis_logging_key setting. This
  list serves as a queue of log events, which may be pulled from the
  queue by some third party application, e.g. by a logstash utility
  or by some home-grown program. Redis server is quite handy for this
  purpose as it offers blocking requests for pulling events from a
  queue, which makes it easy to interface with an event processing
  program. The queue also allows for independent and asynchronous
  operation between amavisd child processes filling the queue, and
  a log analyzer pulling entries from the queue.

  The structured logging to redis is enabled when @storage_redis_dsn
  is configured (see below at the 'IP address reputation' section)
  and the setting $redis_logging_key is set to some nonempty and
  nonzero string, and the $redis_logging_queue_size_limit is set
  to some positive integer value (corresponding to a maximal number
  of entries allowed in a queue).

  Both the $redis_logging_key and $redis_logging_queue_size_limit are
  undefined by default, so structured logging to redis is disabled
  by default even if @storage_redis_dsn is configured.

  The string in $redis_logging_key determines the key in a redis
  database where the event queue (a redis list) will be maintained.
  Semantically it is a name of the queue. This setting is a component
  of policy banks, so log entries can be fed into different redis
  queues depending on a policy bank loaded for each mail message.

  To prevent a queue in the redis server from growing out of bounds,
  e.g. when an event-pulling program is temporarily nonfunctional or
  its processing is falling behind, the $redis_logging_queue_size_limit
  setting imposes a maximal number of events that amavisd may push into
  the queue, i.e. the maximal queue size. If the queue size limit is
  reached, new log events from amavisd are discarded as long as the
  queue size is at the limit. As a redis database is kept in memory, it
  makes sense to choose the value of $redis_logging_queue_size_limit low
  enough so that it does not use too much memory if the log processing
  program goes down, but also high enough so that short outages of
  the log processing program do not lose any log events. The setting
  $redis_logging_queue_size_limit is global (not a component of policy
  banks).

  And example setting:

    @storage_redis_dsn = ( { server => '[::1]:6379', db_id => 1 } );

    $redis_logging_queue_size_limit = 300000;
      # takes about 250 MB of redis memory per 100000 log entries

    $redis_logging_key = 'amavis-log';

    $policy_bank{'MYNETS'} = {
      originating => 1,
      redis_logging_key => 'amavis-log-myusers',  # overrides global setting
    }

  The oldest event may be pulled from listed queues by the redis command:
    BLPOP amavis-log amavis-log-myusers 0

  so from a command line this may look like:
    $ redis-cli -h ::1 -p 6379 -n 1
    BLPOP amavis-log 0

  The BLPOP redis command blocks if the queue is empty and only returns
  when the queue becomes nonempty, which makes it easy to use. For high
  event rates it may be more efficient to batch one LLEN and multiple
  BLPOP calls in a Lua script executed on a redis server and return events
  in chunks.

  An example of a logstash plugin configuration for pulling amavis log
  events from a redis server and feeding them to Elasticsearch:

  input {
    redis {
      type => "amavis"
      host => "::1"
      db => 1
      data_type => "list"
      key => "amavis-log"
      codec => json {}
    }
  }
  filter {
    date { match => [ "time_unix", "UNIX" ] }
  }
  output {
  # stdout { codec => rubydebug }
    elasticsearch_http {
      host => "127.0.0.1"
      port => 9200
      index_type  => "%{type}"
      document_id => "%{mail_id}"
      codec => json {}
    }
  }

  As an alternative for sending log events to a redis server, it is
  possible to use a macro [:report_json] in a log template, which will
  expand to a full JSON representation of a log event. As these strings
  are fairly long (typically 2 kB to 3 kB), this is not a good solution
  when logging to syslog. It may be usable when logging to a file, but
  is not an efficient solution and has not been tested in production.

  Here is a (fake) example of a structured log report entry in JSON
  format, fields are loosely ordered by their semantics in this example.
  Not all fields are always present. When a boolean fields is missing
  it should be interpreted as a false.

  {
    "@timestamp" => "2014-05-06T09:29:47.048Z",
    "time_unix" => 1399368587.048,
    "time_iso_week_date" => "2014-W19-2",
    "partition" => "19",

    "type" => "amavis",
    "host" => "mailer.example.net",
    "src_ip" => "::1",
    "dst_ip" => "::1",
    "dst_port" => 10024,

    "log_id" => "82329-04",
    "mail_id" => "Jnk7NzYB8pvl",
    "mail_id_related" => ["men7HTERZaOF"],

    "client_port" => 41831,
    "client_ip" => "2001:db8::143:1",
    "ip_trace" => ["2001:db8::143:1", "192.0.2.242"],
    "os_fp" => "Windows XP; dist: 6; raw_mtu: 1340; ...",

    "originating" => true,
    "policy_banks" => ["PROXY-ORIGINATING", "MYNETS"],

    "size" => 302694,
    "digest_body" => "a4a7db6307c140b12f57feaf076663f8",

    "mail_from" => "mailing-list-1@example.com",
    "rcpt_to" => ["recip2@example.org", "recip1@example.net"],
    "rcpt_num" => 2,

    "message_id" => "<003701cf690d$b671b3f0$23551bd0@example.com>",
    "author"  => ["sending-user@example.com"],
    "to_addr" => ["recip1@example.net"],
    "cc_addr" => ["recip2@example.org"],
    "subject"       => "Fw: An example 123 - test",
    "subject_rot13" => "Sj: Na rknzcyr 123 - grfg",
    "user_agent" => "Microsoft Office Outlook 12.0",
    "is_bulk"  => true,
    "is_mlist" => true,

    "action" => ["PASS"],
    "actions_performed" => "RelayedInternal RelayedOutbound",
    "checks_performed" => "V S H B F P",
    "content_type" => "Clean",
    "dkim_new_sig" => ["example.com"],
    "dsn_sent" => false,
    "elapsed" => { "Receiving"  => 0.009,
                   "Decoding"   => 0.053,
                   "VirusCheck" => 0.326
                   "SpamCheck"  => 2.116,
                   "Sending"    => 0.118,
                   "Amavis"     => 0.215,
                   "Total"      => 2.672,
                 },
    "message" =>
      "82329-04 PASS Clean <mailing-list-1@example.com>
         -> <recip2@example.org>,<recip1@example.net>",
    "queued_as" => ["3gNFyR4Mfjzc3", "3gNFyR4n6Lzc4"],
    "recipients" => [
      { "action" => "PASS",
        "ccat_main" => "Clean",
        "queued_as" => "3gNFyR4Mfjzc3",
        "rcpt_is_local" => false,
        "rcpt_to" => "recip2@example.org",
        "smtp_code" => "250",
        "smtp_response" => "250 2.0.0 from MTA(smtp:[::1]:10013): 250 2.0.0 Ok: queued as 3gNFyR4Mfjzc3",
        "spam_score" => -2.0
      },
      { "action" => "PASS",
        "ccat_main" => "Clean",
        "mail_id_related" => "men7HTERZaOF",
        "penpals_age" => 1114599,
        "queued_as" => "3gNFyR4n6Lzc4",
        "rcpt_is_local" => true,
        "rcpt_to" => "recip1@example.net",
        "smtp_code" => "250",
        "smtp_response" => "250 2.0.0 from MTA(smtp:[::1]:10013): 250 2.0.0 Ok: queued as 3gNFyR4n6Lzc4",
        "spam_score" => -5.272
      }
    ],
    "smtp_code"  => ["250"],
    "spam_score" => -2.0,
    "tests"      => ["ALL_TRUSTED", "AM.PENPAL", "BAYES_00",
                     "MSGID_MULTIPLE_AT", "RP_MATCHES_RCVD"],
    "tests_ham"  => ["AM.PENPAL","BAYES_00","ALL_TRUSTED","RP_MATCHES_RCVD"],
    "tests_spam" => ["MSGID_MULTIPLE_AT"],
  }


- IP address reputation

  When a Redis storage back-end is enabled, besides the existing pen pals
  functionality, it now also offers information updating and retrieval
  on IP address reputation. This function is enabled by default when
  @storage_redis_dsn is nonempty, but can be disabled by setting
  $enable_ip_repu to false (to 0 or undef), per policy bank if necessary.

  For each mail message a list of public IP addresses (IPv4 or IPv6) is
  collected from its 'Received' trace header fields in a mail header
  section. A redis server maintains a database of each IP address
  encountered. For each IP address an entry carries a set of counters
  corresponding to the number of mail messages encountered in the past
  having this IP address in a trace header. These counters show: a number
  of spam messages, a number of ham messages, a number of banned or
  infected messages, and a total number of messages. Also a timestamp of
  the first and last encounter is kept. Each entry (a set of counters)
  is subject to automatic expiry, so that infrequently encountered IP
  addresses are eventually automatically purged from a database by a
  redis server itself.

  As a sending IP address may change its role (e.g. some machine was
  infected (sending spam) but now has been cleaned, or a NAT-ted address
  is reassigned to someone else), currently a crude way of data aging is
  implemented by discarding entries older than three days since created.
  This may be refined in the future.

  When a new mail message is being processed, a lookup on all its public
  IP addresses from a trace is done. For each IP address found in a
  database a spam score is computed based on a ratio of ham versus
  all messages, and based on a total number of messages. The largest
  calculated spam score of all encountered IP addresses is then
  contributed to a total spam score of a message.

  A formula for computing spam score of each IP address is currently
  hard-coded, is non-linear and takes into account the total number of
  encounters of an IP address, diluted by the ratio of ham messages
  versus all messages seen with this IP address. The computed score
  cannot be negative, i.e. the IP reputation can only contribute to
  spamminess of a message and cannot serve as a 'whitelisting' negative
  score. For the exact formula in use see query_and_update_ip_reputation()
  in file amavisd.

  A time-to-live of each IP entry is assigned dynamically: frequently
  encountered IP addresses are given longer expiration times (days),
  infrequent IP addresses are short-lived and eventually expire,
  typically in few hours.

  It is possible to exclude certain IP addresses or networks from
  contributing spam score by listing them in an @ip_repu_ignore_networks
  list, e.g.:

    @ip_repu_ignore_networks =
      qw( 192.0.2.44 192.0.2.45 198.51.100.0/24 2001:db8::1:25 );

  This does not preclude a redis lookup on an IP addresses matching
  the list, but just takes a zero as its score and does not update
  counters on such address. The mechanism is appropriate for excluding
  site's own mailers (MSA and MX), or local (e.g. departmental) mailers,
  which may on occasion emit a spammy message, but should never receive
  a score penalty. There is no need to include private IP address networks
  in the list, as these are already exempt from IP reputation database.

  An associated list of lookup tables @ip_repu_ignore_maps (whose only
  default entry is the \@ip_repu_ignore_networks) offers more flexibility
  if needed, and is a member of policy banks.

  Like other self-learning mechanisms (e.g. SpamAssassin's auto-learn,
  AWL, TxRep), the quality of a result depends on a quality of other
  spam-gauging rules - the better spam/ham classification works
  (SpamAssassin), the more useful IP reputation becomes. For the purpose
  of IP reputation's spam and ham counts, a mail is considered spam if
  its score is at or above 5, and is considered ham when its final score
  is below 0.5. This is currently hard-coded (see sub save_info_final).
  Intermediate scores are considered unclassified.

  A nice feature of the mechanism is that it reacts fairly quickly
  to a new rush-in of unwanted messages from some IP address, either
  foreign, or local.

  For insight on the IP address reputation behaviour, search the log
  for ' redis: IP '. At log level 2 only spammy hits are logged, at
  log level 3 also the clean hits are shown. The log entry shows
  spam, ham, banned+infected and unclassified counts for an IP address,
  a percentage of unwanted (spam+banned+infected) messages out of the
  total count, and the associated score.

  Apart from starting a redis server on a loopback interface (except for
  changing its 'bind' setting in redis.conf, no other configuration changes
  are necessary, a database need not be initialized), here is an example
  configuration in amavisd.conf:

  @storage_redis_dsn = (
    { server => '[::1]:6379',     db_id => 1 },
    { server => '127.0.0.1:6379', db_id => 1 },
  );

  # list your MX and MSA mailer IP addresses or networks here:
  @ip_repu_ignore_networks = qw( 192.0.2.44 2001:db8::/64 );

  A redis server needs to support Lua scripting, which is available
  since version 2.6. Support for IPv6 is available since version 2.8.0
  of the redis server.


- Added support for decompressing LZ4 streams in mail attachments when
  an external utility lz4c is available and the 'file' utility recognizes
  such streams (probably since version file-5.17).  Default settings
  of @decoders and $map_full_type_to_short_type_re now recognize LZ4;
  if these settings are replaced by a configuration file, the config
  file needs to be updated to include the new entry.


- Added two minor content categories to the major ccat CC_UNCHECKED
  to allow distinguishing between reasons of decoders failure.
  * a minor ccat 1 now indicates that at least one mail part was
    encrypted or otherwise scrambled (e.g. password protected archive);
  * a minor ccat 2 now indicates that some of the limits for protection
    against mail bombs was exceeded (e.g. $MAXLEVELS, $MAXFILES,
    $MAX_EXPANSION_QUOTA, $MAX_EXPANSION_FACTOR).
  Based on a suggestion and a patch by Carsten Wolff.

  The additional information can be used in any of the *_maps_by_ccat
  settings, e.g.:
    $subject_tag_maps_by_ccat{CC_UNCHECKED.',1'} =
      [ '***UNCHECKED(Encrypted)*** ' ];
    $subject_tag_maps_by_ccat{CC_UNCHECKED.',2'} =
      [ '***UNCHECKED(OverLimit)*** ' ];
  or:
    $defang_by_ccat{CC_UNCHECKED.',2'} = 1;


- introduced a setting %final_destiny_maps_by_ccat, which makes it
  possible to specify by-recipient final destiny for each contents
  category, e.g. use D_REJECT on spam to some users, and D_BOUNCE or
  D_DISCARD or D_PASS for others. Introduced mostly for completeness.

  As a backward compatibility measure the existing %final_destiny_by_ccat
  is now an alias for the new %final_destiny_maps_by_ccat;


- added a setting $outbound_disclaimers_only. When set to true and
  disclaimers are enabled, it will only allow adding disclaimers
  to non-local recipients. For backward compatibility the default
  value is false (undef). Based on a patch by Quanah Gibson-Mount;


- the $recipient_delimiter setting can now hold a multi-character string,
  specifying all characters that can delimit an address extension from
  a base e-mail address. Previously this setting was restricted to a
  single character (typically a '+' or a '-').

  When parsing existing e-mail address any of the characters in
  $recipient_delimiter can delimit an address extension. When adding an
  address extension (through %addr_extension_maps_by_ccat), the first
  character in the $recipient_delimiter string is used as a delimiter.

  The change is now in line with a postfix 2.11 that added support
  for multi recipient-delimiters, and a similar feature in Dovecot.

  A patch contributed by Patrick Domack.


- added macros report_json and rot13 (to be used in a log template):

  * the macro 'report_json' expands to a JSON representation of a
    structured log event;

  * the macro 'rot13' replaces a string in its argument with an obfuscated
    string where letters are shifted by 13 positions of an English
    alphabet (a popular variant of a Caesar cipher to conceal spoilers);
    this may serve to (poorly) hide strings such as mail Subject or
    an e-mail address from casual browsing of a log;


OTHER

- dropped dependency on a CPAN module Redis, implementing our own
  client-side redis protocol implementation (Amavis::TinyRedis).
  It is faster and smaller, and supports opening sessions with a
  redis server over IPv6 (or over IPv4 or over a Unix socket).
  The redis server supports IPv6 starting with version 2.8.0.

  Currently supported options in @storage_redis_dsn are:
  server, db_id, password, and ttl.

  The 'server' specifies an INET or INET6 socket (a host IP address
  or name and a port number) or an absolute path to a Unix socket.
  An IPv6 address must be enclosed in square brackets. The default
  value is '127.0.0.1:6379'. Match this with your redis configuration.

  Option 'db_id' specifies a redis database index (given to a "SELECT"
  redis command). Its value is a (small) integer, defaults to 0.
  This allows for independent databases to co-exist on the same redis
  server, e.g. an amavis database and a SpamAssassin Bayes database.

  The 'ttl' option can override a global setting $storage_redis_ttl
  on a per-server basis. Its value is an integer, representing a number
  of seconds for expiration time of pen pals records. It defaults to
  $storage_redis_ttl, which in turn defaults to 16 days (in seconds).
  This setting does not affect IP reputation records, whose expiration
  time is computed dynamically.

  Example:
    $storage_redis_ttl = 22*24*3600;  # 22 days for pen pals records
    @storage_redis_dsn = (  # alternative servers, use the first which works
      { server => '[::1]:6379',      db_id => 1 },
      { server => '127.0.0.1:6379',  db_id => 1, password => 'abc...' },
      { server => '/tmp/redis.sock', db_id => 1, ttl => 8*24*3600 },
    );

  Btw, make sure to keep the setting $database_sessions_persistent
  at its default value (1, i.e. enabled), otherwise Redis performance
  will suffer somewhat.


- store only essential information for pen pals operation to a Redis
  storage back-end to save memory on a database server; information on
  inbound messages is no longer stored there, i.e. only information on
  originating messages is kept;

- more informative logging of pen pals query results when using a Redis
  storage back-end. The redis support code (Lua and protocol handling)
  was largely rewritten for efficiency since amavisd-new 2.8.1.

- added LDAP attribute amavisDisclaimerOptions 1.3.6.1.4.1.15312.2.2.1.47
  to LDAP.schema;  contributed by Quanah Gibson-Mount;

- reduced EDNS payload size from 1240 bytes to a conservative default
  of 1220 bytes when calling Mail::DKIM verifier;

- optimization: filter for public IP addresses from a Received trace
  only once;

- added one digit of precision in the TIMING log report to reported small
  elapsed times (below 5 ms);

- in a milter setup (AM.PDP) the log-id wasn't unique; adding a request
  sequence number to it; a patch by Andreas Schulze;

- avoid writing a notification to stdout about a warm reload for the benefit
  of a cron job; a patch by Andreas Schulze;

- reduced log level on some of the less useful log messages in a milter
  setup; a patch by Andreas Schulze;

- documentation README.sql-mysql: added "CREATE INDEX msgs_idx_mail_id..."
  with a note on an InnoDB requirement for a foreign key;  by Jernej Porenta;


WHY REDIS?

A redis database was chosen initially because SpamAssassin 3.4.0 supports
keeping its Bayes database in a redis server, which makes it very fast,
so this makes a redis database readily available to amavisd too.

Redis has some features that make it suitable for use as a pen pals
database, for Bayes storage, and now for IP reputation and structured
logging:

- automatic expiration of entries based on key's individual time-to-live
  setting makes explicit database maintenance unnecessary;

- accessible over INET (or Unix sockets) allows several amavisd hosts
  to use a common redis server, possibly running on a dedicated host;

- supports Lua scripting, which makes it possible to perform multiple
  basic operations in one go as a single application's functional
  operation. It reduces multiple network round-trip times to a single
  network transaction, reducing network packet rate and latency;

- compared to SQL storage for pen pals (and for Bayes database),
  the redis read speed is somewhat faster, and the write speed is
  MUCH faster;

- as an in-memory database with optional periodic disk persistence
  it makes it suitable for use as a pen pals, as IP reputation and
  as Bayes storage: it is fast, and a potential redis server restart
  reloads data from the last snapshot, thus only losing the last
  minute or two of updates when trouble strikes, which is acceptable
  for these three databases.

- makes it possible to eliminate SQL r/w storage if its only purpose
  was to provide pen pals functionality (and SpamAssassin's Bayes);

Caveat:

Redis server does not offer access controls or strong authentication
mechanisms. For running a server on the same host as amavisd is running
the solution is straightforward: just bind the redis server to a
loopback interface or use a Unix socket. If a network access is desired,
consider protecting the redis server by a firewall (host-local, or
on a dedicated subnet).


---------------------------------------------------------------------------
                                                              June 28, 2013
amavisd-new-2.8.1 release notes

COMPATIBILITY

- when 0MQ (a.k.a. ZeroMQ) is used between Amavis components as an
  internal messaging protocol, make sure to replace all 0MQ-enabled
  Amavis components on upgrading amavisd, as the internal protocol
  has changed slightly, taking advantage of 0MQ multi-part messages
  for better performance. Affected programs are: amavis-services,
  amavisd-status, amavisd-snmp-subagent-zmq, and amavisd.

  NOTE: The Crossroads I/O project (libxs) ceased development on
    July 2012, to be replaced by nanomsg eventually by the same author.

    The 0MQ library (libzmq) is currently (2013) the best choice,
    the preferred library version is 3.2.2 or later along with
    the ZMQ::LibZMQ3 Perl interface module and ZMQ::Constants.
    The older version 2 of the library, along with an older perl
    module ZeroMQ, should be fine too, but lacks support for IPv6.

- amavisd is compatible with perl 5.18.0 and with SpamAssassin 3.4.0


BUG FIXES

- fixed a bug in the SMTP client code, where the final SMTP status did
  not reflect a failure status of a DATA command from a back-end MTA.
  This caused a reception of a mail message to be confirmed but a message
  was then lost, as it could not be passed to a back-end MTA. The bug
  went unnoticed for years, as the commonly used MTAs normally reject
  either at the MAIL FROM, at RCPT TO, or at the data-dot stage, but not
  at the DATA command. Reported by Deniska-rediska;

- fixed calling an external spam scanner DSPAM or Bogofilter, which
  failed with a message:
    auto-learning with spam scanner ... failed: error running program
  Reported by Tonio;

- if a configuration file path as given through a command line option -c
  or as an argument to include_config_files() was not an absolute path,
  and that file contained an error, the do() would search the @INC list
  for alternative files of the same name, and reported an unrelated error
  (typically: No such file or directory) instead of reporting the true
  reason for a failure;

- fixed a regular expression in amavisd.conf for an 'Avast!' AV entry
  to properly extract a virus name; a patch by Ralf Hildebrandt;

- added LDAP errors LOCAL_ERROR and OPERATIONS_ERROR to the set of
  expected error conditions which lets amavisd retry the failed
  operation; a patch by Quanah Gibson-Mount;


NEW FEATURES SUMMARY

- new Redis storage for the "pen pals" feature;

- improved IPv6 support;

- support for p0f v3;

- new macros ip_trace_all and ip_trace_public;

- amavisd-status now shows a bar graph display
  of the number of active processes;

- the timing report log entry can show CPU usage
  at log level 2 if a module Unix::Getrusage is available;


NEW FEATURES

- new Redis storage for the "pen pals" feature: instead of (or in addition
  to) the existing SQL storage for keeping data on past mail messages
  and contributing negative spam score to recent/ongoing correspondence,
  this data can now be kept on a Redis server. Unlike the SQL backend,
  to minimize memory usage the Redis backend keeps only data which are
  required for pen pals operation.

  Redis storage for pen pals can offer a small speedup compared to a
  well-tuned SQL server, offers automatic expiration of data based on a
  configured time-to-live setting, and a simpler setup (no need to manually
  set up an SQL schema). A drawback is that a Redis server keeps all data
  in memory (with optional periodic persistence on disk), which might be
  of concern for busy sites with a long time-to-live setting. Potential
  drawbacks of a Redis server are also its lack of sophisticated access
  controls.

  A redis database may be shared between hosts running amavisd. It can
  be accessed either locally over a Unix socket, or using an INET socket
  (IPv4) over a loopback interface (better security) or over a local
  network. Version 2.6.14 of a Redis server does not offer access over
  IPv6, but version 2.8.0 and later does.

  Required dependencies when Redis support is enabled are a perl module
  "Redis" ( http://search.cpan.org/dist/Redis/ ) version 1.954 (or 1.956)
  or later and a redis server ( http://redis.io/ ) with support for Lua
  scripting (i.e. version 2.6 or later). Most pen pals application-level
  details on queries and storage management is delegated to Lua scripts
  running on a Redis server. Redis module currently requires a patch to
  support communication with a redis server over IPv6.

  Expiration time of items stored in a redis database is controlled by
  a setting $storage_redis_ttl, which is a time-to-live time in seconds
  and defaults to 16 days:
    $storage_redis_ttl = 16*24*60*60;

  Redis support in amavisd is enabled by setting a list @storage_redis_dsn
  to a nonempty value (similar to @storage_sql_dsn for an SQL support).
  If @storage_redis_dsn is empty, the redis support code is not loaded
  and does not occupy any storage.

  The configuration setting @storage_redis_dsn is a list of hashrefs
  (a hashref is a { ... } in perl syntax), each of which specifies
  one Redis server that can be used: if there is more than one entry
  in the list, a connection to each server is attempted until one is
  found where connection succeeds. Each entry is an associative array
  of key/value options which are passed on to a new() method of a perl
  Redis module unmodified and unverified. Usual options are: 'server',
  'sock', 'reconnect' - see documentation of a Redis module for details.
  All Redis module options have their default value, so it is alright
  to specify an empty hash, which means to connect to a default server.

  Apart from options which are passed to a Redis module, two additional
  options are interpreted by amavisd itself and are not passed on to a
  Redis perl module. The 'db_id' options is an optional database index,
  used in a SELECT redis command to choose a (sub)database to use.
  By default a database index is 0. The 'ttl' option overrides a global
  time-to-live setting as specified in $storage_redis_ttl, allowing to
  chose different expiration times of stored items for each server.

  Examples:

  # disables Redis (is a default)
  @storage_redis_dsn = ();

  # enables Redis, use a single default local redis server, all
  # defaults are supplied by a Redis perl module, database index 0
  @storage_redis_dsn = ( {} );

  # access a local redis server over a loopback interface on TCP port
  # 6379, select database index 1, try reconnecting for 20 seconds
  # before giving up when a redis server is down (or restarting)
  @storage_redis_dsn =
    ( { server => 'localhost:6379', reconnect => 20, db_id => 1 } );

  $storage_redis_ttl = 16*24*60*60;  # expiration time for data 16 days
  @storage_redis_dsn = (
    { sock => '/tmp/redis.sock',  reconnect => 20, db_id => 1 },
    { server => 'localhost:6379', reconnect => 20, db_id => 1 },
    { server => 'backup.example.com:6379', db_id => 1, ttl => 5*24*60*60 },
  );

  Some existing settings also affect Redis pen pals operation:
    $database_sessions_persistent, $penpals_bonus_score,
    $penpals_halflife, $penpals_threshold_low, $penpals_threshold_high.

  Starting with version 3.4.0 the module SpamAssassin can also use Redis
  storage for its global Bayes database. Amavisd and SpamAssassin can use
  the same Redis server for their databases, although it is sensible that
  they use separate (sub)databases by choosing a different database index
  (redis SELECT command) through a 'db_id' configuration option, which
  defaults to 0.

  NOTE: As more experience with Redis is gained, it is possible that
  a redis storage schema may change in future versions, possibly in an
  incompatible way. As its purpose is short-term storage, this should
  not be of great concern.


- improved IPv6 support: p0f-analyzer.pl can now communicate with amavisd
  processes over an INET6 socket (or over an INET or UNIX socket as before).
  Extended the protocol between amavisd and p0f-analyzer.pl to allow
  queries on IPv6 addresses;

- rewritten p0f-analyzer.pl to support a newer p0f v3 output format,
  while still recognizing an older p0f v2 output format;
  suggested by Jernej Porenta;

  NOTE: the p0f v3 does not provide a compact output on stdout like p0f v2
  could by using an option -l, so leave out the option -l with p0f v3;

- improved IPv6 support: program amavisd-snmp-subagent-zmq can now
  attach as an AgentX to a Net-SNMP daemon snmpd over an INET6 socket;
  the AgentX socket is specified by $agentx_sock_specs near the beginning
  of a file amavisd-snmp-subagent-zmq, e.g.:
    $agentx_sock_specs = 'tcp6:localhost:705';  # talk to snmpd over IPv6
    $agentx_sock_specs = 'tcp:localhost:705';   # talk to snmpd over IPv4
    $agentx_sock_specs = '/var/agentx/master';  # talk over a UNIX socket

- improved IPv6 support: program amavisd-submit can now submit a mail
  message to amavisd over an INET6 socket;

- a macro W can now produce a list of all virus scanners invoked,
  along with a list of virus names each scanner detected;
  suggested by Patrick Ben Koetter;

- new macros ip_trace_all and ip_trace_public:

  ip_trace_all  provides a list of IP addresses found in the 'Received from'
     trace of a mail header, one entry for each Received header field,
     including possibly invalid IP addresses and private IP addresses;
     Missing addresses are substituted by with a '?' (e.g. in Received
     header fields for local or other non-IP mail submissions).
     The list order corresponds to the order of 'Received' header fields
     as found in a mail header, top-down, i.e. first entry of the list
     is the topmost (the most recent) 'Received' header field, so
     chronologically in reverse;

  ip_trace_public  provides a list of valid public IP addresses found in the
     'Received from' trace of a mail header.  Missing, invalid or private
     IP addresses are not included in this list, so there may be more
     'Received' header fields in a mail header then entries in this list.
     The list order corresponds to the order of 'Received' header fields
     as found in a mail header, top-down, i.e. first entry of the list
     is the topmost (the most recent) 'Received' header field with a valid
     public IP address, so chronologically in reverse;

  suggested by Tomislav Mihaliček;

- templates for administrator notifications, recipient notifications,
  and sender notifications now use macro 'ip_trace_all' instead of macros
  'e' and 't' in order to report the full 'received' trace, not just the
  first hop;

- macro supplementary_info recognizes new arguments: VERSION, SUBVERSION,
  and RULESVERSION, providing additional information from SpamAssassin
  correspond to equivalent SpamAssassin tags;

- a new command line option -X allows controlling some exotic features,
  useful for example in debugging or automatic testing. The option takes
  one argument which is a comma-separated list of keywords. Currently
  the only recognized option is '-X no_conf_file_writable_check',
  which disables security checks on configuration files, which can be
  useful in automatic testing, but is dangerous to use in production.
  Suggested by Alexander Wirt;

- a configuration setting $sa_debug may now specify a comma-separated
  list of SpamAssassin debug facilities, complementing a similar method
  of specifying these facilities through a command line option -d.
  If $sa_debug looks like a simple boolean (or is undefined), the
  traditional semantics still applies: a false prepends an 'info'
  to the list, while a true prepends 'info' and 'all' to the list
  of SpamAssassin debug facilities.

  Examples:
   $sa_debug = 0;  # same as:  $sa_debug = 'info';
   $sa_debug = 1;  # same as:  $sa_debug = 'info,all';
   $sa_debug = 'info,dns,async,bayes';

- pass the size of an original mail body as a 'supplementary attribute'
  to SpamAssassin for the benefit of a 'check_body_length' eval rule
  (new with SpamAssassin 3.4.0). The original mail body size may
  differ from the message as seen by SpamAssassin in case of truncation
  of large messages to mail_body_size_limit.

- to the output of amavisd-status add a simple bar graph display (with
  an exponential-decay peak indicator) of the number of active processes;

- if a module Unix::Getrusage is available, the timing report log entry
  (at log level 2) is enhanced: in addition to total elapsed time
  (wall clock) spent in processing a message, it also shows a sum of
  CPU user and system times spent by amavisd process and its spawned
  processes:

  old format example:
    size: 3815, TIMING [total 1901 ms] - ...

  new format example:
    size: 3815, TIMING [total 1901 ms, cpu 657 ms] - ...

  Additionally, a separate RUSAGE log entry is produced at log level 2,
  indicating resource usage spent by the last task. A field maxrss is
  a gauge (an absolute current value), all other fields are counters,
  so a difference between a previous and a current value is shown in
  the log. Each field value is a pair of numbers delimited by a plus:
  the first value corresponds to resource usage by the reporting amavisd
  child process, the second value corresponds to its spawned processes
  (e.g. file(1), gzip(1), etc.).

  Example (wrapped for clarity):

    size: 3815, RUSAGE minflt=10114+5223, majflt=0+0,
      nswap=0+0, inblock=0+0, oublock=9+0,
      msgsnd=819+9, msgrcv=211+3, nsignals=0+0,
      nvcsw=128+19, nivcsw=32+41, maxrss=164304+194012,
      ixrss=520+14016, idrss=66300+128392, isrss=24960+7680,
      utime=0.390+0.079, stime=0.079+0.108

  See getrusage(2) Unix man page for details.


OTHER

- the 'amavisd genrsa' command will now warn if the requested DKIM
  signing key size is below 1024 bits, as required by RFC 6376;

- on amavisd startup a check on available private DKIM signing keys
  (as declared by dkim_key) will now warn if a key size is below
  1024 bits as required by RFC 6376, and log an information message
  if a key size is below a configured $dkim_minimum_key_bits size
  (defaults to 1024, currently 768 would still be a sensible value);

- for purposes of DKIM-based whitelisting (@author_to_policy_bank_maps)
  and @signer_reputation_maps spam scores, valid signatures with
  public keys shorter than $dkim_minimum_key_bits bits (default 1024,
  equivalent to a lower limit as presently used by Google) are now
  ignored, with an informational message logged at level 1.
  To disable this check, set $dkim_minimum_key_bits to undef or to 0.

- consider Unique local addresses (ULA) fc00::/7 non-public (RFC 4193),
  dropped site-local addresses fec0::/10 (deprecated by RFC 3879),
  adjusting the default setting of @mynetworks accordingly;

- consider the "Shared Address Space" 100.64.0.0/10 non-public (RFC 6598);

- adjust parsing the <zone_id> syntax of a scoped IPv6 address
  as per RFC 6874;

- updated an AV entry for a Sophos Anti Virus: the scanning program
  used to be named 'sweep', now it is 'savscan'; thanks to mefiX;

- updated a default value of @virus_name_to_spam_score_maps: updated
  entry for Doppelstern and added entries for Bofhland and PORCUPINE;

- increase an arbitrary sanity limit on %smtp_reason_by_ccat strings
  from 100 to 450 characters (RFC 5321 allows 512 character reply lines);

- relax testing file type of a configuration file, now a configuration
  may also be passed to amavisd through a named pipe (fifo), possibly
  facilitating testing or unusual deployments;

- relax a requirement that a $QUARANTINEDIR directory needs to be
  writable: if $*_quarantine_method template settings include a
  subdirectory (e.g.: $spam_quarantine_method='local:W%P/spam/%m.gz'),
  such subdirectories must already exist and should be writable,
  but the top-level $QUARANTINEDIR directory need not be writable;

- convert an IPv4-mapped IPv6 address into a plain IPv4 dot-quad form
  when found in Received header fields, in socket local or peer address,
  in ADDR field of an XFORWARD smtp extension command, or in an AM.PDP
  attribute client_address. See draft-cmetz-v6ops-v4mapped-api-harmful
  and draft-itojun-v6ops-v4mapped-harmful for potential caveats;

- drop a support for direct queries to p0f v2, as it never worked well
  due to bugs in p0f v2. The p0f v3 changed the query protocol, but
  a query does not include port numbers (see RFC 6302), so using the
  p0f-analyzer.pl interface is still the only reliable approach;

- use sysread() instead of read() when reading from /dev/urandom
  to avoid leaving entropy data in I/O buffers; also changed interface
  name to sub read_random_bytes(), which now reads directly into a
  scalar buffer, provided by an argument;

- fix uniform random distribution when generating a random PIN for an
  attachment password (when releasing and $release_format is 'attach')
  (not a security issue);

- added keepalive options to a call to Net::LDAP->new, recognized since
  Net::LDAP 0.53; a patch by Quanah Gibson-Mount;

- removed option inet6 from a default LDAP setup ( $ldap_sys_default ),
  as Net::LDAP changed semantics in an incompatible way;
  presumably the Net::LDAP now does the right thing by default;
  suggested by Quanah Gibson-Mount;

- use a low-level 0MQ interface instead of ZeroMQ / ZMQ abstractions;
  (i.e. ZeroMQ raw interface or ZMQ::LibZMQ3 or ZMQ::LibZMQ2);

- taking advantage of 0MQ multi-part messages the number of IP packets
  transmitted is now radically decreased in favour of sending larger
  but fewer packets;

- when generating 'Abuse Reporting Format (ARF) Reports' add a field
  Source-IP and use UTC timestamps in the Arrival-Date field, in accordance
  with RFC 6692;

- drop (opportunistic) loading of a module Devel::SawAmpersand and testing
  the Devel::SawAmpersand::sawampersand(), variables $&, $` and $' are
  no longer slow since Perl 5.17.7, the PL_sawampersand became a constant,
  there is no longer any need of report it;

- documentation update: remove vestiges of a field 'spam_modifies_subj'
  in README.sql, README.sql-mysql, this field was obsoleted in 2.7.0;
  thanks to Patrick Ben Koetter;


---------------------------------------------------------------------------
                                                              June 30, 2012
amavisd-new-2.8.0 release notes

Contents:
  COMPATIBILITY
  BUG FIXES
  NEW FEATURES SUMMARY
  NEW FEATURES - 0MQ
  NEW FEATURES - OTHER
  OTHER


COMPATIBILITY

- removed an old compatibility measure: default value of @banned_admin_maps
  was changed from:
    @banned_admin_maps = (\$banned_admin, \%virus_admin, \$virus_admin);
  to a more consistent:
    @banned_admin_maps = (\$banned_admin);
  The previous default value of @banned_admin_maps tried to maintain
  compatibility with versions before the setting was separated from
  its companion @virus_admin_maps. Now this compatibility is no longer
  considered necessary and contributes to some confusion, so it was dropped.
  See 2.4.0 and 2.2.1 release notes for previous changes to this setting.

- quarantining to an mbox format file used to include a local time in an
  mbox separator line, which differs from RFC 4155 and common practices
  of using an UTC timestamp; a time zone of a timestamp in separator lines
  is now changed to UTC;


BUG FIXES

- fixed initial evaluation of dynamic (i.e. per policy bank) values of
  $enable_dkim_verification, $enable_dkim_signing and $bypass_decode_parts
  across all declared policy banks; these policy bank entries may be scalars
  of references to such;

- finely adjust a message size for de-stuffed dots according to a size
  definition in RFC 1870; avoids occasional message size mismatch when
  using an antispam interface module SpamdClient (implementing client-side
  of a spamc/spamd protocol);

- updated LDAP.ldif to match LDAP.schema; provided by Quanah Gibson-Mount;

- updated AMAVIS-MIB.txt and amavisd-snmp-subagent: changed type of
  SNMP variables *MsgsSize* in the group amavisStats 7 from Counter32
  to Counter64 for consistency with other *MsgsSize* variables in groups
  amavisStats 3 and amavisStats 9;

See also the bug fixes section of 2.7.1 and 2.7.2 release notes.
All fixes applied to 2.7.1 and 2.7.2 are incorporated in the 2.8.0 code.


NEW FEATURES SUMMARY

- For monitoring and statistics gathering purposes a new set of utilities
  and service processes is available based on a message passing paradigm,
  using a 0MQ (a.k.a. ZMQ, ZeroMQ, or Crossroads I/O) library. This
  replaces a functionally similar set of utilities based on a shared
  BerkeleyDB database, with a benefit of avoiding lock contention
  altogether. This can bring sigificant speedups, most pronounced on
  a host with many busy amavisd child processes.

- Applied numerous fine-grained optimizations based on a NYTProf profiler
  results. Optimizations include a reduction in a number of generated
  Perl opcodes and similar micro-optimizations. This accounts for a large
  amount of small changes in the code.

- Our current statistics (Q4 2011) shows that 80 % of messages are below
  30.000 bytes, and 90 % of mail messages are below 100.000 bytes in
  size. As an optimization, messages below 100 KiB in size are now kept
  and processed in memory, including passing them more optimally to
  SpamAssassin 3.4.0. Some file activity is still there, but is much
  reduced. If $TEMPBASE also resides on an SSD disk (or a RAM disk),
  observed speedup between 2.7.2 and 2.8.0 was 3 to 8 percent on a
  busy host (with monitoring disabled, so as not to skew a measurement).

- Use a module IO::Socket::IP if available, instead of dealing directly
  with low-level modules IO::Socket::INET and IO::Socket::INET6.
  The IO::Socket::IP is a Perl core module since Perl version 5.19.8;

- choose more appropriate defaults if running on an IPv6-only host
  (like connecting to ::1 instead of 127.0.0.1 which may not exist);

- amavisd-release now also supports connecting to amavisd over IPv6;

- as a debugging aid it is now possible that a late event triggers full
  logging of earlier events that occurred during processing of a current
  mail message;

- $enable_ldap setting is now dynamic, i.e. can be changed by a policy
  bank, which makes it possible to selectively disable LDAP lookups
  per policy bank;

- optionally avoid persistent connections to SQL and LDAP servers;

- it is now possible to disable calling an external file(1) utility
  but still have MIME parts decoding enabled;

- added support in Amavis::SpamControl::ExtProg for an external spam scanner
  Bogofilter;

- added locking options to @spam_scanners entries, to be used with external
  scanners which need but do not implement locking of their resources
  by themselves;

- added a global configuration setting $sa_userprefs_file, which is passed
  on to SpamAssassin as a 'userprefs_filename' parameter at initialization;

- added a subroutine iso8601_weekday(), potentially useful with partitioning;

- added several new macros available to logging and notification templates;


NEW FEATURES - 0MQ

- added support for monitoring and auxilliary services, communicating
  with amavisd and among themselves through 0MQ sockets (also called ZMQ
  or ZeroMQ, or Crossroads I/O or XS). This method offers similar features
  as current services amavisd-nanny, amavisd-agent and amavisd-snmp-subagent,
  but use message passing paradigm instead of communicating through a shared
  Berkeley database. This avoids locking contention, so the gain can be
  significant for a busy amavisd setup with lots of child processes.

  New files in the package are:

  - amavis-mc  is a master supervisor process ( master of ceremonies :),
      to be started at boot time as root, or as a user vscan/amavis.
      Currently its only function is to spawn three instances of
      amavis-services processes with dropped privileges, to monitor
      and restart them in case they fail, and to terminate them when
      itself if being terminated. Preferably this process should be
      started before amavisd and before amavisd-snmp-subagent-zmq,
      although things would eventually catch up even if this is not
      the case. This process must run on the same host as amavis-service
      processes.

  - amavis-mc_init.sh  is an example FreeBSD-style startup/shutdown shell
      script for starting/stopping the amavis-mc process;

  - amavis-service  implements three services, chosen by a command line
      argument. It should be running as user vscan/amavis (not as root!).
      All its instances are typically started/stopped automatically by
      the amavis-mc process with dropped privileges. A note for manual
      testing (started from a command line, not by an amavis-mc process):
      make sure to run amavis-service under the same UID as the amavisd is
      running. If 0MQ cannot write to a socket due to privilege violation,
      messages are silently dropped. Service processes as implemented
      by amavis-service must run on the same host as amavisd for two
      reasons: they communicate with amavisd child processes through a
      Unix socket, and at least some of these services need visibility
      of amavisd processes through signals (kill). At least the forwarding
      service must be running when amavisd is operational with $enable_zmq
      at true, otherwise amavisd child processes might eventually stall when
      their message queue fills up. Preferably amavis-service processes
      should be started before amavisd is started, although things would
      eventually catch up even if started late or restarted during operation.

  - amavisd-status  is a user utility program, similar to amavisd-nanny,
      which connects to amavis-service 0MQ socket and displays a status
      of running amavisd child processes. This program communicates with
      amavis-service processes through an inet socket and can in principle
      run on a different host (in which case sockets must be bound to a
      publicly reachable interface, not loopback). The program can be
      started and stopped at any time, can run under any UID as long as
      it has access to a 0MQ socket $outer_sock_specs, and may run in
      multiple instances if necessary.

  - amavisd-snmp-subagent-zmq  is a SNMP AgentX program, functionally
      equivalent to amavisd-snmp-subagent. It collects information from
      amavis-service processes and passes it as a MIB to an SNMP daemon.
      This process communicates with amavis-service processes through an
      inet socket and can in principle run on a different host (in which
      case sockets must be bound to a publicly reachable interface, not
      loopback). If access to the amavisMta MIB (1.3.6.1.4.1.15312.2.1.3)
      subtree is desired, the amavisd-snmp-subagent-zmq must run on
      the same host as Postfix in order to have access to its queue
      directories. In principle there could be more than one instance of
      the amavisd-snmp-subagent-zmq running at the same time, although
      this hardly serves any practical purpose.

  The old amavisd-agent utility does not currently have a 0MQ equivalent;
  use snmpbulkwalk with net-snmp and amavisd-snmp-subagent-zmq for similar
  functionality.

  Please see comments in amavis-service for details and configuration
  of sockets.

  To enable amavisd child processes to start sending their status and
  statistics information to amavis-service services, please set a
  configuration variable $enable_zmq to true in amavisd.conf:
    $enable_zmq = 1;

  Optionally a 0MQ socket can be changed, it defaults to:
    @zmq_sockets = ( "ipc://$MYHOME/amavisd-zmq.sock" );
  The @zmq_sockets is a list of 0MQ sockets, so in principle amavisd
  processes can report their state to multiple instances of amavis-service.

  Both the 0MQ-based ($enable_zmq=1) and the BerkeleyDB-based ($enable_db=1)
  monitoring implementations can coexist: use one or the other, or both
  at the same time, or turn off both if monitoring is not needed.

  Required Perl modules are either:
    ZeroMQ, which interfaces with a version 2 of a libzmq library
      (in case of FreeBSD that would be ports net/p5-ZeroMQ and devel/zmq),
      or with a Crossroads I/O library libxs (now defunct);
  or
    ZMQ::LibZMQ2 and ZMQ::Constants modules
      with a version 2 of a libzmq library (or with a Crossroads I/O library);
  or
    ZMQ::LibZMQ3 and ZMQ::Constants
       with a version 3 of a libzmq library (FreeBSD ports: devel/zmq-devel).
       Although Crossroads I/O library is natively equivalent to a libzmq
       version 3 library, the ZMQ::LibZMQ3 perl module does not currently
       support interfacing with Crossroads I/O (libxs).

  NOTE: The Crossroads I/O project ceased developmenet in July 2012,
    to be replaced by nanomsg eventually (by the same author).
    The 0MQ is currenty (2012/2013) the best choice.

  Tested combinations of a Perl interface module with a message passing
  library:

  * with 0MQ ( http://www.zeromq.org/ ):
    ZeroMQ 0.21       + zeromq 2.2.0
    ZMQ::LibZMQ2 1.01 + zeromq 2.2.0
    ZMQ::LibZMQ3 1.00 + zeromq 3.1.0

  * with Crossroads I/O ( http://www.crossroads.io/ ):
    ZeroMQ 0.21       + libxs 1.2.0 (zmq v2.1 compatible)
    ZMQ::LibZMQ2 1.01 + libxs 1.2.0 (zmq v2.1 compatible)
    ZMQ::LibZMQ3 1.00 + libxs 1.2.0 (native) (no, XS not supported by LibZMQ3)


  PERFORMANCE with 0MQ

  When scanning messages for spam (using SpamAssassin), a spam scan
  takes most of the processing time and resources, so replacing a
  BerkeleyDB-based monitoring with a 0MQ-based monitoring brings some
  speedup on a busy server, but the change is not dramatic.

  But as an extreme counter-example: when DKIM signing passed messages,
  with most other checks disabled, a speedup can be by a factor of 10.
  Synthetic benchmark: 7 KiB messages, 8 child processes, log level 2,
  CPU Intel Core i7-960 (4 cores, 8 threads), $TEMPBASE on an SSD disk,
  result: 19 mail messages per second with BerkeleyDB, over 200 mail
  messages per second with 0MQ, and still 130 msg/s with all checks
  (*except* spam scanning) enabled.


  SECURITY CONSIDERATIONS with 0MQ

  0MQ libraries (zeromq or libxs) do not provide any application-level
  security beyond what is available with standard Unix or INET or INET6
  sockets. This means that Unix-style inter-process sockets are protected
  by the usual file system's ownership and protection bits, and access
  to INET/INET6 sockets is only protected by interface binding and system
  firewall mechanisms.

  Communication between amavisd child processes and the forwarding service
  (amavis-services msg-forwarder) goes by default over a Unix-style socket,
  owned by UID vscan/amavis. Communication between utilities and service
  processes goes by default over an INET socket bound to a loopback
  interface, and as such is accessible to any process running on the
  same host, but is not accessible from other hosts. If access to these
  sockets from other hosts is desired, their binding should be changed
  to all or to ethernet interfaces, making them accessible to any host
  in the network, so host-firewall rules should be implemented if access
  needs to be restricted.

  Having said that, currently information passing through 0MQ sockets
  is limited to statistics and health status only, and does not affect
  operation of amavisd child processes, nor is any sensitive information
  passed around, so access to these sockets from unauthorized sources
  is not expected to pose a high security risk.


  0MQ and IPv6

  IPv6 is supported by zeromq library starting with version 3, and by
  libxs (any version). Because the application needs to pass information
  to a library about a type of sockets needed and there is no universal
  and backward compatible (with v2) way to do so, currently amavisd does
  not offer any configuration option to choose INET6 over INET on 0MQ
  sockets. This restriction is expected to be lifted in the next version.
  Currently on an IPv6-only host one can choose to use Unix-style sockets,
  or patch amavis programs to turn off a ZMQ_IPV4ONLY socket option
  (these are commented-out in present code).


NEW FEATURES - OTHER

- if a module IO::Socket::IP is available, amavisd will use this module
  to create its client-side inet or inet6 sockets, instead of using the
  low-level modules IO::Socket::INET and IO::Socket::INET6. This delegates
  some of the dirty details handling to IO::Socket::IP, such as using the
  getaddrinfo(3) system service to resolve host names, and dealing with
  dual-stack multihomed host names. If IO::Socket::IP is not available,
  the IO::Socket::INET or IO::Socket::INET6 are used directly instead,
  to preserve compatibility. Please use a fairly recent version of
  IO::Socket::IP, testing was done with versions 0.08 and 0.16.

- added a subroutine read_cidr() which can read a Postfix style CIDR file,
  with a syntax interpreted according a Postfix cidr_table(5) man page.
  The subroutine returns a ref to an array by default (but can also
  produce a hash, and is able to add data to an existing array or hash).

  Typical use:
    @mynetworks_maps = ( read_cidr('/etc/postfix/mynetworks.cidr') );
    @client_ipaddr_policy = map(($_,'MYNETS'), @mynetworks_maps);

  or:
    @mynetworks = @{ read_cidr('/etc/postfix/mynetworks.cidr') };

  For details and more complex usage see leading comments in the read_cidr
  subroutine;

- as a debugging aid it is now possible that a late event triggers full
  logging of earlier events that occurred during processing of a current
  mail message. This is implemented by writing all log events to a temporary
  file regardless of their log level and of the current $log_level setting.
  A later event can cause the captured temporary log to be copied to a
  regular log. Each child process keeps its own temporary log file open
  all the time, the file is rewound and truncated after each mail message
  processing and reused for the next capture, so its size rarely exceeds
  about 50 kB.

  Maintaining a temporary capture log is enabled by setting a configuration
  variable $enable_log_capture to true:
    $enable_log_capture = 1;

  Enabling a log capture costs a little bit of resources as amavisd needs
  to assemble and format all log messages regardless of their log level, not
  benefiting from early pruning of log entries not reaching the $log_level.
  Nevertheless the small overhead is quite acceptable when troubleshooting
  some rarely occurring problem and keeping $log_level permanently at the
  max is not acceptable due to sheer volume of debug logging.

  The captured log is read from a temporary file and copied to a regular
  log as log level 1 entries (i.e. at LOG_INFO syslog priority) if a
  dynamic variable $enable_log_capture_dump is true by the end of mail
  message processing. A chunk of captured log entries is preceded/ended
  by a log line:
    CAPTURED DEBUG LOG DUMP BEGINS
    CAPTURED DEBUG LOG DUMP ENDS
  and each such log entry has a prepended timestamp (hours, minutes,
  seconds with milliseconds) of a capture time.

  The $enable_log_capture_dump variable can be turned on directly
  by some debugging patch code, but is more conveniently loaded by
  activating a policy bank, e.g.:

  $policy_bank{'SLOW'} = {
    enable_log_capture_dump => 1,
  };

  $policy_bank{'GOTCHA'} = {
    enable_log_capture_dump => 1,
  };

  which can be loaded for example by a custom hook, e.g.:

  sub after_send {
    my($self,$conn,$msginfo) = @_;
    if (Time::HiRes::time - $msginfo->rx_time > 5.5) {
      Amavis::load_policy_bank('SLOW', $msginfo);
    }
    # or perhaps:
    if ($msginfo->sender =~ /some-regexp/) {
      Amavis::load_policy_bank('GOTCHA', $msginfo);
    }
  }

  Btw, the only purpose of having two different policy banks in the example
  is to be able to see at a glance in the log which one was activated.

- the @decoders list is made a bit more flexible: the first entry in
  each tuple (a short type name) may be a scalar string as before,
  or may be a reference to a list of such names, in which case the
  tuple applies to all listed short types.

  Example:
    [['zip','kmz'], \&Amavis::Unpackers::do_unzip],

  which previously needed two entries:
    ['zip', \&Amavis::Unpackers::do_unzip],
    ['kmz', \&Amavis::Unpackers::do_unzip],

- support an external decompressor lrzip for a .lrz format.
  Thanks to Jernej Porenta for a suggestion;

- $enable_ldap setting is now dynamic, i.e. can be changed by a policy
  bank, which makes it possible to selectively disable LDAP lookups
  per policy bank. The LDAP code is loaded and a connection to an LDAP
  server is established if at least one policy bank has enable_ldap set
  to true (e.g. enable_ldap => 1 ) or a global $enable_ldap is true,
  but queries are disabled if currently active enable_ldap is false.
  Suggested by Tomislav Mihaliček;

  Example:

    $enable_ldap = 1;
    $policy_bank{'GUESTS'} = {
      enable_ldap => 0,
    };

  or the other way around:

    $enable_ldap = 0;
    $policy_bank{'INBOUND'} = {
      enable_ldap => 1,
    };

- optionally avoid persistent connections to SQL and LDAP servers - at
  the expense of about 3 to 7 ms elapsed time for a reconnect. Persistent
  connections from mostly idling child processes consume database server
  resources (e.g. a TCP socket), and may become stuck when some intermediate
  stateful device like a firewall or a NAT decides to drop stale sessions.

  The behaviour is controlled by a setting $database_sessions_persistent:
  when true sessions remain open even after a SMTP session (from an MTA) has
  closed; when false sessions are closed after each SMTP session closedown.
  The default value is true for compatibility with earlier versions.
  Problem reported by Jernej Porenta;

- it is now possible to disable calling an external file(1) utility
  but still have MIME parts decoding enabled:  $file = undef;
  This may save some contents classification time, at the expense of
  losing results of a file(1) utility (i.e. short file type information)
  for banning checks. Disabling file(1) checks can be useful when most
  other checks are disabled too, e.g. in an amavisd instance whose only
  task is DKIM-signing, like after a mailing list manager fanout;

- added Amavis::SpamControl::ExtProg support for an external spam scanner
  Bogofilter. An entry in @spam_scanners list for invoking the bogofilter
  program can be something like:

  @spam_scanners = (
    ['Bogofilter', 'Amavis::SpamControl::ExtProg', 'bogofilter',
      [ qw(-e -v)],  # -u
      mail_body_size_limit => 65000, score_factor => 1.0,
    ],
  # ['SpamAssassin', 'Amavis::SpamControl::SpamAssassin' ],
  );

  The bogofilter interface code assigns a hard-coded score +5 to
  bogofilter's result status 'Spam', -5 to 'Ham' and 0 to 'Unsure'.
  This score is multiplied by score_factor (default 1 if not given)
  to produce the final spam score which is summed up with scores
  as contributed by other spam scanners in the @spam_scanners list.
  The 'X-Bogosity' header field will be inserted into forwarded message,
  unless prevented by a corresponding %allowed_added_header_fields entry.

  Based on a patch contributed by Stephen Davies.

- added Amavis::SpamControl::ExtProg support for auto-learning on external
  spam scanners; experimental: works, but may change in future versions;
  *** to be documented ***; Suggested by Jernej Porenta;

- added locking options to @spam_scanners entries, to be used with
  external scanners which do not implement database locking by themselves.
  Options are: 'lock_file', 'lock_type', 'classifier_lock_type' and
  'learner_lock_type'. The 'lock_file' specifies a file name on which
  a flock(2) is acquired. A lock type can be 'shared', 'exclusive',
  or 'none'. The 'shared' acquires a LOCK_SH (shared read) lock,
  the 'exclusive' acquires a LOCK_EX (exclusive write) lock on a given
  file. A default lock type is 'exclusive' if the lock_type option is
  missing. If either a lock_file is absent or empty, or a lock type is
  'none', then no locking is performed.

  Option 'classifier_lock_type' can override a generic 'lock_type'
  option when a scanner is requested to classify a message. Similarly,
  a 'learner_lock_type' option can override a generic 'lock_type' when
  a scanner is invoked for auto-learning.

  Example:

  ['CRM114', 'Amavis::SpamControl::ExtProg', 'crm',
    [ qw(-u /var/amavis/home/.crm114 mailreaver.crm
         --dontstore --report_only --stats_only
         --good_threshold=8 --spam_threshold=-8) ],
    learn_ham  => [ qw(-u /var/amavis/home/.crm114 mailreaver.crm --good) ],
    learn_spam => [ qw(-u /var/amavis/home/.crm114 mailreaver.crm --spam) ],
    mail_body_size_limit => 65000, score_factor => -0.20,
    lock_file => '/var/amavis/crm114.lock',
    lock_type => 'shared', learner_lock_type => 'exclusive',
  ],

- added a global configuration setting $sa_userprefs_file (undef by
  default), which is passed on to SpamAssassin as a 'userprefs_filename'
  parameter during its initialization. If 'userprefs_filename' parameter
  is nonempty, SpamAssassin tries to load a file with that name as
  user preferences configuration file (overriding systemwide settings),
  otherwise it tries to load a file '~/.spamassassin/user_prefs'
  if it exists. Suggested by Quanah Gibson-Mount;

- added a subroutine iso8601_weekday() which takes a Unix time as an
  argument (seconds since 1970-01-01T00:00Z), and returns a weekday number
  based on local time: a number from 1 through 7, beginning with Monday and
  ending with Sunday, as specified in ISO 8601 (EN 28601).

  May be useful as a partition_tag for short-term cycling of a logging
  database storage (e.g. used by a pen-pals feature):
    $partition_tag =
      sub { my($msginfo)=@_; iso8601_weekday($msginfo->rx_time) };

- added a macro 'weekday', which expands to a weekday number
  of the current message reception time, as provided by a call
  to iso8601_weekday($msginfo->rx_time);

- added a macro 'secret_id', which expands to a secret counterpart to
  mail_id, such that: b64_encode(md5(b64_decode(secret_id))) == mail_id.
  It is encoded in base64url (RFC 4648), e.g. laL-rCJ6MBTm
  (with a counterpart mail_id: XlZbJeFhn4OE). Typically used to authorize
  releasing from a quarantine. Suggested by Antoine Nguyen;

- added a macro 'mail_id' as a synonym to a macro 'i', which is a
  long-term unique mail_id on this system, possibly used in log and in
  quarantine names, encoded in base64url (RFC 4648), e.g. XlZbJeFhn4OE
  (with a counterpart secret_id: laL-rCJ6MBTm);

- added a macro 'log_id' as a synonym to a macro 'n', which is an
  internal log id (also called task id, am_id) as shown in the log
  and by amavisd-nanny, e.g. 58725-05-2;

- added a macro 'hexenc', which encodes its string arguments as
  hex digits, high nybble first;

- added macros 'b64enc' and 'b64urlenc', which encode their arguments
  as base64 strings, removing the final null padding '=' characters.
  The 'b64enc' encodes into a character set [A-Za-z0-9+/], while the
  'b64urlenc' encodes into a character set [A-Za-z0-9-_] in accordance
  with RFC 4648;

- added a macro 'body_digest', which expands to a digest (a hash) of a
  body of a mail message as computed by the algorithm chosen by a setting
  $mail_digest_algorithm (defaults to 'MD5', can be 'SHA-1' or 'SHA-256').
  These are raw (non-encoded) bytes, not suitable for direct display.
  It is common to encode it with one of the macros: 'hexenc', 'b64enc',
  or 'b64urlenc', and possibly truncate it by a macro 'substr', e.g.:
    [:substr|[:b64urlenc|[:body_digest]]|0|9]

  The result of:
    [:hexenc|[:body_digest]]
  is the same as the result of a legacy macro call %b.

- added a configuration setting $mail_digest_algorithm which chooses an
  algorithm name for generating a mail header digest and a mail body digest.
  If set to 'MD5' (case-insensitive) a module Digest::MD5 will be used,
  producing a MD5 digest (128 bits, 32 hex digits, 22 base64 characters).
  This is the fastest algorithm and is a default. Any other value is
  passed on to a module Digest::SHA as an argument to its method new().
  The module Digest::SHA can produce digests of a SHA family: 160..512 bits,
  and accepts an algorithm name like 'SHA-1' or 'SHA-256' (see its
  documentation for details). The SHA-1 digest size is 160 bits / 40 hex /
  27 base64 chars, while the SHA-256 size is 256 bits / 64 hex / 43 base64
  characters.

  The generated digest may end up as part of a quarantine file name
  (%b in templates), or via macro 'b' or 'body_digest' in notification
  templates or a main log entry.


OTHER

- quarantining to a mbox format file was using mboxo rule for protecting
  a "From " line in a mail body, which made an original ">From " line
  indistinguishable from a protected From; now a mboxrd format rule is
  used, see http://en.wikipedia.org/wiki/Mbox

- make MIME::Parser use $TEMPBASE as a temporary directory for scratch
  files instead of its default (which was /tmp, or failing over to a
  current directory, disregarding a TMPDIR environment variable).
  This can bring performance improvements if $TEMPBASE resides on
  an SSD or RAM disk and /tmp resides on a HDD;

- distinguish an absence of an SMTP response from a negative SMTP response
  in an SMTP/LMTP client code for improved logging/debugging purposes;
  report delay time in case of a failure;

- a default value for $inet_socket_bind now reflects the availability
  of socket protocol families INET (IPv4) and INET6 (IPv6):
  - if version of Net::Server is below 2.0:    '127.0.0.1'
  - if both inet & inet6 are available:      [ '127.0.0.1', '[::1]' ]
  - if only inet is available:                 '127.0.0.1'
  - if only inet6 available (IPv6-only host):  '[::1]'
  Previously a default was always a '127.0.0.1'.

- $forward_method, $notify_method and $requeue_method now default to an IPv6
  address of a loopback interface ::1 instead of 127.0.0.1 when INET6 support
  is available and INET is unavailable (IPv6-only host);

- remove an existing Authentication-Results header field only if we are
  capable of generating our own: keep it if $enable_dkim_verification
  is false or if $allowed_added_header_fields{'authentication-results'}
  is false;

- add a field "Source-Port:" to "Abuse report format" (ARF) messages
  as per draft-kucherawy-marf-source-ports;

- Avira SAVAPI av scanner: only log a warning instead of aborting
  when a QUIT command at the end of a session fails;

- load all (both) applicable policy banks when %interface_policy contain
  both a "SOCK" entry and a Unix socket path name; and similarly when it
  contains both the "IPaddress:port" and a "port" entries. Previously
  the "SOCK" policy bank was not loaded when a socket path name entry
  existed in %interface_policy, and similarly a port-only -based policy
  bank was not loaded when a more specific "IPaddress:port" entry existed;

- make use of a new SpamAssassin 3.4.0 option "skip_prng_reseeding"
  (description in the SpamAssassin Bug 6690);

- no longer pre-load a module Mail::SpamAssassin::Plugin::SpamCop
  to avoid unnecessarily dragging-in modules Net::SMTP and Net::Cmd;

- a spamd client code in Amavis::SpamControl::SpamdClient now obeys an
  option 'mail_body_size_limit' in a @spam_scanners entry and truncates
  a message passed to spamd (like other spam scanner interfaces do),
  instead of skipping a call to spamd. This interface module is mainly
  intended for testing spamd, or used with third-party software which
  uses the same spamc/spamd protocol.

- modules Convert::TNEF is now made optional, instead of being required;
  do not load it if @decoders list is empty;

- avoid a warning issued when encountering an empty ehlo-keyword in a
  response to an EHLO command (like on testing with a smtp-sink utility);

- some fine-grained reduction in a number of generated opcodes and
  similar tiny optimizations; this accounts for numerous small changes
  in the code;

- avoid some warnings issued by Test::Perl::Critic;

- just in case: make sure that our SMTP responses at the incoming session
  are truly flushed to the socket and not stuck in a perlio I/O buffer;

- updated 2.7.0 release notes, documenting that a policy bank may also be
  loaded based on a path name of a Unix socket receiving a connection;

- updated and clarified schema and instructions in README.sql-pg
  based on suggested changes by Tim Howe;

- fixed spelling mistakes in comments;

- internal incompatible change: changed arguments and a result of a
  subroutine write_header; also, now it rewinds a message file by itself;


---------------------------------------------------------------------------
                                                            August xx, 2012
amavisd-new-2.7.3 release notes

BUG FIXES

- fixed a bug in the SMTP client code, where the final SMTP status did
  not reflect a failure status of a DATA command from a back-end MTA.
  This caused a reception of a mail message to be confirmed but a message
  was then lost, as it could not be passed to a back-end MTA. The bug
  went unnoticed for years, as the commonly used MTA normally reject
  either at the MAIL FROM, RCPT TO or at the data-dot stage, but not
  at the DATA command. Reported by Deniska-rediska;

- if a configuration file path as given through a command line option -c
  or as an argument to include_config_files() was not an absolute path,
  and that file contained an error, the do() would search the @INC list
  for alternative files of the same name, and report an unrelated error
  (typically: No such file or directory) instead of reporting the true
  reason for a failure;

- fixed a regular expression in amavisd.conf for an 'Avast!' AV entry
  to properly extract a virus name; a patch by Ralf Hildebrandt;

OTHER

- updated an AV entry for a Sophos Anti Virus: the scanning program
  used to be named 'sweep', now it is 'savscan'; thanks to mefiX;

- documentation update: remove vestiges of a field 'spam_modifies_subj'
  in README.sql, README.sql-mysql, this field was obsoleted in 2.7.0;
  thanks to Patrick Ben Koetter;


---------------------------------------------------------------------------
                                                              June 30, 2012
amavisd-new-2.7.2 release notes

BUG FIXES

- a generated Received header field was missing the 'IPv6:' prefix
  in the TCP-info component of a 'by' subfield (as required by RFC 5321,
  section 4.1.3) when amavisd received a message over an IPv6 protocol;
  (btw, the TCP-info component of a 'from' subfield was correct);

- changed data type of an SNMP variable LogRetries from C32 to C64
  for consistency with the MIB;

- updated AV entry 'AVG Anti-Virus' to consider status 403 continuation
  lines when searching for a virus name; suggested by Ralf Hildebrandt;


OTHER

- reduce a log level to 5 on a log message:
    Amavis::IO::RW: Error flushing on close: ...
  to avoid an innocent but sinister-looking warning when a pipe
  to a virus scanner is broken and needs to be re-established;
  reported by Stefan Jakobs;

- updated an AV entry for 'F-Secure Linux Security' to version 9.14;
  options updated by Mika Ilmaranta, a patch by Tuomo Soini;

- fix a Unix socket compatibility issue with Net::Server versions 2.000,
  2.001 and 2.002, where a method NS_unix_path no longer exists.
  This method was re-introduced for compatibility reasons in 2.003.
  Reported by Paul MacKenzie;


---------------------------------------------------------------------------
                                                             April 29, 2012
amavisd-new-2.7.1 release notes

BUG FIXES

- prevent rmdir() from failing with 'Invalid argument' on Solaris 10 when
  deleting a temporary directory: current working directory must not be
  within a directory which is about to be deleted; reported and diagnosed
  by Maciej Uhlig;

- forwarding or quarantining through a 'pipe:' method failed with
  "Insecure dependency in exec while running with -T switch" when a
  sendmail command-line option -N was needed; reported by Andreas Schulze;

- when multiple sockets are specified (e.g. in $forward_method) as a
  redundancy/failover mechanism, and SMTP session caching is enabled,
  a failed forwarding session does not clear a cached session, so all
  further attempts are stuck with the failed server, instead of picking
  a different server from the list; discovered by Michael Storz;

- on establishing a SMTP session when multiple sockets are specified
  (e.g. in $forward_method) as a redundancy/failover mechanism, the
  random choice never picked the last socket in a list;
  discovered by Michael Storz;

- fix defanging by mimedefang, it was failing with perl 5.10 or later
  due to an unhandled "Insecure dependency in sprintf" while logging the
  result if the $log_level was 2 or higher, or when debugging was enabled;
  thanks to Steve Scotter for a problem report;

- fix defanging by Anomy::Sanitizer, it was failing with an error message:
  "mangling by anomy failed: replacement size 0, mail will pass unmodified";

- fix the 'xz' entry in a default @decoders list (in files amavisd.conf,
  amavisd.conf-default and amavisd); the first two variants ('xzdec' and
  'xz') were glued together, so the xz decoder was only available if found
  under names 'unxz' or 'xzcat';

- provide a workaround for a bug [rt.cpan.org #64642] [rt.cpan.org #84879]
  in a perl module Encode, which gratuitously untaints a string when encoding
  or decoding it:
    https://rt.cpan.org/Public/Bug/Display.html?id=64642
    https://rt.cpan.org/Ticket/Display.html?id=84879
     (fixed in Encode 2.50);
  A module Scalar::Util is now required, which should not be a compatibility
  problem, as this module is a Perl core module since perl 5.8.0.

- avoid the use of Encode::is_utf8 due to a bug in a perl module Encode
  as bundled with versions of Perl 5.8.0 to 5.8.8 (fixed in March 2007):

  Perl bug tracking: #32687:
    Encode::is_utf8 on tainted UTF8 string returns false
    https://rt.perl.org/rt3/Public/Bug/Display.html?id=32687
  also referenced by #37170:
    https://rt.perl.org/rt3/Public/Bug/Display.html?id=37170

  This is a re-manifestation of the same problem we had back in 2004,
  with a workaround provided by amavisd-new-2.2.1.  Forgot that people
  are still using Perl 5.8 :)  Reported by Peter Dieth;

- fix a warning: _WARN: Invalid conversion in sprintf: "%a"

- write informational messages during a stop/start/restart to stdout,
  instead of to stderr, avoiding unnecessary cron job messages;
  thanks to Cristian Seres, Sandro Janke and John Griffiths;
  also: https://bugzilla.redhat.com/show_bug.cgi?id=561389

- fix a syntactically incorrect 'Avira SAVAPI' av entry (missing
  closing bracket) in a sample configuration file amavisd.conf;

- minor: get_body_digest incorrectly logged 8-bit body as 8-bit header;

- no longer insist on a minimal version 2.22 of a module Digest::MD5,
  the 'clone' method is no longer needed since amavisd-new-2.7.0;

- do not call $parser->max_parts($MAXFILES) with some old versions
  of MIME::Parser which did not yet provide this method;

- pre-load a module File::Glob even with perl 5.8.0, otherwise
  autowhitelisting in SpamAssasssin may fail with "Insecure dependency";

- documentation: (files README.sql-mysql and README.sql-pg):
  fixed a field name "policy.unchecked_lover", previously incorrectly
  specified as "policy.unchecked_lovers_maps"; reported by TimH;

- documentation: fixed the two SELECT examples in files README.sql-pg and
  README.sql-mysql, the field 'select' needs to be qualified with a table
  name: 'msgrcpt.content' to avoid ambiguity;  reported by Gary V;

- documentation bug in amavisd.conf-default: 'ESMTP' is not a valid
  setting for $protocol, just use 'SMTP' instead; reported by Pascal Volk;


COMPATIBILITY

- commented out the LHA entry in the default @decoders list and in
  do_executable(). The program seems to be unmaintained, was seen crashing
  and as such it may pose a security risk; pointed out by Thomas Jarosch;

- due to popular demand, bring the 'spam-tag:' log line back to log level 2
  (version 2.7.0 dropped it to log level 3) to retain compatibility with
  some log analyzers. Caveat: 'spam-tag' string is now entirely in lowercase.
  Suggested by Stefan Jakobs;


OTHER

- if a message is quarantined to more than one location using different
  quarantine methods, the SQL field msgs.quar_type indicates only the
  type of the last one. When archival quarantining is enabled this choice
  is unfortunate, as the primary quarantine type is more interesting
  than the permanent archival quarantine type. This is now reversed,
  the msgs.quar_type field now reflects the first quarantine type.
  Suggested by Patrick Ben Koetter.

- SMTP session caching now no longer re-uses old sessions which are
  in use for more than a minute since their establishment; suggested
  by Michael Storz;

- having the archive quarantine enabled should not be a sufficient reason
  to store information to SQL when $sql_store_info_for_all_msgs is off;
  Suggested by Patrick Ben Koetter.

- ClamAV-clamd and ClamAV-clamd-stream av scanners: changed socket name
  in a sample configuration file amavisd.conf to /var/run/clamav/clamd.sock
  (previously the socket name was /var/run/clamav/clamd); this makes it
  compatible with a default socket name under several Linux distributions
  and under FreeBSD; suggested by Oliver Schinagl;

- documentation updates;


---------------------------------------------------------------------------
                                                               July 1, 2011
amavisd-new-2.7.0 release notes

Contents:
  NEW FEATURES SUMMARY
  GENERAL
  COMPATIBILITY WITH 2.6.4 / 2.6.5 / 2.6.6
  BUG FIXES SINCE 2.6.6
  BUG FIXES SINCE 2.6.5
  BUG FIXES SINCE 2.6.4
  NEW FEATURES
  OPTIMIZATIONS
  OTHER
  CLEANING


NEW FEATURES SUMMARY

- significant improvements affecting a pre-queue content filtering setup
  (time limiting, warm/flying restart, ...) - requires Postfix 2.7.0 and
  SpamAssassin 3.3.0, or later;

- new daemon amavisd-signer makes it possible to sign mail with DKIM
  signatures without requiring amavisd process to have access to private
  signing keys;

- added support for the Sophos-SSSP, Avira SAVAPI and ClamAV clamd streaming
  protocols allows amavisd to communicate with these antivirus solutions;

- allow specifying multiple (fail-over) back-end mailers for resubmission
  of messages from amavisd back to MTA;

- support for Postfix 2.8.0 XFORWARD IDENT, passes a local message identifier
  (queue id) downstream to a post-queue content filter and back to Postfix;

- speedup in data transfer rate on receiving large mail via SMTP/LMTP
  sessions by a factor of 3.9 for plain text sessions, and by a factor
  of 11 for encrypted (TLS) sessions;

- recognize and insert header fields as prepared by SpamAssassin 3.3.0
  or later through its 'add_header' configuration option;

- a new setting allows a forward_method to be chosen based on a message
  content type and/or recipient address; this may be useful for outgoing
  mail routing purposes or to implement sender reputation schemes;

- per-recipient (or per- policy bank) SpamAssassin configuration files or
  SQL configuration sets are supported (@sa_userconf_maps), and per-recipient
  SQL Bayes database usernames (@sa_username_maps);

- new macros: client_helo, client_addr, client_port, client_addr_port,
  mime2utf8, rusage, ADDEDHEADERHAM, ADDEDHEADERSPAM, banned_parts_as_attr,
  actions_performed, new arguments to macros dkim, header_field, HEADER,
  YESNO and YESNOCAPS;

- @listen_sockets setting offers a unified configuration of listening
  sockets; it may be configured directly, or the traditional way: the
  $inet_socket_port, $unix_socketname and $inet_socket_bind just add
  their entries to the @listen_sockets list;

- lists of lookup tables (the @*_maps variables) can now contain
  explicit SQL and LDAP lookup objects as their elements, instead of
  (or in addition to) the implied SQL and LDAP lookups;

- a new configuration variable @virus_name_to_policy_bank_maps allows
  loading of policy banks based on a virus name;

- a new configuration variable $mail_id_size_bits allows setting the size
  of randomly generated mail_id and secret_id codes;

- a new configuration variable $sql_store_info_for_all_msgs allows storing
  information on mail messages selectively just for quarantined messages;

- added SNMP counters InMsgsStatus* which combine the final mail checking
  status with a direction of a mail flow;

- optional transparent archival quarantine, retaining envelope recipient
  addresses on delivery to a dedicated SMTP server;


GENERAL

With a synergy of four solutions, using amavisd-new in a pre-queue
filtering setup became a sensible / better behaved solution:

- the "smtpd_proxy_options=speed_adjust" Postfix option, available since
  Postfix 2.7.0 (20091101), improves decoupling between SMTP clients
  and a content filter in a proxy setup, reducing the number of content
  filtering processes needed for the same mail load. With this option
  turned on, a Postfix SMTP server receives entire message before
  connecting to a before-queue content filter;

- a master_deadline option and its API equivalent, available in SpamAssassin
  since version 3.3.0, allows for time limiting on lengthy rules checking,
  while still providing results when a time limit is exceeded; this makes
  it more suitable for time-sensitive setups like a pre-queue filtering setup;

- reworked sub-task time limiting in amavisd, along with its counterpart
  solution in SpamAssassin, makes it better suited to a real-time nature
  of pre-queue filtering setups where one has no control over how long
  SMTP clients are willing to wait at the data-end stage;

- a re-purposed command line option 'reload' now does a warm restart,
  keeping sockets available to an MTA client at all times, thus reducing
  a chance that an MTA would even notice a content filter's warm restart.

Provided that required minimal versions of Postfix and SpamAssassin are
available, on can try amavisd in a Postfix proxy setup. The $child_timeout
setting needs to be radically reduced in this setup, matching the longest
time most SMTP clients are willing to wait, and must be less than Postfix
is willing to wait (smtpd_proxy_timeout), which by default is 100 s.
A sensible value is somewhat less then a minute (e.g. 45 seconds). Even
though RFC 5321 (section 4.5.3.2.6) recommends that clients SHOULD be
willing to wait for 10 minutes at data-end stage, it is not uncommon
that this recommendation is not adhered to.

Note that a pre-queue filtering setup (along with its benefits) still
has all its drawbacks, like the need for more filtering processes to
accommodate mail arrival rate peaks (instead of averages), and much shorter
and unpredictable (client-dependent) time limits. The new features of the
three products only rise the thresholds where trouble starts, and make
the whole setup better behaved.


COMPATIBILITY WITH 2.6.4 / 2.6.5 / 2.6.6

- due to popular demand to reduce undesired and unintentional backscatter,
  defaults for the settings $final_spam_destiny and $final_banned_destiny
  were changed. Previously they both defaulted to D_BOUNCE, new defaults
  are:

    $final_virus_destiny      = D_DISCARD;
    $final_banned_destiny     = D_DISCARD;
    $final_spam_destiny       = D_PASS;
    $final_bad_header_destiny = D_PASS;

  Please adjust to will. If you have these settings configured explicitly
  in a configuration file, this change of a default value does not affect
  you.

  For a pre-queue content filtering setup (smtp proxy or milter) a suitable
  value for undesired content is D_REJECT. For a post-queue filtering setup
  preferred choices are to tag-and-deliver (D_PASS), or to drop (D_DISCARD)
  and quarantine.

  It is still possible to use a D_BOUNCE setting, but please limit
  and monitor your backscatter. Due to a default setting of
  @viruses_that_fake_sender_maps the backscatter on viruses has been
  fully suppressed since amavisd-new-20021116 even with a D_BOUNCE.
  Backscatter on high-scoring spam has been controllable since
  amavisd-new-20030616-p8 by a family of settings
  @spam(_crediblefrom)_dsn_cutoff_level(_bysender)_maps,

- several ancient configuration settings were removed or deactivated,
  see section CLEANING below;

- a command line option 'reload' has been renamed to 'restart',
  corresponding to a shutdown followed by a normal (cold) start;
  while a command line option 'reload' has been re-purposed to function
  as a warm/flying restart. See below for details. Protection of some
  files may need to be examined (configurations files and DKIM private
  keys should be readable for group vscan/amavis and not writable by
  UID vscan/amavis);

- a failure of all virus scanners no longer automatically tempfails the
  operation, but flags a message with a CC_UNCHECKED contents category
  (just like a failure of decoders/dearchivers), and allows the usual
  controls (*_destiny, *_quarantine_*) to be used to choose behaviour.
  The $virus_scanners_failure_is_fatal=1 reverts to previous behaviour,
  see below;

- a default value of $hdr_encoding and $bdy_encoding has been changed
  from 'iso-8859-1' to 'UTF-8' which better suits reporting of banned parts;

- default encoding for reading text templates from the tail of a file
  'amavisd' has been changed to 'utf8', which allows replacing a default
  text by a non-ascii Unicode template, encoded as UTF-8;

- when using SQL for logging/penpals: three fields need to be added
  to a table msgrcpt: msgrcpt.content, msgrcpt.rseqnum, msgrcpt.is_local,
  and one to a table msgs: msgs.originating .

  Semantics of msgrcpt.content is similar to msgs.content, but reflects
  individual recipient's settings (e.g. when a message is both banned and
  spam, a recipient with banning tests disabled will see a message as spam,
  while other recipient of the same message will consider it banned).
  The added field may also simplify queries by third party applications.

  The field msgrcpt.rseqnum uniquely identifies/enumerates recipients within
  each message, typically by assigning them sequential numbers starting
  with 1. The only purpose of this field is to make it possible to define
  a primary key for the table msgrcpt, which may be needed for some
  clustering/partitioning purposes. Amavisd itself does not require a
  primary key on this table.

  The field msgrcpt.is_local should be considered a boolean, its value can be:
    'Y' ... yes, recipient is local, i.e. matches @local_domains_maps
    'N' ... no,  recipient does not match @local_domains_maps
    ' ' ... unknown - this is a default field value; amavisd always sets
            this field to either 'Y' or 'N';

  The field msgs.originating should be considered a boolean, its value can be:
    'Y' ... yes, message is originating from inside or from an authenticated
            roaming sender (the flag $originating was true);
    'N' ... no, message is not submitted by our user ($originating was false);
    ' ' ... unknown - this is a default field value; amavisd always sets
            this field to either 'Y' or 'N', reflecting the $originating flag;

  A combination of msgs.originating and msgrcpt.is_local tells a direction
  a message is traveling:
    originating is_local
        N        N    open relay (probably misconfigured @local_domains_maps
                                  or $originating flag not set)
        N        Y    inbound message
        Y        N    outbound message
        Y        Y    internal message (inside or authenticated -> inside)
  Note that a direction is a per-recipient property, a multi-recipient
  message can be outbound for some recipients and internal for others
  at the same time.

  The following SQL directives can be used to add these new fields:
    ALTER TABLE msgrcpt ADD rseqnum     integer  DEFAULT 0   NOT NULL;
    ALTER TABLE msgrcpt ADD content     char(1)  DEFAULT ' ' NOT NULL;
    ALTER TABLE msgrcpt ADD is_local    char(1)  DEFAULT ' ' NOT NULL;
    ALTER TABLE msgs    ADD originating char(1)  DEFAULT ' ' NOT NULL;

  If a primary key on table msgrcpt is needed for some reason,
  try something like the following:
  *MySQL:
     UPDATE msgrcpt SET rseqnum=1+floor(999999999*rand()) WHERE rseqnum=0;
     ALTER TABLE msgrcpt ADD PRIMARY KEY (partition_tag,mail_id,rseqnum);
  *PostgreSQL:
     UPDATE msgrcpt SET rseqnum=1+floor(999999999*random()) WHERE rseqnum=0;
     CREATE UNIQUE INDEX msgrcpt_idx_primary
       ON msgrcpt (partition_tag,mail_id,rseqnum);

  If keeping a possibly customized copy of %sql_clause in a configuration
  file, entries 'ins_rcp' and 'upd_msg' will need to be updated accordingly.

  To facilitate transition from 2.6.6 to 2.7.0, it is possible to configure
  amavisd 2.7.0 to supply with SELECT and INSERT clauses a subset of
  parameters as used by 2.6.6. A configuration setting $sql_schema_version
  controls this backward compatibility. Its default value is 2.007000 .
  By setting it to a value below 2.007000 (such as 2.006006 or 2.006004) a
  subset of parameters as was used with a version 2.6.6 or 2.6.4 is selected.
  SQL clauses in $sql_clause{'upd_msg'} and $sql_clause{'ins_rcp'} need to
  be adjusted according to a chosen version of actual parameters. Below is
  an example of a required setting compatible with both amavisd-new 2.6.6
  and 2.7.0, which lets amavisd 2.7.0 use an SQL schema of 2.6.6, which
  lacks the four newly added fields:

  our($sql_schema_version)  if $myversion_id_numeric < 2.007000;
  $sql_schema_version = 2.006006;
  $sql_clause{'upd_msg'} =
    'UPDATE msgs SET content=?, quar_type=?, quar_loc=?, dsn_sent=?,'.
    ' spam_level=?, message_id=?, from_addr=?, subject=?, client_addr=?'.
    ' WHERE partition_tag=? AND mail_id=?';
  $sql_clause{'ins_rcp'} =
    'INSERT INTO msgrcpt (partition_tag, mail_id, rid,'.
    ' ds, rs, bl, wl, bspam_level, smtp_resp) VALUES (?,?,?,?,?,?,?,?,?)';

  Note that this is only provided to facilitate transition. Please add
  the new fields on an opportunity, then remove the above settings from
  your configuration file and restart amavisd.

- SQL fields msgs.content and msgrcpt.content used to encode a content
  type CC_SPAMMY as 's', and CC_MTA as 't'. With default case-insensitive
  queries on a data type CHAR it was not possible to distinguish
  between lowercase 's' (= CC_SPAMMY) and uppercase 'S' (= CC_SPAM), so
  the CC_SPAMMY is now encoded as 'Y', and CC_MTA as 'T' (just in case).
  Please adjust your management tools if necessary.

- please check SQL data types on fields msgs.mail_id, msgs.secret_id,
  msgrcpt.mail_id and quarantine.mail_id in existing databases, these must
  be treated case-insensitively - see details further down, please search
  further down for "must be treated case-insensitively";

- SQL clause $sql_clause{'sel_quar'} no longer uses a coalesce() function
  (introduced in amavisd-new-2.6.2) which attempted to deal with NULL
  quarantine.partition_tag or with undefined $partition_tag, when releasing
  a message from an SQL quarantine - but payed the price of not using an
  index. If releasing from an SQL quarantine is desired, either ensure there
  are no (old) records in a table 'quarantine' with a NULL partition_tag
  (e.g. replace such fields with a 0, and don't leave $partition_tag
  undefined in amavisd.conf - set it to 0 for example when partitioning
  is not needed), or assign a former clause to $sql_clause{'sel_quar'}
  in amavisd.conf :

  $sql_clause{'sel_quar'} =
    'SELECT mail_text FROM quarantine'.
    ' WHERE coalesce(partition_tag,0)=coalesce(?,0) AND mail_id=?'.
    ' ORDER BY chunk_ind';

  Thanks to Michael Scheidell and Thomas Gelf for pointing out the
  inefficiency.

- if using Petr Rehor's amavisd-milter to call amavisd, please update it
  to version 1.5.0 (or later), as earlier versions did not accept a new
  attribute 'log_id', which is now included in a response from amavisd;

- a sample configuration file amavisd.conf-sample was removed from the
  package - it hasn't been seriously updated for years, and it contained
  lots of aged or distracting information;

- old helper programs amavis.c and amavis-milter.c are no longer distributed
  with the package, along with the entire helper-progs subdirectory.
  As a milter client please use the more modern 'amavisd-milter' package by
  Petr Rehor, available at http://sourceforge.net/projects/amavisd-milter/

- old AM.CL protocol is no longer supported; it was provided for
  compatibility with versions of AMaViS pre-dating amavisd-new, along with
  its client programs: old helper programs amavis.c and amavis-milter.c.
  Handling of release requests and milter requests through AM.PDP protocol
  remains unaffected;

- a sample AM.PDP client program for mail submission to amavisd which was
  previously distributed as 'helper-progs/amavis.pl' has been renamed to
  'amavisd-submit' and slightly modernized. It provides partial functional
  compatibility with a very early AMaViS client program amavis.c . It takes
  a message on stdin, copies it to a temporary file, passes its name to
  amavisd daemon using AM.PDP protocol, and based on the response adjusts
  its exit status value so that an invoking script or program may decide
  whether to deliver the mail message or not;

- mail_id and secret_id are now composed of characters from a character set
  [ A-Z, a-z, 0-9, -, _ ] instead of [ A-Z, a-z, 0-9, +, - ]  (i.e. now uses
  underline instead of a plus) to conform to RFC 4648 base64url specification,
  thus making it potentially easier to specify an id in various GUI/API
  interfaces without a need for quoting a plus. The change is also reflected
  in a choice of quarantine file names. Compatibility with releasing of old
  quarantined messages is retained;

- relationship between mail_id and secret_id has changed and is now:
    mail_id = encode_base64(md5(decode_base64(secret_id)))
    (i.e. md5 is applied to 9 raw bytes of a secret id)
  while previously it was:
    mail_id = encode_base64(md5(secret_id))
    (i.e. md5 was applied to 12 base64 characters of a secret id)
  Releasing from a quarantine still understands old relationship and old
  base64 encoding character set for compatibility, so no problems are
  expected even when releasing a mix of old and new quarantined messages.
  The change may potentially affect some third party application.

- caching of virus and spam check results based on a mail body hash has been
  removed. It was very beneficial years ago when virus storms were common
  and spam was not personalized. Nowadays (2011) the feature barely pays
  for itself (savings are comparable to additional processing needed), and
  is incompatible with per-recipient spam checks (as introduced with this
  version), and incompatible with DKIM verification on locally originating
  and signed mail being returned from a mailing list. Rather than trying
  to fit a square peg into a round hole, the feature is now dropped.

  Associated configuration variables are still declared for compatibility,
  but have no effect:
    $enable_global_cache,
    $virus_check_negative_ttl, $virus_check_positive_ttl,
    $spam_check_negative_ttl, $spam_check_positive_ttl

- a default value for $lock_file is now undefined instead of the former
  default value "$helpers_home/amavisd.lock";  an undefined value lets
  Net::Server choose a suitable temporary file (POSIX::tmpnam) for 'flock'
  serialization on socket accept();

- updated (rarely used) AV entries 'Sophos SAVI', 'Mail::ClamAV'
  and 'av_smtp' in an incompatible way (they now use ask_daemon interface
  instead of a dedicated subroutine), please update your AV entries
  according to the new sample file amavisd.conf;

- internal: spam_level() and spam_tests() are no longer properties of a
  message but are now a property of each recipient, which makes possible
  per-recipient spam checking settings (e.g. rules, bayes username, ...);

- internal: a delivery_method() is no longer a property of a message, but
  is now a property of each recipient, which makes per-recipient forwarding
  possible;

- internal: a load_policy_bank() takes one additional argument $msginfo,
  which is passed on to any policy bank's ACTION routine if a policy bank
  has one;


BUG FIXES SINCE 2.6.6

- take a more cautious approach on keeping evidence on an SMTP session
  transaction state when feeding a message back to MTA. Under certain
  abnormal circumstances an MTA could respond to end-of-data with a temporary
  failure but retain an active transaction state while amavisd would assume
  the transaction was closed, leading to a 'MAIL transaction in progress'
  failure on the next message using the same cached SMTP session.
  Now amavisd considers a transaction state to be unknown when there is any
  doubt and closes a session instead of caching it, unless the transaction
  is reliably known to be closed. Problem reported by Ralf Hildebrandt.


BUG FIXES SINCE 2.6.5

All bug fixes that were developed during a 2.7.0 developement cycle
have been backported to the 2.6 branch and released as 2.6.6.
They are all documented in release notes of the 2.6.6 release.


BUG FIXES SINCE 2.6.4

All bug fixes and some compatibility measures that were developed during
a 2.7.0 developement cycle have been backported to the 2.6 branch and
released as 2.6.5. They are all documented in release notes of the
2.6.5 release.


NEW FEATURES

- a command line option 'reload' has been renamed to 'restart', while keeping
  its semantics: to stop a currently running daemon, and then promote a
  process to become a new daemon. This makes a complete and independent
  restart with all its benefits: can start a chrooted daemon, can access
  config files or DKIM signing keys accessible only to root, can open
  sockets/ports otherwise restricted to root, can change inet and unix
  socket locations, their bindings and port numbers. It will also reset
  SNMP counters in a database, if it is enabled.

  A downside is that during a restart existing sockets are closed, so
  until new sockets are re-established an MTA client experiences connection
  failures, which is particularly disruptive in a pre-queue MTA setup.

- a command line option 'reload' has been re-purposed to function as a
  warm restart: it now sends a HUP signal to a running daemon, then exits.
  A running daemon upon receiving a HUP signal will clone its sockets,
  clear their 'close-on-exec' flag, then restart itself through exec().
  A reborn daemon inherits open sockets, does a normal startup (loading
  perl modules and config files), then reassociates inherited sockets
  with configured inet and Unix socket names, which is why these must
  not be changed in a configuration file between reloads.

  Sockets remain open and available to clients during the whole warm-restart
  period, requests are queued by kernel (queue size is configurable through
  $listen_queue_size, defaulting to SOMAXCONN, or there may not be any
  queues at all when an IP stack is using SYN cookies), so apart from a
  delay in connection establishment, an MTA client will not notice a restart
  as long as the IP stack is willing to accept new sessions (as controlled
  by listen queue size or SYN cookies). This makes the reloading method
  particularly suitable for pre-queue filter setups.

  A downside is that a HUP-ed daemon has already dropped root privileges
  during its first start, so it must restart as a nonprivileged user
  (typically 'vscan' or 'amavis'), which rules out its ability to chroot,
  and requires that configuration files, DKIM signing keys files, and
  perl modules must be readable by this GID or UID, otherwise a restart
  fails and a daemon process no longer exists. Depending on a version
  of perl and operating system in use, it might be necessary to specify
  an absolute path to amavisd on the initial start. To debug warm-restart
  problems it may be useful to first try a warm restart on a non-daemonized
  process (started manually as: amavisd foreground, or: amavisd debug),
  so that potential errors on stderr are visible.

  A sensible protection of configuration files and files with DKIM keys is
  to set their group ownership to vscan (amavis) and UID ownership to root,
  and mode to 0640 (u=rw,g=r,o=).

  A need for non-root accessibility of DKIM signing keys can be avoided
  by using a new signing service daemon included with this release (see
  further down: amavisd-signer).

  One additional feature of a warm reload is that SNMP counters in a
  database (visible through amavisd-agent or amavisd-snmp-subagent)
  are not reset to zero, unlike the restart which clears them.

- on stop, restart or reload, currently busy child processes are left
  to complete their current task instead of being abruptly stopped.
  This minimizes a disruption experienced by MTA.

- added a client-side and server-side support for the IDENT attribute of
  a Postfix XFORWARD smtp command (available since Postfix version 2.8.0).
  The attribute allows passing of a local message identifier (MTA queue id)
  downstream from a front-end MTA to a post-queue content filter and back
  to a back-end MTA. Amavisd makes this information available through an
  existing macro %Q (which was previously non-empty only in milter setups),
  and as such the information appears in the log when using a default amavisd
  log template. This information is also passed back to a re-entry MTA if
  it announces a support for this attribute (enabled on a back-end smtpd
  service with an option smtpd_authorized_xforward_hosts), so the log entries
  are now easier to correlate in a post-queue filtering setup:

  back-end MTA:
    postfix/smtpd[72995]: 553261D1CB0: client=localhost[::1],
      orig_queue_id=2F5971D1CA3, orig_client=...

  post-queue content filter:
    amavis[20341]: (20341-15) Passed CLEAN ...
      Queue-ID: 2F5971D1CA3, queued_as: 553261D1CB0

  front-end MTA:
    postfix/lmtp[73130]: 2F5971D1CA3: ... relay=127.0.0.1[127.0.0.1]:10024,
      status=sent (250 2.0.0 from MTA(smtp:[::1]:10025):
                   250 2.0.0 Ok: queued as 553261D1CB0)

- support Postfix 2.9 long queue IDs (enable_long_queue_ids=yes)
  as available since postfix-20110321 by adjusted default values
  of $log_short_templ and $log_verbose_templ templates;

- improved support for pre-queue content filtering setups: reorganized time
  limiting on processing to obey more strictly a deadline time, which is the
  sum of $child_timeout and a timestamp at the moment of a reception of a
  complete message (SMTP data-end time). The deadline time is also passed
  to SpamAssassin, which since version 3.3.0 supports a 'master_deadline'
  option and can gracefully terminate its processing on a time limit, while
  still providing results collected so far.

  The setting $sa_timeout is now retired: the variable is still declared
  for backward compatibility, but has no effect. Instead, the time available
  for spam scanning is automatically determined from $child_timeout, taking
  into consideration the actual time left till the deadline;

- $child_timeout and $smtpd_timeout settings are now dynamic, i.e. can be
  changed by a policy bank, which makes it possible to support (on different
  ports) both the pre-queue and post-queue (e.g. fallback) clients by the
  same amavisd daemon;

- a new configuration variable $soft_bounce (also a member of policy banks)
  turns rejects, bounces and discards into a temporary failure when true;
  this is potentially useful as a short-term safety net when testing
  configuration changes on a low-traffic server;

- added an AV entry and supporting code for Sophos-SSSP, implementing the
  client side of the Sophos SSSP protocol, talking to a savdid daemon
  (a replacement for Sophie) using its native protocol;

- added an AV entry and supporting code for AVIRA SAVAPI protocol,
  implementing the client side of the protocol, talking to a savapi daemon;

- added an AV entry for clamdscan which can serve as a useful backup scanner,
  connecting as client to a remote clamd; the supplied alternative config
  file should specify the host IP and port number where clamd is running
  using TCPAddr and TCPSocket options; suggested by Michael Scheidell;

- added an AV entry for ClamAV clamd streaming which can serve as a main
  or backup scanner, connecting as client to a remote clamd. The client
  side implements clamd zINSTREAM command, batched in a zIDSESSION / zEND
  group. This approach is comparable to what is implemented in clamdscan
  and is somewhat less efficient than passing only a directory name to
  clamd, but has an advantage that the clamd daemon need not have direct
  access to amavisd temporary files, and may even be running on a remote
  host. The cost of this flexibility is additional data transfer.
  Suggested by Michael Scheidell.

- lists of lookup tables (the @*_maps variables) can now contain
  explicit SQL and LDAP lookup objects as their elements, instead of
  (or in addition to) the implied SQL and LDAP lookups.

  A new configuration setting $lookup_maps_imply_sql_and_ldap controls
  whether the SQL and LDAP lookup objects are implicitly prepended
  to list in @*_maps variables (when true), or not (when false).
  The default value is 1 for compatibility with previous versions.

  Regardless of the $lookup_maps_imply_sql_and_ldap setting, the @*_maps
  lists of lookup tables/objects may now contain explicit lookup objects
  for arbitrarily named SQL fields and LDAP attributes. This provides more
  flexibility: the order of lookups is now configurable (previously SQL and
  LDAP lookup objects were prepended to lists and thus always looked up
  first), and the names of SQL fields or LDAP attributes can now be
  specified as arguments to SQL and LDAP lookup objects (previously field
  and attribute names were hardwired into code).

  Three shorthand functions are available for creating SQL lookup (query)
  objects: q_sql_s, q_sql_n, q_sql_b, and three for creating LDAP lookup
  (query) objects: q_ldap_s, q_ldap_n, q_ldap_b.  The _s, _n and _b suffixes
  imply a data type of the expected result: a string, a numeric value, and a
  boolean. Due to Perl's forgiveness a string data type can in most cases be
  used as a number or as a boolean and may be used when data type conversion
  and value normalization is not necessary or when a data type is not known.

  Here are some examples:

  @spam_kill_level_maps = (
    { # a hash-type lookup object
      'user1@example.com' => 8,
      '.example.org' => 7.5,
    },
    q_ldap_n('amavisSpamKillLevel'),  # an LDAP lookup object
    q_sql_n('spam_kill_level'),  # an SQL lookup object
    $sa_kill_level_deflt,  # a constant-type pseudo-lookup object
  );

  @spam_subject_tag2_maps = (
    q_sql_s('subject_tag'),
  );

  In addition to simple scalar arguments (a field or attribute name), these
  six lookup object-creating functions can take as their argument a listref
  of field or attribute names, or a hashref where hash entry values are
  SQL field names (or LDAP attribute names), and hash entry keys are the
  result data names. Lookups resulting from such lookup objects will return
  a hashref of key/value pairs instead of a single scalar result. This is
  currently only useful in the @dkim_signature_options_bysender_maps list
  of lookups which expects such hash results (sets of data names and their
  values, i.e. entire records).

  The listref argument is just a shorthand notation which can be used
  in place of a hashref when field names (or attribute names) are the
  same as the desired result data names. The following alternatives
  are equivalent:
    q_sql_s( { 'd' => 'd', 's' => 's', 'ttl' => 'ttl' } )
    q_sql_s( {  d  => 'd',  s  => 's',  ttl  => 'ttl' } )  # perl shorthand
    q_sql_s( [ 'd', 's', 'ttl' ] )
    q_sql_s( [qw(d s ttl)] )  # perl shorthand

  Example (artificial, not necessarily useful):

    @dkim_signature_options_bysender_maps = (
      q_sql_s(  ['d', 's', 'ttl'] ),
      q_ldap_s( ['d', 's', 'a'] ),
      q_ldap_s({ d => 'sdid', s => 'amavisSelector', a => 'amavisDkimAlg' }),
      { 'postmaster@example.com' => { a => 'rsa-sha1', ttl => 7*24*3600 },
        '.' => { a => 'rsa-sha256', ttl => 30*24*3600 },
      },
    );

- a new configuration variable $sql_store_info_for_all_msgs when turned
  off requests storing information on mail messages selectively just for
  quarantined messages. At the same time turning this setting off also
  disables pen pals lookups. A default value is 1 (true) as before,
  indicating that information on all messages is to be stored into tables
  msgs, msgrcpt and maddr when @storage_sql_dsn is enabled, thus ensuring
  long-term uniqueness of mail_id and proper operation of pen pals lookups;

- a new program is included with a package: amavisd-signer. It is a DKIM
  signing service daemon for amavisd. It uses an AM.PDP protocol lookalike
  to receive a request from amavisd and provides two services: choosing a
  signing key, and signing a message digest with a chosen DKIM private key.

  Amavisd uses this signing service when a $dkim_signing_service setting
  is defined and nonempty, and $enable_dkim_signing is true. For each
  mail message meeting the basic requirements for signing (originating,
  nonspam and not infected), the first request sent to a signing service
  passes some information about the message (its author, sender, recipients)
  and expects the service to choose and provide a suitable signing domain
  and selector (and optional signature options) when a signing key is
  available and the service considers it appropriate to sign the message.
  If the response does not provide a signing domain and selector,
  amavisd falls back to consulting its own settings (a dkim_key() set
  of signing keys, and @dkim_signature_options_bysender_maps).

  The second stage of signing occurs when a signing key has been uniquely
  identified during the first stage, i.e. when its signing domain and a
  selector have been determined. Amavisd computes a message digest according
  to DKIM specifications and passes it to the signing service, along with
  the signing domain and selector name. The signing service computes the
  signature and returns it as a 'b' attribute (corresponding to a 'b' tag
  of a DKIM signature), from which amavisd assembles the signature header
  field and inserts it into a message. The signing service may still choose
  not to sign at this stage, e.g. when a private key corresponding to the
  requested signing domain and selector is not available. If a signing
  service is not available or cannot sign, amavisd falls back to its own
  configured list of signing keys ( dkim_key() ) for backward compatibility.

  The main reason for separating the signing act from the main amavisd daemon
  is to make it possible to do the DKIM signing without letting amavisd
  have access to private keys - following the minimal 'need-to-know'
  security principles. For example, amavisd may be started as non-root or
  restarted from a jail, while the independent amavisd-signer process
  remains the only process with access to private signing keys (by running as
  root or under a separate UID or GID or with an access to a crypto device).

  Additional benefit is that more complex decisions on which signing key
  to use for which mail message can be delegated to the signing service,
  which can be customized (through code changes or replacing it altogether)
  without touching the main amavisd daemon.

  To let amavisd use a signing service, specify the signing service's
  IP address and TCP port number in amavisd.conf, e.g.:
    $dkim_signing_service = '127.0.0.1:20203';
  matching the $inet_socket_bind and @listen_sockets settings near the
  beginning of the 'amavisd-service' file, then start the signing service
  and restart amavisd daemon. Currently all the settings for amavisd-service
  are contained in its file, no external configuration file or command line
  options are available at present.

- a constant D_TEMPFAIL has been added to a set of allowed final_*_destiny
  values; mostly intended for completeness and testing;

- a new setting @listen_sockets offers a unified configuration of listening
  sockets. This list may be configured directly, or the traditional way: the
  $inet_socket_port and $unix_socketname just add their entries (if any)
  to the @listen_sockets list, and $inet_socket_bind provides a default
  binding IP address for inet or inet6 ports. Each socket specification
  may either be a unix socket path (as in $unix_socketname), or an inet or
  inet6 socket specification (a binding IP address as in $inet_socket_bind,
  combined with a port number $inet_socket_port, delimited by a colon,
  e.g. '127.0.0.1:10024', '[::1]:10024', '10024'.  When only a port number
  is specified without an IP address, the binding address defaults to
  $inet_socket_bind, which in turn (if left undefined), defaults to all
  interfaces.

  An 'unspecified' binding address '0.0.0.0' implies any socket of the inet
  family (IPv4), while an 'unspecified' address '::' implies any socket of
  an inet6 (IPv6) family. Depending on the operating system and its settings
  an inet6 socket may or may not be able to also accept inet connections.
  To be able to listen on inet6 (IPv6) sockets requires version 2.0 (or later)
  of the module Net::Server, or a patched Net::Server 0.99.

  Example:
    @listen_sockets = ( '10024', "$MYHOME/amavisd-proxy.sock",
      '0.0.0.0:10010', '127.0.0.1:10012', '10026', '9998', '[::1]:10028' );

- SMTP and LMTP client code now accepts a listref of peer socket
  specifications, or a single scalar specification as before. This allows
  for a failover in case some server is down or refuses connections.
  It also provides a simpleminded load balancing between next-hop
  (re-entry) MTA servers, as the selection from a list is random.
  Session caching still works, so if a recently used SMTP/LMTP session
  is still open, it will be reused, in which case no server randomization
  takes place for as long as the established session remains open.

  Typical configuration variables where this feature is available are:
  $forward_method, $notify_method, $resend_method, $release_method, and
  $requeue_method, but only when the specified protocol is smtp: or lmtp:,
  (not pipe:, local:, sql:, bsmtp:).

  Example:
    $forward_method =
      [ 'smtp:[::1]:10025', 'smtp:[127.0.0.1]:10025', 'smtp:*:10025' ];

    $notify_method =
      [ 'smtp:*:*', 'smtp:192.0.2.10:10025' ];

  It is assumed that the protocol specification scheme (e.g. 'smtp:')
  of all entries in a list is the same. Mixing different protocols
  in the same list of alternatives is not allowed;

- when a message is being released from a quarantine as an attachment
  ( $release_format = 'attach' ), it is now possible to wrap this attached
  message into a password-protected ZIP archive to prevent accidental or
  automatic opening of the possibly malicious original message. The chosen
  password is included in the first plain text MIME part, along with an
  explanation / instructions for a recipient.

  Note that the purpose of password scrambling is only to prevent an
  accidental or automatic opening of an attachment. It is not intended
  to be a strong mechanism for keeping messages secret. There is no point
  in providing excessively long / strong passwords.

  A template for this first plain-text MIME part can be changed as before
  by assigning a new text to $notify_release_templ (or modifying a default
  template near the end of the file 'amavisd').

  Three new configuration variables are added, all three are also members
  of policy banks: $attachment_email_name, $attachment_outer_name, and
  $attachment_password. Their default values are:
    $attachment_password = '';  # no password and no ZIP wrapping
    $attachment_email_name = 'msg-%m.eml';
    $attachment_outer_name = 'msg-%m.zip';

  The $attachment_email_name is a template for forming a name of a file,
  which is then inserted into a zip archive. This name will be seen as a
  filename containing an original mail message when a recipient unzips
  the archive. The supplied string may contain placeholders, the same
  placeholders are recognized as for filename templates used to control
  quarantining. For the record, here is a complete list of placeholders
  currently recognized:
    %P  =>  $msginfo->partition_tag
    %b  =>  $msginfo->body_digest
    %m  =>  $msginfo->mail_id
    %n  =>  $msginfo->log_id
    %i  =>  iso8601 timestamp of a message reception time by amavisd
    %%  =>  %

  The $attachment_outer_name is a template for forming a name of a ZIP
  archive which will be attached to a message. This name will end up
  in a MIME sub-header field of the attachment, and as such will be used
  as a filename when a recipient saves the attachment (without unzipping
  it). The supplied string may contain the same placeholders as above.

  The $attachment_password setting can be:

  . an empty string, in which case no ZIP wrapping will occur and no
    passwords are applied; also the settings $attachment_email_name and
    $attachment_outer_name have (currently) no effect, as the attachment
    is not a ZIP archive but the original message itself;
    this is a default setting for compatibility with earlier versions;

  . a fixed static string, in which case an original message is wrapped
    in a ZIP archive and the archive is encrypted with this fixed string
    password;

  . an undefined value ( $attachment_password = undef ), in which case
    a 4-digit random password (PIN) is internally generated for each
    quarantine release, the rest is the same as with a fixed string;

  . a subroutine reference, in which case the supplied subroutine is
    called (in a scalar context), passing it a $msginfo object as
    the only argument; the subroutine is expected to return a password
    as a string, or die if it cannot do its job; the returned value is
    then treated as one of the three cases above, i.e. an empty string
    disables zipping, an undefined value invokes internal PIN generating
    code, and any other value is taken as a password for encrypting
    the archive.

  Example use:
    $release_format = 'resend';  # choices: plain, resend (default), attach

  or:
    $release_format = 'attach';
    $attachment_password = '';   # no archive, just plain attachment

  or:
    $release_format = 'attach';
    $attachment_password = undef;  # internally generated 4-digit random PIN

  or:
    $release_format = 'attach';
    $attachment_password = 'fooBAR';  # fixed password

  or:
    $release_format = 'attach';
    $attachment_password = sub {
      my($msginfo) = @_;
      my $str = qx'pwgen -N 1 -n -B -s 6';
      die "pwgen failed, exit status: $?" if $?;
      die "pwgen returned empty result" if $str eq '';
      return $str;
    };

  As the $attachment_password is a member of policy bank, it is possible
  to configure amavisd to listen to release requests on two TCP ports,
  for example using one to release unencrypted false-positive spam messages,
  and the other to release possibly problematic infected messages.


- updated amavisd-snmp-subagent and AMAVIS-MIB.txt by adding ten
  user-specifiable 64-bit counters and ten user-specifiable 32-bit gauges;
  Counters are placed into OID tree under 1.3.6.1.4.1.15312.2.1.1.17
  and named UserCounter1..UserCounter10, whereas gauges are placed
  under 1.3.6.1.4.1.15312.2.1.1.18 and named UserGauge1..UserGauge10.
  A custom hook or a policy bank ACTION hook can be used for adjusting
  their values by calling snmp_count64() routine, e.g.:
    Amavis::Util::snmp_count64('UserCounter3', 'UserCounter9');
  or:
    Amavis::Util::snmp_count( ['UserCounter4', 1234, 'C64'] );

- updated amavisd-snmp-subagent and AMAVIS-MIB.txt by adding the following
  counters, all placed under 1.3.6.1.4.1.15312.2.1.1 :

    .19.1   InMsgsStatusAcceptedAll         same value as .2.7
    .19.2   InMsgsStatusAcceptedInbound
    .19.3   InMsgsStatusAcceptedOutbound
    .19.4   InMsgsStatusAcceptedInternal
    .19.5   InMsgsStatusAcceptedOriginating
    .19.6   InMsgsStatusAcceptedOpenRelay

    .20.1   InMsgsStatusRelayedUntaggedAll  (no equivalent)
    .20.2   InMsgsStatusRelayedUntaggedInbound
    .20.3   InMsgsStatusRelayedUntaggedOutbound
    .20.4   InMsgsStatusRelayedUntaggedInternal
    .20.5   InMsgsStatusRelayedUntaggedOriginating
    .20.6   InMsgsStatusRelayedUntaggedOpenRelay

    .21.1   InMsgsStatusRelayedTaggedAll    (no equivalent)
    .21.2   InMsgsStatusRelayedTaggedInbound
    .21.3   InMsgsStatusRelayedTaggedOutbound
    .21.4   InMsgsStatusRelayedTaggedInternal
    .21.5   InMsgsStatusRelayedTaggedOriginating
    .21.6   InMsgsStatusRelayedTaggedOpenRelay

    .22.1   InMsgsStatusDiscardedAll        same value as .2.9
    .22.2   InMsgsStatusDiscardedInbound
    .22.3   InMsgsStatusDiscardedOutbound
    .22.4   InMsgsStatusDiscardedInternal
    .22.5   InMsgsStatusDiscardedOriginating
    .22.6   InMsgsStatusDiscardedOpenRelay

    .23.1   InMsgsStatusNoBounceAll         same value as .2.10
    .23.2   InMsgsStatusNoBounceInbound
    .23.3   InMsgsStatusNoBounceOutbound
    .23.4   InMsgsStatusNoBounceInternal
    .23.5   InMsgsStatusNoBounceOriginating
    .23.6   InMsgsStatusNoBounceOpenRelay

    .24.1   InMsgsStatusBouncedAll          same value as .2.11
    .24.2   InMsgsStatusBouncedInbound
    .24.3   InMsgsStatusBouncedOutbound
    .24.4   InMsgsStatusBouncedInternal
    .24.5   InMsgsStatusBouncedOriginating
    .24.6   InMsgsStatusBouncedOpenRelay

    .25.1   InMsgsStatusRejectedAll         same value as .2.12
    .25.2   InMsgsStatusRejectedInbound
    .25.3   InMsgsStatusRejectedOutbound
    .25.4   InMsgsStatusRejectedInternal
    .25.5   InMsgsStatusRejectedOriginating
    .25.6   InMsgsStatusRejectedOpenRelay

    .26.1   InMsgsStatusTempFailedAll       same value as .2.13
    .26.2   InMsgsStatusTempFailedInbound
    .26.3   InMsgsStatusTempFailedOutbound
    .26.4   InMsgsStatusTempFailedInternal
    .26.5   InMsgsStatusTempFailedOriginating
    .26.6   InMsgsStatusTempFailedOpenRelay

  For compatibility, the following counters appear in the MIB
  at two locations (both locations present the same value):
    .19.1 or .2.7   InMsgsStatusAcceptedAll
   (.20.1     -     InMsgsStatusRelayedUntaggedAll)
   (.21.1     -     InMsgsStatusRelayedTaggedAll)
    .22.1 or .2.9   InMsgsStatusDiscardedAll
    .23.1 or .2.10  InMsgsStatusNoBounceAll
    .24.1 or .2.11  InMsgsStatusBouncedAll
    .25.1 or .2.12  InMsgsStatusRejectedAll
    .26.1 or .2.13  InMsgsStatusTempFailedAll

  The value of a counter .2.8 InMsgsStatusRelayed is a sum of:
    .20.1 InMsgsStatusRelayedUntaggedAll
    .21.1 InMsgsStatusRelayedTaggedAll

  Their semantics is documented in AMAVIS-MIB.txt .
  Suggested by Patrick Ben Koetter.

- a policy bank may now provide a custom hook as a hash key 'ACTION'.
  On loading a policy bank whose ACTION key has an associated value
  being a subroutine reference, the supplied subroutine is called when
  a policy bank is loaded, before its remaining keys/values are copied
  to the current setting. The action routine is passed two arguments:
  a $msginfo (a ref to an object containing all the information about
  a message being processed), and a policy name being loaded. Note that
  $msginfo may be undef if a policy bank is loaded early - before a
  $msginfo object is created, such as with policy banks associated with
  a port number or with client's IP address;

  Example use:
    $policy_bank{'TRUSTED_BOOKSHOPS'} = {
      bypass_spam_checks_maps => [1],
      spam_lovers_maps => [1],
      ACTION => sub { Amavis::Util::do_log(2,'Buying a book?');
                      Amavis::Util::snmp_count64('UserCounter2'); },
    };
    @author_to_policy_bank_maps = ({
      'amazon.com'   => 'TRUSTED_BOOKSHOPS',
      'amazon.co.uk' => 'TRUSTED_BOOKSHOPS',
      'amazon.de'    => 'TRUSTED_BOOKSHOPS',
    });

- a new configuration variable @virus_name_to_policy_bank_maps has been
  introduced. It allows loading of policy banks based on a virus name
  as reported by virus scanners. Reported names converted to spam by a
  @virus_name_to_spam_score_maps are no longer treated as virus names
  and as such are not eligible to @virus_name_to_policy_bank_maps.

  The @virus_name_to_policy_bank_maps is a list of lookup tables. A lookup
  key is each virus name as reported by any virus scanner. A result of a
  lookup is expected to be a string containing a comma-separated list of
  policy bank names. Nonexistent policy banks are ignored. Duplicate names
  are merged into a single name. The most suitable lookup mechanisms are
  a regexp lookup and a hash lookup, as these are able to provide an
  arbitrary user-specifiable result (unlike a list-based (ACL) lookup, which
  can only provide a boolean value). Suggested by Patrick Ben Koetter.

  Example use:

    @virus_name_to_policy_bank_maps = (
      new_RE(  # a regexp lookup
        [ qr'^(W32/MyDoom|W32/Netsky|Mal/BredoZp)' => 'VIRUS,MASS_VIRUS' ],
        [ qr'\bEICAR\b'i => 'EICAR_TEST' ],
      ),
      'VIRUS',  # constant (pseudo)lookup, catchall for any other virus name
    );

    $policy_bank{'VIRUS'} = {
      ACTION => sub { Amavis::Util::snmp_count('UserCounter1') },
    };

    $policy_bank{'EICAR_TEST'} = {
      log_templ => $log_short_templ . ', EICAR test message, not to worry',
      final_destiny_by_ccat  => { CC_VIRUS() => D_BOUNCE },
    };

    $policy_bank{'MASS_VIRUS'} = {  # mute everything using a big hammer
      final_destiny_by_ccat     => { CC_VIRUS() => D_DISCARD },
      warnsender_by_ccat        => { REPLACE => 1 },
      warnrecip_maps_by_ccat    => { REPLACE => 1 },
      quarantine_method_by_ccat => { REPLACE => 1 },
      admin_maps_by_ccat        => { REPLACE => 1 },
      newvirus_admin_maps => [],
      log_templ => 'MASS VIRUS DROPPED, ' . $log_templ,
      ACTION => sub { Amavis::Util::snmp_count('UserCounter2') },
    };

- a policy bank may now be loaded based on a path name of a Unix socket
  receiving a connection.

  Example use:

    @listen_sockets = (
      "$helpers_home/amavisd.sock1",
      "$helpers_home/amavisd.sock2",
      "$helpers_home/amavisd.sock3",
    );

    $interface_policy{"$helpers_home/amavisd.sock1"} = 'UX-S1';
    $interface_policy{"$helpers_home/amavisd.sock2"} = 'UX-S2';
    $interface_policy{"$helpers_home/amavisd.sock3"} = 'UX-S3';

    $policy_bank{'UX-S1'} = { ... };
    $policy_bank{'UX-S2'} = { ... };
    $policy_bank{'UX-S3'} = { ... };

- transparent archival quarantine is a special case of archive quarantining
  which retains all recipient addresses unmodified in an envelope of a message
  directed to a quarantine. It makes sense when $archive_quarantine_method
  specifies protocols 'smtp:' or 'lmtp:' or 'bsmtp:' and a dedicated server
  is used which guarantees these quarantined messages will *not* be delivered
  to recipients in the envelope.

  Transparent archiving is used when $archive_quarantine_to (actually the
  @archive_quarantine_to_maps) results in a reserved string '%a' for all
  recipients.

  Think of the '%a' as a placeholder in a replacement string, being
  substituted by a full original recipient address. There may be other
  substitution placeholders available in the future, equivalent to
  placeholders %l, %d, etc. in SQL query templates.

  Example:
    $archive_quarantine_method = 'smtp:127.0.0.1:7777';
    $archive_quarantine_to = '%a';
    @archive_quarantine_to_maps = (\$archive_quarantine_to);

  or:
    $archive_quarantine_method = ['smtp:[::1]:7777', 'smtp:127.0.0.1:7777'];
    @archive_quarantine_to_maps = (
      { '.example.com' => '%a',
        '.example.net' => '%a',
        '.example.org' => 'quarantine@example.org',
        '.' => undef,
      }
    );

  The envelope sender address of messages sent to an archival quarantine
  is still controlled by the $mailfrom_to_quarantine setting as before.
  When this value is undef (which is a default) the envelope sender address
  remains unchanged - is the same as in a received message. Any other value
  replaces the original sender address, so an empty string implies a null
  return path.

  When delivering quarantine messages to a dedicated SMTP server it must be
  ensured that the receiving server will not bounce or reject quarantine
  messages or deliver them to recipients specified in the SMTP envelope!

  If a receiving SMTP server announces a DSN capability in its response
  to EHLO, amavisd will add option NOTIFY=NEVER with each recipient
  to prevent potential backscatter. This is an additional safeguard to
  prevent potential backscatter, therefore it is recommended that the
  receiving quarantine server implements and announces the DSN capability.
  Specifying an empty string for the $mailfrom_to_quarantine achieves the
  same effect (a null return path implies NOTIFY=NEVER) thus preventing
  backscatter, but loses original sender address in the envelope.

  Suggested by Patrick Ben Koetter.

- as a convenience, two pre-defined logging templates are provided:
  $log_short_templ and $log_verbose_templ. The former is the same as was
  a default $log_templ in previous versions, the later is quite verbose
  and provides most of the interesting information about a message.
  An initial value of $log_templ is taken from the $log_short_templ.
  To change $log_templ, either assign a new template directly as before,
  or, as a shorthand if $log_verbose_templ is appropriate, just assign it,
  e.g.:
    $log_templ = $log_verbose_templ;

- added a configuration variable @debug_recipient_maps. Similarly to
  @debug_sender_maps, a debug level logging is temporarily turned on for
  the duration of processing of this message when a recipient address
  matches a list of lookup tables @debug_recipient_maps;
  suggested by Patrick Ben Koetter;

- internal: a delivery_method() is now a property of a recipient instead
  of being a property of a message as a whole. This makes per-recipient
  forwarding method selection possible. When recipients of a multi-recipient
  message specify different forwarding methods, a message is forwarded in
  multiple transactions, one for each unique delivery_method() setting;
  i.e. recipients are clustered into sets with the same delivery_method
  setting and a message for each subset of recipients if forwarded as one
  transaction;

- finer custom control over the forwarding method is available through a
  before_send() custom hook which may override the $r->delivery_method(...)
  for all or just some of the recipients with whatever forwarding method
  specification is suitable - for example a next-hop server's IP address or
  its port number can be chosen based on spam score or based on a sender
  domain or some other characteristics of a message or of a recipient;

- a new configuration variable @forward_method_maps (along with making
  a delivery_method() a property of a recipient instead of being a property
  of a message) makes per-recipient forwarding method selection possible;
  suggested by Ralf Hildebrandt;

  Example:
    @forward_method_maps = ({  # use lowercase keys with hash-type lookups!
      'user@example.com'  => 'smtp:[::1]:10025',
      '.sub1.example.com' => 'smtp:[::1]:10026',
      '.sub2.example.com' => 'smtp:[::1]:10027',
      '.example.net' =>   'smtp:[127.0.0.1]:10025',
      '.example.org' => [ 'smtp:[192.0.2.9]:125', 'smtp:[2001:db8::f]:125' ],
      '.'            => $forward_method,
    });

- a new configuration variable %forward_method_maps_by_ccat allows the
  forward_method_maps to depend on content type and allows per-recipient
  specification of a forward method, such as specifying a next hop MTA's
  IP address and port number. This offers new possibilities to control
  mail routing for purposes like implementing sender reputation schemes
  which dynamically choose an SMTP source IP address (typically of
  outgoing mail) based on the contents of a mail message or based on
  recipient's e-mail address or domain. This needs to be complemented
  by a suitable configuration of an MTA, such as Postfix 2.7.0 or later.
  The default is to use the $forward_method setting, ensuring compatibility.
  There is no need to specify entries for content types which are not being
  forwarded (often: CC_VIRUS, CC_BANNED, CC_SPAM).

  Example use:

    $forward_method = 'smtp:[127.0.0.1]:10025';

    %forward_method_maps_by_ccat = (
      CC_BADH.',3',  [ 'smtp:*:10027' ],
      CC_BADH.',4',  [ 'smtp:*:10027' ],
      CC_BADH.',5',  [ 'smtp:*:10027' ],
      CC_BADH.',6',  [ 'smtp:*:10027' ],
      CC_BADH.',8',  [ 'smtp:*:10027' ],
      CC_SPAMMY,     [ 'smtp:[192.0.2.22]:10025' ],
      CC_CATCHALL,   sub { ca('forward_method_maps') },
    );

- added a global configuration setting $allow_preserving_evidence, defaults
  to true. Turning it off disables preserving temporary files (as evidence)
  in case of trouble, which is potentially useful for unattended and
  unmonitored operation. The setting has no influence on preserving evidence
  in case of @debug_sender_maps or @debug_recipient_maps triggering, which
  always preserves evidence;

- an entry for CC_UNCHECKED was added to %admin_maps_by_ccat, defaulting
  to @virus_admin_maps. Hence administrator notifications are also sent
  for messages which cannot be decoded (e.g. are encrypted or contain
  a mangled archive) if virus administrator notifications are enabled.
  To turn off sending administrator notifications for unchecked contents:
    delete $admin_maps_by_ccat{&CC_UNCHECKED};

- to avoid a need to directly manipulate the *_by_ccat settings, a set
  of individual configuration variables associated with CC_UNCHECKED
  contents category was added, with their default values compatible
  with earlier versions of amavisd:
    $final_unchecked_destiny = D_PASS;
    $unchecked_quarantine_method = undef;
    $unchecked_quarantine_to = 'unchecked-quarantine';
    @unchecked_quarantine_to_maps = (\$unchecked_quarantine_to);
    LDAP attribute: amavisUncheckedQuarantineTo
    SQL field:      unchecked_quarantine_to

- a failure of all virus scanners no longer automatically tempfails the
  operation, but flags a message with a CC_UNCHECKED contents category
  (just like a failure of decoders/dearchivers), and allows the usual
  controls (*_destiny, *_quarantine_*) to be used to choose behaviour;
  for example:
    $final_unchecked_destiny = D_TEMPFAIL;
    $unchecked_quarantine_method = 'local:unchecked/%m.gz';

  To revert to a previous behaviour where a failure of all virus scanners
  resulted in a temporary failure, set the $virus_scanners_failure_is_fatal
  to true, e.g.:
    $virus_scanners_failure_is_fatal = 1;
  The setting $virus_scanners_failure_is_fatal is a member of policy banks.

- support decompression of a .xz file format and legacy .lzma file formats
  through XZ Utils ( http://tukaani.org/xz/ ) if an entry with a decoding
  program is found in the @decoders list; it defaults to finding a program
  'xz' or 'xzdec' in the $path ;

- added two new functions: iso8601_year_and_week() and iso8601_yearweek()
  to accompany the existing function iso8601_week();  they all provide
  a week-of-the-year number (ISO 8601 / EN 28601, 1..53, in local time zone)
  given a Unix timestamp (seconds since 1970-01-01T00:00Z) as an argument,
  optionally together with the corresponding year number. The result is an
  integer or a pair of integers as follows:

    $w = iso8601_week($unix_time);                 # e.g.  49
    $yw = iso8601_yearweek($unix_time);            # e.g.  201049
    ($y, $w) = iso8601_year_and_week($unix_time);  # e.g. (2010,49)

  Semantics is equivalent to PostgreSQL extract(week from ...), and
  to MySQL week(date,3). These functions can be useful for assigning
  to a $partition_tag (in amavisd.conf), e.g.:
    $partition_tag =
      sub { my($msginfo)=@_; iso8601_week($msginfo->rx_time) };
  or:
    $partition_tag =
      sub { my($msginfo)=@_; iso8601_yearweek($msginfo->rx_time) };

  or based on a day of a week for short-term cycling (Mo=1, Tu=2,... Su=7):
    $partition_tag =
      sub { my($msginfo)=@_; ((localtime($msginfo->rx_time))[6]+6)%7+1 };
  (a note from a future: starting with 2.8.0 the following is equivalent:
    $partition_tag =
      sub { my($msginfo)=@_; iso8601_weekday($msginfo->rx_time) };
  )

  Suggested by Michael Scheidell.

- the two placeholders %k and %a in templates for SQL lookup clauses
  $sql_clause{'sel_policy'} (i.e. $sql_select_policy) and
  $sql_clause{'sel_wblist'} (i.e. $sql_select_white_black_list)
  were augmented by four new placeholders: %l, %u, %e, and %d,
  potentially facilitating forming of more complex SQL queries;
  suggested by Marco Fretz.

  The following replacements are made:
    %a -> exact/unmodified e-mail address (same as the first entry in %k)
    %l -> full unmodified localpart (all up to, but not including the '@')
    %u -> lowercased username (a localpart without extension)
    %e -> lowercased address extension (including a delimiter), if any
    %d -> lowercased domain (without '@')
    %k -> a list of lookup strings, as before (see below)

  For example, given an e-mail address: User+Foo@Sub.Example.COM
  the placeholders would be substituted by:

    %a  User+Foo@Sub.Example.COM
    %l  User+Foo
    %u  user
    %e  +foo
    %d  sub.example.com

    %k  User+Foo@sub.exAMPLE.COM
        user+foo@sub.example.com
        user@sub.example.com
        user+foo
        user
        @sub.example.com
        @.sub.example.com
        @.example.com
        @.com
        @.

- per-recipient (or per- policy bank, or global) SpamAssassin configuration
  files or SQL configuration sets are now supported (the @sa_userconf_maps
  setting, a policy.sa_userconf SQL field). A multi-recipient message whose
  recipients map to different configuration sets will be checked by calling
  SpamAssassin multiple times, once for each unique SpamAssassin configuration
  set. A configuration set is either a filename, or a set of SQL records
  obtained from SpamAssassin's user_scores_dsn SQL database by calling its
  method load_scoreonly_sql().

  A lookup on a list of lookup tables @sa_userconf_maps may return undef
  or an empty string implying no user preferences file, or may provide a
  file name (absolute path, or relative to $MYHOME) of a SpamAssassin's
  'user preferences' configuration file, or may start with a string 'sql:'
  which implies loading user preferences from a user_scores_dsn SQL database
  (as declared in a SpamAssassin's configuration file) for a username
  provided by a lookup on @sa_username_maps (see further down).

  SpamAssassin will be requested to load a user preferences configuration
  through its read_scoreonly_config() or load_scoreonly_sql() method, which
  otherwise (in spamd) serves to load user's .spamassassin/user_prefs file
  or SQL preferences when switching users. See SpamAssassin documentation
  file sql/README for SQL details.

  SpamAssassin's SQL database is only consulted if user_scores_dsn is
  declared in a SpamAssassin configuration file, and the @sa_userconf_maps
  returns a string starting with 'sql:' (case insensitive, the rest of the
  string is currently ignored). If a username as provided by a lookup on
  @sa_username_maps equals the username under which amavisd was started,
  SpamAssassin's SQL preferences for that username will not be loaded - it
  is assumed that preferences for a default username are empty, i.e. that
  it uses a default SpamAssassin configuration.

  Each time that currently loaded configuration needs to be replaced
  by another or restored to a systemwide default, an initial SpamAssassin
  configuration is restored through SpamAssassin's copy_config() method.

  Note that saving an original SpamAssassin configuration, loading a user
  configuration, and restoring to the original configuration does not come
  cheap: it can take 200 ms for a load and restore, and 370 ms for the
  initial saving of the configuration (saving is only done once per child
  process, and only if needed). Saved configuration can occupy additional
  2 MB of virtual memory, so use the feature sparingly. No penalty occurs
  until a child process does its first loading of a user configuration, so
  rarely activated or inactive policy banks or per-recipient setting using
  this feature do not cause any additional processing or occupy additional
  memory.

  According to SpamAssassin documentation, a user preferences file or SQL
  preferences can include scoring options, scores, whitelists and blacklists,
  etc. If 'allow_user_rules' is enabled (local.cf), then user preferences
  file can also include rule definitions and privileged settings - but not
  administrator settings.

  The feature is only available since SpamAssassin 3.3.0.

  Example:
    @sa_userconf_maps = (
      { 'user1@example.com' =>
          '/etc/mail/spamassassin/special_user_config',
        '.example.org' => 'sql:',
      }
    );

  Based on a suggestion by Alexander Wirt and initially based on his patch;

- added a global configuration setting $sa_num_instances with a default
  value of 1, which is the only sensible setting for sites not using
  per-recipient SpamAssassin configuration switching (as described in
  the previous section).

  The $sa_num_instances controls the number of Mail::SpamAssassin objects
  (instances) created by a parent amavisd process during a startup. Each
  SpamAssassin instance does its own initialization (loading of rules and
  configuration settings) during a program startup and occupies a sizable
  portion of virtual memory (like 7 MB on a 64-bit platform with SA 3.4
  rules).

  When switching SpamAssassin configurations (@sa_userconf_maps), and given
  more than one instance of the Mail::SpamAssassin object, amavisd has a
  choice of picking an instance which may already have loaded a selected
  user configuration file previously, and thus save some time by not having
  to store and reload SpamAssassin state again. This may be beneficial
  for example when a sizable portion of users use a default SpamAssassin
  configuration, while other users need a per-user or per-domain preferences
  settings;

  Note that as of SpamAssassin 3.3.2 some features (like compiled rules)
  are global and not a property of a SpamAssassin instance object.
  The problem is tracked in the SpamAssassin project as Bug 6236.
  Until this is resolved please consider the feature experimental.

- per-recipient (or per- policy bank) SpamAssassin SQL database usernames
  are supported (setting @sa_username_maps, a policy.sa_username SQL field).
  This makes it possible to implement per-user or per-user-group or
  per-domain Bayes databases when SpamAssassin is configured to keep
  its Bayes database on an SQL server. It also makes it possible to load
  per-recipient SpamAssassin preferences (configurations) from an SQL
  database (as described in a previous section).

  Switching between Bayes usernames is cheap compared to switching between
  SpamAssassin configuration files.  A multi-recipient message whose
  recipients map to different usernames will be checked by SpamAssassin
  multiple times, once for each unique username;

  Example:
    @sa_username_maps = (
      { 'user1@example.com' => 'user1',
        'user2@example.com' => 'user2',
        '.example.com'      => 'user_ex',
      }
    );

- passes a value of $originating flag to SpamAssassin through its
  suppl_attrib argument in a $spamassassin->parse call; it is expected
  that this information would be treated by SpamAssassin 3.4.0 similarly
  to msa_networks;

- a new configuration variable $mail_id_size_bits allows setting the size
  of randomly generated mail_id and secret_id codes which are used to
  identify a message on releasing it from a quarantine, and are used as a
  key when logging to SQL (pen pals) or storing to quarantine. The variable
  specifies a length of mail_id in bits, and must be an integral multiple
  of 24 (i.e. must be divisible by 6 and by 8). The mail_id is represented
  externally as a base64url-encoded string of $mail_id_size_bits / 6
  characters, and internally as a string of $mail_id_size_bits / 8 octets.
  The default value is 72 bits, as in previous versions.
  Sensible values are 48, 72 and 96 bits.

  See entry "introduce a concept of 'mail_id'" in amavisd-new-2.3.0 release
  notes for probability analysis of collisions. The default size should fit
  all practical current needs.

  The size of SQL fields msgs.mail_id, msgs.secret_id, msgrcpt.mail_id and
  quarantine.mail_id may need increasing to accommodate $mail_id_size_bits/6
  characters if using a non-default value of $mail_id_size_bits.
  See also the next entry regarding a type for these fields.

- SQL fields msgs.mail_id, msgs.secret_id, msgrcpt.mail_id and
  quarantine.mail_id must be treated case-insensitively. A suitable data
  type for these fields in PostgreSQL is bytea, and varbinary in MySQL
  (of size 12 or 16 characters). In order not to lose entropy in mail_id,
  and not to increase a probability of collisions, please check existing
  database schema and adjust as necessary, either a data type, or chose
  a case-sensitive collation setting. See README.sql-pg and README.sql-mysql
  for an ALTER command to change data type of these fields.

- added optional SQL and LDAP lookups for @spam_tag3_level_maps
  (sql field: policy.spam_tag3_level, ldap attribute: amavisSpamTag3Level),
  and for @spam_subject_tag3_maps (sql field: policy.spam_subject_tag3,
  ldap attribute: amavisSpamSubjectTag3); suggested by Thomas Johnson;

- added the following LDAP settings to $default_ldap:
    sslversion, clientcert, clientkey, cafile, capath, verify,
    sasl, sasl_mech, sasl_auth_id, localaddr, scheme, inet6;
  allows bind authentication with a certificate or SASL and allows
  connections to an LDAP server over IPv6;
  based on a patch by Christian Roessner;

- added macros ADDEDHEADERHAM and ADDEDHEADERSPAM, which expand
  to newly generated header fields which SpamAssassin prepared for
  insertion into a header section, in case the message is eventually
  declared to be nonspam or spam respectively; this information is
  available from SpamAssassin since version 3.3.0;

- macro 'dkim' now recognizes two additional keywords: 'selector',
  'sig_sd', and 'newsig_sd', see README.customize for details;
  in particular, the 'newsig_sd' allows to add information on newly
  applied signature to a main log entry, and is now included in a
  default log template;

- added a macro 'mime2utf8' which takes a string as its first argument,
  and an optional truncation length as the second. The string is decoded
  as a MIME-Header string (understands Q or B character set encodings
  like =?iso-8859-2?Q?...?=, =?koi8-r?B?...?=) and is converted to UTF-8,
  optionally truncated to the specified size at clean UTF-8 boundaries,
  and returned as a result.  Suggested by Bastian.
  The macro is useful in a logging template or in notification templates
  to decode Subject or From header fields, e.g.:

    [? [:header_field|Subject]||,\
    Subject: [:dquote|[:mime2utf8|[:header_field|Subject]|100]]]#

- added a macro 'client_helo', which provides a client-supplied EHLO/HELO
  domain name of the original SMTP session. The information is obtained
  through an XFORWARD extension to an SMTP protocol as provided by Postfix,
  or through a 'helo_name' attribute in an AM.PDP request.
  Add something like:
    , helo=[:client_helo]#
  to the log template if it needs to be logged. Suggested by Xueron Nee;

- added a macro 'client_addr' which is a synonym for macro 'a';
  the information is obtained through an XFORWARD extension to an SMTP
  protocol as provided by Postfix, or through a 'client_address'
  attribute in an AM.PDP request; if neither of these are available,
  the client's IP address is parsed from a topmost Received header field;

- added a macro 'client_port', yields a TCP source port number of an
  original SMTP session; the information is obtained through an XFORWARD
  extension to an SMTP protocol as provided by Postfix, or through a
  'client_port' attribute in an AM.PDP request.  See RFC 6302;

- added a macro 'client_addr_port' which combines a client's IP address
  and a TCP source port number (if available) of an original SMTP session;
  it is similar to:
    \[[:client_addr]\]:[:client_port]
  or when a port number is not available:
    \[[:client_addr]\]

  This macro is now included in a default main log template, so the TCP
  source port number is logged along its IP address. This information is
  useful in reporting abuse (e.g. client behind a NAT), troubleshooting,
  forensics and law enforcement. If this information is not desired, one
  may assign a customized template to the $log_templ configuration variable.
  See RFC 6302: Logging Recommendations for Internet-Facing Servers.
  Suggested by Rok Potočnik.

- added a macro 'banned_parts_as_attr' and an associated per-recipient
  attribute banned_parts_as_attr(); it provides the same information as
  a macro 'banned_parts' and its associated attribute banned_parts(),
  but uses a different syntax, possibly facilitating parsing and reporting
  names or types or location of banned parts.

  The following example illustrates the difference. A result is a single
  string in both cases, wrapped here for clarity, and shows a path in a
  message tree of a banned leaf node:

  a macro 'banned_parts' can yield:

      multipart/mixed |
      application/octet-stream,.rar,Setup1.1.rar |
      .exe,.exe-ms,setup.exe

  while a macro 'banned_parts_as_attr' yields:

      P=p003,L=1,M=multipart/mixed |
      P=p002,L=1/2,M=application/octet-stream,T=rar,N=Setup1.1.rar |
      P=p007,L=1/2/4,T=exe,T=exe-ms,N=setup.exe

  for the same banned part in a message.

  The single-character attribute names are unchanged from previous versions.
  For documentation, here is a legend:
    P: part's base name, i.e. a file name in a ./parts/ temporary directory
    L: part's location (path) in a mail tree (branch enumeration, top-down)
    M: MIME type as declared in MIME header fields of a message
    T: short part's content type according to a file(1) utility and mapped
       through @map_full_type_to_short_type_maps
    N: declared part names (none, one or more), as declared in MIME header
       fields or in an archive (tar, zip, ...)
    A: part's attributes as follows:
       U=undecodable, C=crypted, D=directory, S=special(device), L=link

- macro 'header_field' and its alias 'HEADER' now has an optional third
  parameter (index), which chooses the header field in case of multiple
  header fields of the same name; the default (-1) is to return the last
  (bottommost) occurrence, as before; see README.customize for details;

- added a macro 'actions_performed', which expands into a comma-separated
  list of words: Accepted, Relayed(Untagged), RelayedTagged, Discarded,
  Rejected, Bounced, NoBounce or TempFailed, followed by a mail flow
  direction word: Inbound, Internal, Outbound or OpenRelay. For brevity
  the 'RelayedUntagged' status appears in this list as 'Relayed'.
  Additionally, the list may include words Quarantined and Archived.
  For multirecipient messages it is possible that the list includes
  more than one combination.

  The purpose of this macro is to augment the bare-bones 'Passed CLEAN'
  or 'Blocked SPAM' in the main log entry. For this purpose the default
  log template now includes this macro call. If the additional information
  is not desired in the log, please assign a customized template to the
  $log_templ configuration variable.

  Some examples of the new log entries:

    Passed CLEAN {RelayedOutbound}, ...
    Passed CLEAN {RelayedInbound}, ...
    Passed CLEAN {RelayedInternal,RelayedOutbound}, ...
    Passed SPAMMY {RelayedTaggedInbound}, ...
    Blocked SPAM {RejectedInbound,Quarantined}, ...
    Blocked INFECTED (Mal/BredoZp-B) {DiscardedInbound,Quarantined}, ...

  Semantics of entries in the 'actions_performed' list corresponds
  to the newly added SNMP variables 1.3.6.1.4.1.15312.2.1.1.19 - .26
  (with the exception that 'RelayedUntagged' counter is abbreviated
  in this macro as 'Relayed'). Please see their detailed description
  in a file AMAVIS-MIB.txt .

- added a macro 'rusage', which expands to a resource usage entry as provided
  by a system service getrusage(2); the argument to the macro should be one
  of the field names in the structure rusage (see getrusage(2) man page),
  e.g. ru_utime, ru_stime, ru_maxrss, ru_ixrss, ru_idrss, ru_isrss,
  ru_minflt, ru_majflt, ru_nswap, ru_inblock, ru_oublock, ru_msgsnd,
  ru_msgrcv, ru_nsignals, ru_nvcsw, ru_nivcsw;  the information is only
  provided if an optional perl module Unix::Getrusage is available;

- SpamAssassin-compatible macros 'YESNO' and 'YESNOCAPS' now optionally
  accept two string arguments, replacing the default strings 'Yes' and 'No'
  in the result;

- settings $enable_dkim_verification and $enable_dkim_signing are now
  dynamic, i.e. became members of policy banks, thus facilitating
  selectively enabling or disabling these features on a policy bank basis;

- internal: added a message property object dkim_signwith_sd() which allows
  custom hooks to provide the DKIM signing code with a selector and a
  domain name preferred for choosing a signing key. If this information is
  not available the signing code will consult an external signing service
  if provided ($dkim_signing_service), or else use the built-in algorithm
  for choosing a signing key. A custom hook may provide the information
  as follows:
    $msginfo->dkim_signwith_sd( ['some_selector', 'some_domain'] );
  After a successful signing, the dkim_signwith_sd will contain a pair
  [selector,domain] which was actually chosen for signing;

- recognize and insert header fields as prepared by SpamAssassin 3.3.0
  or later through its 'add_header' configuration option; some of the
  standard X-Spam-* header fields are still overruled by equivalent ones
  generated by amavisd itself, primarily to provide true per-recipient
  handling;  header field names must still be listed in the associative
  array %allowed_added_header_fields in order to be inserted;
  overrides are configurable through %prefer_our_added_header_fields,
  for example:
    $prefer_our_added_header_fields{lc('X-Spam-Status')} = 0;

- added an attribute 'log_id' to server responses in an AM.PDP protocol,
  allowing the client to match its request with the amavisd daemon logging;

- added LDAP attributes: amavisAddrExtensionVirus,
  amavisAddrExtensionSpam, amavisAddrExtensionBanned, and
  amavisAddrExtensionBadHeader for consistency with SQL;
  suggested by Stefan Palme;

- added LDAP attributes: amavisSpamTag3Level, amavisSpamSubjectTag3,
  amavisUncheckedQuarantineTo, amavisCleanQuarantineTo, amavisUncheckedLover,
  amavisForwardMethod, amavisSaUserConf and amavisSaUserName for consistency
  with SQL;

- added LDAP attribute amavisDisclaimerOptions, along with its corresponding
  SQL field 'disclaimer_options'. It finds its way to the list of lookup
  tables @disclaimer_options_bysender_maps, so the replacement of the
  _OPTIONS_ placeholder in @altermime_args_disclaimer could be made dynamic;
  suggested by Quanah Gibson-Mount;

- for consistencly, added LDAP attribute amavisUncheckedLover, along
  with its corresponding SQL field 'unchecked_lover' and a statical
  list of lookup tables @unchecked_lovers_maps, which appears in the
  %lovers_maps_by_ccat. Previously the CC_UNCHECKED entry of the
  %lovers_maps_by_ccat was (ab)used, and shared the @virus_lovers_maps
  value. Suggested by Patrick Ben Koetter;

- added a variable $myprogram_name, which defaults to a program name
  (perl variable $0), but may be modified in a configuration file typically
  depending on a value of $instance_name. It is used to dynamically change
  a process name in $0, which shows up in a ps(1) and top(1) output on
  most Unix systems. Along with $syslog_ident, it offers a handy way to
  distinguish amavisd instances.

- if running other spam scanners besides SpamAssassin through a @spam_scanners
  mechanism (such as DSPAM or CRM114), make header fields produced by them
  visible to SpamAssassin too, so that its rules can benefit from additional
  information. Note that in order for SpamAssassin to be able to see such
  header fields from other scanners, such scanners must be listed in the
  @spam_scanners list *before* the 'SpamAssassin' entry.  Suggested by Marco.


OPTIMIZATIONS

- rewritten a code section on receiving SMTP/LMTP DATA, replacing perl
  line-by-line reads & processing by reading & processing 32 kB chunks
  of data at a time; as a result, data transfer rate has been increased
  by a factor of about 3.9 for plain text session, and by a factor of 11
  for encrypted (TLS) session.

  Measured data rates of an SMTP DATA transfer between Postfix and amavisd
  on a loopback interface:

  No TLS (no session encryption):
  . amavisd receiving, old code:  8.3 MiB/s
  . amavisd receiving, new code: 32.3 MiB/s
  . amavisd sending:             18   MiB/s

  With TLS (encrypted session, AES256-SHA):
  . amavisd receiving, old code:  1.0 MiB/s
  . amavisd receiving, new code: 11.2 MiB/s
  . amavisd sending:              4.3 MiB/s

- save about 6 MB of virtual memory per amavisd child process by properly
  deleting some larger data items from variables, known not to be reused;
  thanks to the insight of Perl Monks (ikegami) in:
    http://www.perlmonks.org/?node_id=803515

- speed up lookup_ip_acl lookups on larger lists of CIDR network addresses
  (like @mynetworks and @inet_acl list) by using a radix trie (Patricia Trie)
  representation; the patricia trie is used when a module Net::Patricia
  is available and a list contains more than 20 elements; minimal required
  version of Net::Patricia is 1.015;

- avoid entering and exiting a block in most map() and grep() calls saves
  on opcodes, achieving a small reduction of code size and a tiny speedup;

- 'use constant' for CC_* and D_* constants allows perl to inline them;


OTHER

- provide a workaround for a Perl 5.8.9 bug #62502, where O_WRONLY, O_APPEND
  and other Fcntl constants can become tainted; this is an application of
  the same workaround as already applied in 2.6.3, but covers two additional
  code sections; the bug could manifest itself as a taint problem during
  opening a pipe to an external mail submission problem. This only affects
  perl 5.8.9;  the 5.8.8 and 5.10.0 are fine.  Tracked down and a patch
  provided by Petr Rehor;

- RFC 5617 now defines an "Author Domain Signature" as a valid signature
  in which the domain name of the DKIM signing entity, i.e., the d= tag in
  the DKIM-Signature header field, is the same as the domain name in the
  Author Address. The change came with draft-ietf-dkim-ssp-10; previously
  the "Author Domain Signature" was based on an 'i' tag (identity).

  This change is now followed by amavisd-new 2.7.0 in macro 'dkim', in
  evaluation of the @author_to_policy_bank_maps list, in internal attribute
  dkim_author_sig(), and reflected in logging. Similarly, the evaluation of
  @signer_reputation_maps is now based on a signing domain ('d' tag), instead
  of the 'i' tag as previously. The change only affects signatures where
  the domain name of a signing identity is a subdomain of a signing domain
  (not identical to the signing domain), which is rare in current practices.

- updated generating and parsing of Authentication-Results headear
  field according to RFC 5451 and RFC 6008 - previously it followed
  a draft-kucherawy-sender-auth-header. This header field is now also
  inserted for new DKIM signatures as just-generated and inserted to a
  passed internal-to-internal message when it is eligible for signing;
  suggested by Florian Effenberger.

- added a setting $myauthservid, also a member of policy banks, which
  controls the "authserv-id" token in the Authentication-Results header
  field, according to RFC 5451. Its default value is $myhostname as before.
  Its value must comply with the RFC 5451 syntax ("dot-atom"). Having a
  separate control may facilitate setups where a message is processed by
  amavisd more than once, e.g. for DKIM signing of a mailing list fanout
  messages, where the second pass should not remove an Authentication-Results
  header field from a first pass.

- updated ARF notifications to RFC 5965 (An Extensible Format for Email
  Feedback Reports); the $report_format = 'arf' implementation was based
  on ARF draft, now it complies with RFC 5965;

- tightened some sanity limits on DKIM verification to better handle
  mail messages with a huge number of signatures; problem reported
  by Tuomo Soini;

- amavisd.conf: added file types ini, lib, ocx, sys, vxd to the commented-out
  long list of file types in $banned_filename_re, along with a commented-out
  list of type names for consideration: asd, asf, asx, url, vcs, wmd, wmz;

- updated default @virus_name_to_spam_score_maps with new or changed entries:
    [ qr'^(Heuristics\.)?Phishing\.'     => 0.1 ],
    [ qr'^Doppelstern\.(Scam4|Phishing)' => 0.1 ],
    [ qr'^ScamNailer\.Phish\.'           => 0.1 ],
    [ qr'^HTML/Bankish'                  => 0.1 ],
  thank to Giampaolo Tomassoni for Heuristics.Phishing and HTML/Bankish;

- when inserting a subject tag into a Subject header field, remove
  existing copies of the same string first to avoid subjects like
  "***UNCHECKED*** Fwd: ***UNCHECKED*** Re: foo bar" ;  based on a
  patch by Thomas Arendsen Hein;

- p0f-analyzer.pl: convert an 'IPv4-mapped IPv6 addresses in alternative
  form' to an IPv4 address, otherwise the p0f-analyzer.pl would ignore
  such queries, as the p0f daemon did not handle IPv6 until version 3.
  The 'IPv4-mapped IPv6 addresses' is returned for an IPv4 connection
  when TCP/IP stack is configured to allow inet6 sockets to accept inet
  sessions; problem reported by Vytautas Kasparavicius;

- suppress generating a non-delivery notification if a SpamAssassin test
  DKIM_ADSP_DISCARD is hit, honouring RFC 5617;

- amavisd.conf: commented-out calls to do_ascii to match defaults in the
  amavisd program; the uulib code (as invoked by Convert::UUlib) has a
  history of stability problems, seems it is causing more grief compared
  to the benefits it brings;

- new AV entry for 'Avira for UNIX 3.x', thanks to g0rbi, Thomas Mueller,
  Steffen Ille, Klaus Fuerstberger and Andreas Schulze;

- add three more exception cases to mercifully ignore an EBADF I/O error
  due to a Perl bug on line-by-line reading;

- entries 'SpamAssassin' and 'SpamdClient' in the @spam_scanners list
  now recognize options 'mail_body_size_limit' and 'score_factor', to match
  their behaviour with 'DSPAM' and 'CRM114' entries;

- dropped a logging level (from -1 to 2) on a warning message:
    INFO: dot-stuffing error (only one leading dot): ...
  as Postfix in a pre-queue proxy filtering setup does not do any dot-stuffing
  sanitation, so garbage in the DATA section as received by a Postfix smtpd
  service comes unchanged to a proxy filter; reported by Ralf Heidenreich,
  confirmed by Victor Duchovni and Wietse Venema;

- use module File::Temp to create a temporary working directory, instead
  of using a home-brewed code; as a result, these directory names are now
  a bit longer;

- avoid slurping the whole directory contents into memory when recursively
  tidying, removing, or checking a temporary directory, when purging old
  database files on a restart, and when preparing a list of files to be
  scanned;

- collect a couple of random bytes from /dev/urandom (if available)
  at a start of the main process and at each child process birth (when
  our entropy pool is rather depleted), then stir our entropy pool and
  perl's srand() to prevent File::Temp from working with the same
  pseudorandom sequence in each child process;

- reworked fetching random bits from entropy pool and deriving mail id
  from secret id (after re-reading RFC 4086); much less of the private
  entropy accumulator is now exposed to observers; added a new function
  fetch_entropy_bytes(), dropped a function fetch_entropy();

- a macro %S no longer corresponds to sender_contact, which was a relict
  from times of early viruses; for compatibility with existing templates
  it is now equivalent to %s, but should no longer be used and might be
  retired or re-purposed with the next version;  default notification
  templates were adjusted accordingly - please adjust your customized
  templates if using them;

- drop dependency on Digest::SHA1;

- README.chroot: document that sa-update needs to update rules in the jail
  and refresh the text somewhat; thanks to Francois Rolland;


CLEANING

- retired often misused settings $warnvirussender and $warnspamsender
  (but kept marginally useful $warnbannedsender, $warnbadhsender, and their
  parent %warnsender_by_ccat). To bounce or reject viruses and spam use
  D_REJECT and D_BOUNCE settings for corresponding $final_*_destiny. It
  is no longer supported to both deliver (D_PASS) a virus or spam message
  while also sending a notification to sender. Both retired variables are
  still declared for compatibility with old config files, but their value
  is ignored. An attempt to set their value to a non-default value produces
  a warning.

- retired a setting $syslog_priority, it was not particularly useful since
  the introduction of dynamic syslog priorities with amavisd-new-2.0 .
  The new behaviour is equivalent to a previous $syslog_priority='debug';
  The variable is still declared for compatibility with old config files,
  but its value is ignored. An attempt to set its value to a non-default
  value produces a warning.

- retired a setting $SYSLOG_LEVEL, it was obsoleted by amavisd-new-2.4.0;
  please use the setting $syslog_facility instead, defaulting to
  $syslog_facility='mail' . The variable $SYSLOG_LEVEL is still declared
  for compatibility with old config files, but its value is ignored.
  An attempt to set its value to a non-default value produces a warning.

- renamed $DO_SYSLOG to $do_syslog, and $LOGFILE to $logfile; old names
  are kept as aliases for compatibility;

- retired a setting $relayhost_is_client, it became obsolete with
  amavisd-new-2.0.  Please use a '*' in place of a host IP address and
  port number when amavisd should pass a checked mail message back
  to the same host from which the request came, e.g.:
    $forward_method = 'smtp:*:*';
  The variable is still declared for compatibility with old config files,
  but its value is ignored. An attempt to set its value to a non-default
  value produces a warning.

- retired a setting $sa_timeout, the variable is still declared for
  backward compatibility, but has no effect. Instead, the time available
  for spam scanning is automatically determined from $child_timeout,
  taking into consideration the actual time left till the deadline;
  An attempt to set its value to a non-default value produces a warning.

- retired a setting $sa_spam_report_header, it was obsoleted in
  amavisd-new-2.4.3 with the introduction of %allowed_added_header_fields.
  To enable insertion of X-Spam-Report header field, please use instead:
    $allowed_added_header_fields{lc('X-Spam-Report')} = 1;
  The variable is still declared for compatibility with old config files,
  but its value is ignored. An attempt to set its value to a non-default
  value produces a warning.

- retired settings $sa_spam_modifies_subj and @spam_modifies_subj_maps.
  Disabling insertion of spam tag into a Subject header field can be achieved
  by turning off the corresponding entries in %subject_tag_maps_by_ccat:
    undef $subject_tag_maps_by_ccat{CC_SPAM()};
    undef $subject_tag_maps_by_ccat{CC_SPAMMY.',1'};
    undef $subject_tag_maps_by_ccat{CC_SPAMMY()};
    undef $subject_tag_maps_by_ccat{CC_CLEAN.',1'};
  or by emptying corresponding lists of lookup tables, e.g.:
    @spam_subject_tag_maps  = ();
    @spam_subject_tag2_maps = ();
    @spam_subject_tag3_maps = ();
  or individually (by-recipient) by specifying suitable lookup tables in
  @spam_subject_tag_maps / @spam_subject_tag2_maps / @spam_subject_tag3_maps,
  either statically, or through SQL or LDAP lookups;
  Both settings are still declared for compatibility with old config files,
  but their value is ignored. An attempt to set the value of a variable
  $sa_spam_modifies_subj to a non-default value produces a warning.

- retired a setting $insert_received_line, it was obsoleted in
  amavisd-new-2.4.3 with the introduction of %allowed_added_header_fields.
  To disable insertion of a Received header field, please use instead:
    $allowed_added_header_fields{lc('Received')} = 0;
  The variable is still declared for compatibility with old config files,
  but its value is ignored. An attempt to set its value to a non-default
  value produces a warning.

- retired a setting $notify_xmailer_header, the X-Mailer header field is
  not inserted into notifications, as was a default. The variable is still
  declared for compatibility with old config files, but its value is ignored.
  An attempt to set its value to a non-default value produces a warning.

- retired a setting $sa_auto_whitelist, it became obsolete with
  amavisd-new-2.1.0 and SpamAssassin 3.0.0 (released in 2004)
  by a 'use_auto_whitelist 1' option in local.cf . The variable is still
  declared for compatibility with old config files, but its value is ignored.
  An attempt to set its value to a non-default value produces a warning.

- retired a deprecated macro 'x-mailer', use macros 'header_field' or
  'useragent' instead;

- removed a constant CC_TEMPFAIL, it was retired with amavisd-new-2.5.0;

- renamed a configuration variable $sql_partition_tag to $partition_tag
  in order to reflect its more general usage outside of SQL; the old name
  $sql_partition_tag is retained for compatibility and is an alias for
  $partition_tag;

- dropped compatibility of $final_*_destiny settings with old numerical
  values (used by versions of amavisd older than amavisd-new-20030314);

- internal: retire Amavis::In::Message::client_addr_mynets, no longer in use;
- internal: retire Amavis::In::Message::sender_contact, no longer in use;
- internal: retire Amavis::In::Message::PerRecip::infected, no longer in use;

- internal: drop a redundant argument $conn from the following subroutines:

    make_received_header_field, check_header_validity, defanged_mime_entity,
    msg_from_quarantine, check_amcl_policy, postfix_policy,
    add_forwarding_header_edits_common, add_forwarding_header_edits_per_recip,
    prepare_modified_mail, do_notify_and_quarantine, do_quarantine,
    save_info_preliminary, save_info_final, mail_dispatch,
    dispatch_from_quarantine, virus_scan, spam_scan, white_black_list,
    Amavis::SpamControl::{ExtProg,SpamdClient,SpamAssassin}::check

  As a compatibility measure, the do_quarantine() may still be called
  with or without the first argument $conn, its value is now ignored
  if present.

  Although the $conn argument is also redundant in calls to custom hooks
  (as this information is available through $msginfo->conn_obj), these
  calls are left unchanged for compatibility with existing custom hooks.


---------------------------------------------------------------------------
                                                               May 18, 2011
amavisd-new-2.6.6 release notes

This version is strictly a maintenance release, it incorporates bug fixes
backported from 2.7.0-pre* series and/or posted as patches to the mailing
list.


BUG FIXES

- amavisd-release was not sending a 'mail_file' attribute when a quarantined
  message was a non-compressed file in a single-level directory quarantine
  (not SQL-based), causing a release failure; reported by Jarno Huuskonen;

- quarantining to SQL was sporadically failing, reporting some unrelated
  random error (like 'not available' or 'OpenSSL error: header too long');
  reported by Tonio;

- avoid a warning "_WARN: Use of uninitialized value in string eq at ...
  line 275." when an SQL-based white/black-listing is used;
  reported by Tonio;

- wrap the sql clause  SET NAMES 'utf8'  so that only a warning at
  a log level 2 is issued if an SQL server does not understand the
  command (SQLite, old versions of MySQL) instead of aborting;
  reported by Roland Holzner;


---------------------------------------------------------------------------
                                                              April 7, 2011
amavisd-new-2.6.5 release notes

This version is strictly a maintenance release, it incorporates bug fixes
backported from 2.7.0-pre* series and/or posted as patches to the mailing
list.


BUG FIXES

- when a back-end MTA rejected a message, amavisd would send a non-delivery
  status notification, but also propagate the reject status back, which is
  wrong, only one or the other response would be appropriate. A fix also
  allows choosing either a D_REJECT, D_BOUNCE or D_DISCARD response for
  such a case, configurable through %final_destiny_by_ccat at a CC_MTA
  entry, defaulting to D_REJECT; reported by Peer Heinlein;

- checking header section syntax could take excessive amounts of time
  in some degenerate cases of a very long header section, now fixed;

- do not bypass spam checking of a bounce message when its referenced domain
  in Message-ID is non-local but pen pals are disabled; reported by Stefan;

- removed some of the guesswork in bounce killer to prevent false
  positives in certain cases of forwarding a mail message as an attachment,
  at the expense of passing through some undesired but nonstandard bounces;
  (also, deal with non-delivery notifications from yahoogroups.com,
  and fixed one particular case of a false-positive in bounce killer
  (mixed/multipart with an attached full message, sent through a mailing
  list);

- fixed a 'Zoo archive' entry in the $map_full_type_to_short_type_re list;

- fixed a test for $myhostname being a FQDN to allow IDN domains (with a dash);

- fixed a REPLACE hack (feature introduced in 2.6.2) on loading a policy bank;

- fixed choosing the module IO::Socket::INET in ask_daemon_internal() to
  avoid versions of IO::Socket::INET6 older than 2.55 (2.56?) failing with
    "Address family not supported by protocol family"
  when an IPv4 address with a port number is specified for connections
  to a virus scanner; based on a patch by Phil Pearl (Lobbes);

- do_unzip: avoid testing a version of Compress::Raw::Zlib, the module may
  not be loaded at all and the test would fail, resulting in inoperative
  zip unpacking; reported by Tuomo Soini;

- when logging or quarantining to SQL, execute a clause: SET NAMES 'utf8'
  after connecting to a database to ensure the decoded Subject and From
  header fields are correctly interpreted by an SQL server as UTF-8 encoded
  strings. It seems the module DBD::mysql does not observe a MySQL setting
  for 'character_set_client' and needs an explicit SET NAMES. The problem
  did not affect PostgreSQL. Reported by Zhang Huangbin;

- avoid LDAP lookups aborting the scan when a %d placeholder is used
  in a $default_ldap{base} setting and the resulting base does not exist
  in an LDAP schema; reported by Zhang Huangbin;

- the amavisd-new 2.6.3 relaxed semantics of a number of hard links on a
  directory in TempDir::prepare(_dir), but left out an equivalent change
  necessary in TempDir::check, which is now fixed; the change only affects
  certain file system (like the one used on Mac OS X);

- treat an empty PID file or a junk one-liner file the same as a nonexistent
  PID file; previously an empty PID file (e.g. after an unclean shutdown)
  would prevent amavisd from starting; problem reported by Michael Scheidell;

- changed amavisd-release to only provide a 'quar_type' attribute in its
  request when it is reasonably sure of its appropriate value, otherwise
  leave the decision to the amavisd daemon; this solves releasing from a
  file-based quarantine when compression is not used and all files are at
  the top directory; reported by Voytek Eymont;

- provide a workaround for a [perl #62048] bug affecting versions of perl
  older than (approx) 5.12.3, when a banning check if using rules in
  $banned_namepath_re and a lookup_re() could abort with an:
    Unwarranted "Malformed UTF-8 character"
  on certain tainted mail part names (with a valid UTF-8 representation);
  reported by Jakob Curdes;

- provide a workaround for logging to syslog using an old version of
  Unix::Syslog which didn't prepare and keep its own copy of the 'ident'
  argument on a call to openlog(3); thanks to Bill Landry;


OTHER

- ensure compatibility with a new version 5.500 of MIME-Tools, which changed
  the way mime attributes content-disposition.filename and content-type.name
  are decoded, now properly respecting their declared encodings (character
  set). As a result, the declared (recommended) file names of MIME parts are
  now represented as native Perl character strings (Unicode), and as such
  may also end up in reported names of banned parts. Regular expressions
  in @banned_filename_maps, $banned_filename_re and $banned_namepath_re
  may also see these strings as native Perl characters, along with their
  MIME-encoded form. The change also affects interpretation of names with
  earlier versions of MIME-Tools, making them behave more like the 5.500.

- amavisd.conf: exclude names starting with 'cid:' from matching the
  double extensions banning rule, avoiding false positives;

- a small update to a default @virus_name_to_spam_score_maps;

- the 'originating' flag is now passed on to SpamAssassin through its
  %suppl_attrib argument - potentially useful with current trunk version
  of SpamAssassin (treats originating mail submission as a MSA submission),
  and ignored by older versions;

- some documentation updates;
  the RELEASE_NOTES file is now encoded as UTF-8, instead of ISO-8859-1;


---------------------------------------------------------------------------
                                                              June 25, 2009
amavisd-new-2.6.4 release notes


NOTE: When upgrading Perl to version 5.10 or planning to do so, please do
not forget to add a missing /m flag to regular expressions in your existing
AV entries (if you haven't already done so with a 2.6.3 upgrade), as
suggested in an example file amavisd.conf in a package.  Perl 5.8 does
not mind missing /m flags, but with perl 5.10 the results from a virus
scanner may no longer be properly recognized. See the BUG FIXES section
in 2.6.3 release notes.


COMPATIBILITY WITH 2.6.3

The output of amavisd-agent and contents of a database snmp.db has changed
according to the now published MIB. Several new SNMP counters were added, a
few retired, and some renamed. If you are parsing the output of amavisd-agent
or accessing snmp.db directly, please review AMAVIS-MIB.txt, and perhaps
switch to using the new amavisd-snmp-subagent.


BUG FIXES

- amavisd failed to start when spam scanning was disabled either
  by @bypass_spam_checks_maps=(1) or by @spam_scanners=(), giving:
    Can't locate object method "new" via package "Amavis::SpamControl"
  As a workaround one could use a @spam_scanners=(undef) to disable spam
  scanning; reported by Steve;

- several decoders failed to propagate "Exceeded storage quota" exception,
  so the protection of AV scanners against mail bombs was ineffective;
  reported by Jorgen Lundman;

- milter usage (AM.PDP): verbatim header edits inserted a header body of "1"
  instead of the correct string, for example: "Authentication-Results: 1";

- updated AV entry for BitDefender's bdscan to recognize tabs around a colon
  in its output; contributed by Steve;

- fix parsing of a combined result from DSPAM (option --classify), as
  earlier versions of DSPAM did not include a signature with a combined
  result line; problem reported by Marijan Vidmar;


NEW FEATURES SUMMARY

- provide a true SNMP agent and a MIB, facilitating monitoring the health
  of a content filtering system, its performance and mail characteristics;

- a new AV interface to SMTP-based antivirus scanners;

- allow customizing SMTP-status response reason text for blocked messages;

- prevent inserting fake copies of certain important mail header fields
  without breaking a DKIM signature;


NEW FEATURES

- newly supplied with the package is a program amavisd-snmp-subagent,
  acting as an SNMP AgentX, exporting amavisd statistical counters database
  (snmp.db) as well as a child process status database (nanny.db) to a
  SNMP daemon supporting the AgentX protocol (RFC 2741), such a NET-SNMP.

  It is similar to combined existing utility programs amavisd-agent
  and amavisd-nanny, but instead of writing results as text to stdout,
  it exports data to an SNMP server running on a host (same or remote),
  making them available to SNMP clients (such a Cacti or mrtg) for
  monitoring or alerting purposes.

  The amavisd program does not have any additional requirements, but
  to run amavisd-snmp-subagent the following Perl modules are required:
  NetSNMP::OID, NetSNMP::ASN, NetSNMP::agent, NetSNMP::default_store.
  All of these come with a Net-SNMP package (previously known as "ucd-snmp"),
  home at http://net-snmp.sourceforge.net/, FreeBSD ports: net-mgmt/net-snmp.

  Also, an snmpd daemon must be running on a host. It can be an snmpd from
  a Net-SNMP package or some other SNMP server supporting AgentX protocol.
  When using snmpd from Net-SNMP, just add the following to its snmpd.conf:
    master agentx
    agentXSocket tcp:127.0.0.1:705
  so that amavisd-snmp-subagent will be allowed to connect to it.

  The setup was tested with Net-SNMP versions 5.3.2.3, 5.4.2.1 and 5.2.0.
  If you experience wild numbers served in Counter64 variables on a 64-bit
  platform, the following patch (at the server side) solves the problem:
    http://www.mail-archive.com/
      net-snmp-users@lists.sourceforge.net/msg19502.html
  The patch seems to already be incorporated into version 5.3.3 of Net-SNMP,
  and into 5.5 (but not in 5.4.2, nor in 5.2.0).

  A MIB module (SNMP Management information base) is provided in a file
  AMAVIS-MIB.txt. It is not necessary to make it available to an SNMP server,
  and not even necessary for SNMP clients, but making it available to clients
  allows them to display data with names of variables, not just their OIDs.
  A query example with no MIB modules:
    snmpbulkwalk -v2c -c xxx host.example.com .1.3.6.1.4.1.15312.2.1
  A query example when a file AMAVIS-MIB.txt is in a subdirectory ./mibs/ :
    snmpbulkwalk -m+AMAVIS-MIB -M-mibs -OQ -v2c -c xxx host.example.com amavis

  The amavisd-snmp-subagent can be started at any time, either before or
  after amavisd, and either before or after snmpd. It can also be restarted
  at any time. Also, amavisd can be restarted without having to restart
  amavisd-snmp-subagent, as it will automatically notice a database
  change and connect to a new database. Similarly, an snmpd daemon can be
  restarted at any time and amavisd-snmp-subagent will reconnect to it
  if necessary. A natural starting order is: snmpd first, then amavisd
  and then amavisd-snmp-subagent.

  Restarting amavisd will reset its counters. An SNMP client typically
  interprets a decremented value of a counter variable as a wraparound,
  which results in a large spike when graphing data. There are two common
  solutions to the problem: a reasonable upper limit can be provided to
  a client, so that a spike will be treated as invalid data and ignored,
  or else a AMAVIS-MIB::sysUpTime variable can be monitored, and if its
  value is smaller than on a previous reading, this indicates that counters
  were reset (i.e. amavisd was restarted) and values of counters should not
  be treated as wrapped on maxint. Consult your SNMP client documentation.

  The amavisd-snmp-subagent should have access to databases snmp,db and
  nanny.db in a $db_home directory (environment variable AMAVISD_DB_HOME,
  defaults to /var/amavis/db) and have rights to connect to an snmpd daemon.
  It is safe to run it as root, although perhaps not necessary.

  For testing purposes start amavisd-snmp-subagent from a command line
  using a command line option -f to let it stay in foreground, and
  optionally increase debug level, e.g:
    amavisd-snmp-subagent -f -d 5
  If everything goes well, start it without -f and let it daemonize.

  Supplying a filename with an option -P tells a daemonized agent to write
  its PID to that file, and remove the file on shutdown (on receiving a
  signal TERM or INT):
    amavisd-snmp-subagent -P /var/run/amavisd-snmp-subagent.pid

  Some suggested sets of OIDs making up interesting diagrams
  (e.g. for displaying by Cacti):

  counters:
    * inMsgsStatusRelayed, inMsgsStatusDiscarded,
      inMsgsStatusNoBounce, inMsgsStatusBounced, inMsgsStatusRejected
    * inMsgs, inMsgsOriginating
    * inMsgsSize, inMsgsSizeOriginating
    * inMsgsSize, outMsgsSizeSubmitQuar, outMsgsSizeRelay
    * inMsgs, outMsgsRelay, outMsgsSubmitQuar,
      outMsgsSubmitDsn, outMsgsSubmitNotif
    * contentCleanMsgs, contentCleanMsgsOriginating
    * inMsgs, contentSpamMsgs, contentBannedMsgs, contentVirusMsgs
    * contentSpamMsgsOriginating, contentBannedMsgsOriginating,
      contentVirusMsgsOriginating
    * timeElapsedTotal, timeElapsedDecoding,
      timeElapsedVirusCheck, timeElapsedSpamCheck
    * procGone

  gauges:
    * procBusy, procAll
    * procBusy, procBusyTransfer, procBusyDecode, procBusyVirus, procBusySpam
    * procBusy0, procBusy1s, procBusy2s, procBusy4s, procBusy8s
    * procBusy15s, procBusy30s, procBusy1m, procBusy2m, procBusy4m
    * mtaQueueEntriesIncoming, mtaQueueEntriesActive, mtaQueueEntriesDeferred

  Note that even frequent or extensive SNMP queries do not burden amavisd
  processes. The amavisd-snmp-subagent process keeps a cache of current
  variable values. It queries one or the other berkeley database as needed,
  i.e. when cached data is stale and there was an actual SNMP query for a
  variable in one or the other database. When a berkeley database needs to be
  accessed, all its data is fetched in one quick sweep by using a database
  cursor with a read lock, so that data is consistent. No more than one
  database sweep in 4 seconds is performed, and less often when queries are
  less frequent and preferably batched in groups. If some time has passed
  since the last SNMP query (more than 4 seconds currently), resulting values
  are always fresh as collected from a database at the time of an SNMP query.

  There is one additional experimental feature - experimental in a sense
  that it may change or be dropped in future versions. If running Postfix
  on the same host as amavisd-snmp-subagent, a count of files (mail messages)
  in each of the Postfix queue directories is provided as Gauge32 variables
  in the MIB under .1.3.6.1.4.1.15312.2.1.3, i.e. under amavisMta subtree.
  The following SNMP variables are available: mtaQueueEntriesMaildrop,
  mtaQueueEntriesIncoming, mtaQueueEntriesActive, mtaQueueEntriesDeferred.

  Although semantically outside the scope of amavisd, it provides a quick
  insight into health of an MTA, and indirectly into health of amavisd.
  Data is made available only if a command 'postconf -h queue_directory' is
  successful at amavisd-snmp-subagent startup time and provides a sensible
  result. Like with the other two real databases, MTA directories are only
  scanned if and when actually queried by an SNMP client (again, subject to
  caching). As a safety measure for times when MTA queue grows huge, there
  is a time limit for scanning each directory subtree (currently 5 seconds,
  which is about how much a typical SNMP client is willing to wait for a
  response). Also, a long scan time automatically increases cache validity
  time (time-to-live) of that measurement.


- a new experimental interface to SMTP-based antivirus scanners is provided;
  an @av_scanners entry may look like the following:

    ['av_smtp', \&ask_av_smtp,
      ['{}', 'smtp:[127.0.0.1]:5525', 'dummy@localhost'],
      qr/^2/, qr/^5/, qr/FOUND:\s*(.*?)\s*$/m ],

  The ask_av_smtp mechanism connects to a virus scanner using the specified
  protocol (typically SMTP or LMTP) on a given IP address and a port number,
  considering the virus scanner as an ordinary MTA. The full original
  message is then fed to the scanner (currently ignoring the "{}" argument),
  using the original envelope sender address and a given address as a single
  recipient (defaults to 'dummy@localhost'). It is expected that a virus
  scanner will accept a clean message (2xx) and reject an infected message
  (status 5xx). An SMTP response is parsed as usual for any output from a
  virus scanner, typically considering a response starting with 2 as clean,
  a response starting by 5 as infected, and anything else as a scanner
  failure. The SMTP-based virus scanner should be configured not to deliver
  a message. This may be achieved by feeding its SMTP output to a dummy
  SMTP listener, such as smtp-sink as supplied by a Postfix package.
  It is not a particularly efficient interfacing mechanism, but some virus
  scanners do not provide a choice. Prompted by Kevin M. Myer;

- a new configuration variable %smtp_reason_by_ccat allows customizing
  SMTP-status response reason text. The reason strings are subject to
  macro expansion, so built-in macros are available (README.customize).
  Multi-line texts are allowed and produce a valid multi-line SMTP response,
  but use it sparingly, as some nonstandard mailers may not like it.
  Currently %smtp_reason_by_ccat is only consulted for blocked messages,
  a passed clean message still uses a hardwired reason text;
  suggested by Ralf Hildebrandt, based on a patch by Noah Baker;

- support inclusion of null header field names in an 'h' tag of a DKIM
  signature generated by amavisd for specified header field names, thus
  preventing third parties from prepending additional occurrences of
  these header fields without breaking a signature; useful for example
  for protecting a recipient's mail reader or a filter from being tricked
  by supplying a duplicate From or Subject header fields; the protection is
  requested by specifying a value larger than 1 in %signed_header_fields,
  e.g.:
    $signed_header_fields{'from'} = 2;
    $signed_header_fields{'subject'} = 2;
    $signed_header_fields{'message-id'} = 2;
    $signed_header_fields{'content-type'} = 2;

  Please restrict values used in %signed_header_fields to 0, 1, or 2,
  consider other values reserved for future use.

  By default the following header fields are protected from duplicates by
  a DKIM signature generated by amavisd: From, Date, Subject, Content-Type.
  To revert to a classical behaviour, set their value in %signed_header_fields
  to 1, e.g.:
    $signed_header_fields{lc($_)} = 1 for qw(From Date Subject Content-Type);

- add a config variable @spam_notifyadmin_cutoff_level_maps, which allows
  suppressing of spam administrator notifications when spam score exceeds
  a level resulting from a lookup into this list of lookup tables;
  suggested by Rudy Gevaert;

- new configuration variables: $snmp_contact, $snmp_location, empty strings
  by default; these end up in a MIB as exported by the new amavis SNMP agent;


OTHER

- failure of a file(1) utility is now only logged (at syslog level LOG_ERR)
  and no longer treated as a fatal error; suggested by Matija Grabnar;

- require a minimal version 2.017 of Compress::Raw::Zlib when unpacking a
  zip archive (by Archive::Zip) to avoid an archive (e.g. in an infected mail)
  from causing amavisd process to hang; thanks to Alexander 'Leo' Bergolth
  for troubleshooting the memory allocation issue in a zip library;

- amavisd-nanny: write notes about lost processes to STDERR instead of
  to STDOUT, making it easier to use it non-interactively, e.g. from cron;
  suppress printing of "exited" when not interrupted; based on a patch
  provided by Thomas Gelf;

- amavisd-agent: suppress printing of "exited" when not interrupted;

- amavisd-agent: updated according to changes in MIB;

- reduce a log level of a virus scanner failure from -2 to -1, unless all
  virus scanners have failed;

- added to @virus_name_to_spam_score_maps :
    /^Structured\.(SSN|CreditCardNumber)\b/
    /^Sanesecurity.TestSig_/
    /^Email\.Spammail\b/
    /^winnow\.(phish|spam)\./
    /^INetMsg\.SpamDomain/

- internal: added user_policy_id and user_policy_id to recipient data in
  object Amavis::In::Message::PerRecip, facilitating storing users.policy_id
  into msgrcpt.sql_policy_id; suggested by Stefan Palme;

- amavisd.conf-sample: updated comment explaining the use of %a and %k
  expansions in $sql_select_policy; thanks to Max-Julian Pogner;

- documentation: change all "author signature" to "author domain signature"
  according to draft-ietf-dkim-ssp-10;


---------------------------------------------------------------------------
                                                             April 22, 2009
amavisd-new-2.6.3 release notes


NOTE: When upgrading Perl to version 5.10 or planning to do so, please do
not forget to add a missing /m flag to regular expressions in your existing
AV entries, as suggested in an example file amavisd.conf in a package.
Perl 5.8 does not mind missing /m flags, but with perl 5.10 the results
from a virus scanner may no longer be properly recognized.
See the BUG FIXES section below.


COMPATIBILITY WITH 2.6.2

- support for DSPAM has been removed from Amavis::SpamControl::SpamAssassin
  module, merging DSPAM scores into SpamAssassin and DSPAM autolearning
  is no longer available. Nevertheless, it is now possible to use DSPAM
  instead of SpamAssassin, or by adding results from each. See description
  below for @spam_scanners;

- please see a note below about having to explitly re-assign the
  @client_ipaddr_policy list if the @mynetworks_maps (not the @mynetworks)
  is changed in amavisd.conf;

- there are no other known incompatibilities with 2.6.2;


BUG FIXES

- when logging to SQL (pen pals), the msgs.message_id field always received
  a value '1' instead of a Message-Id, thus making pen pals less effective
  (only matching on sender/recipient pairs worked, not on message threads)
  and letting some bounces bypass a bounce killer; bug was introduced with
  version 2.6.2; reported by Michael Scheidell;

- timer was not reset after a persistent failure to connect to a daemonized
  virus scanner, so a subsequent call to a backup scanner only had 10 seconds
  available before it was aborted, which was often too short for a command
  line backup scanner like clamscan; reported by Bill Landry;

- if a virus scanner interface did not find a name of a virus in the output
  of a virus scanner (despite noticing infection), the infection was ignored;
  reported by Thomas Mueller;

- added missing /m flags to regular expressions in AV entries
  (a bug is revealed with Perl 5.10.0; previous versions of Perl happened
  to work, unintentionally accepting a /m flag if added late during a regexp
  evaluation); reported by Rafael;

- $banned_namepath_re setting only worked globally, but was not usable in
  policy banks; reported by Danny Richter;

- do_uncompress: signal run_command_copy() errors, instead of returning a
  status, thus allowing decompose_part() to detect 'Exceeded storage quota'
  or 'Maximum number of files exceeded', and flag mail as CC_UNCHECKED;

- if $mailfrom_notify_admin was not specified in a configuration file but
  defaulted to an e-mail address in $hdrfrom_notify_admin, the following
  was reported (due to missing angle brackets) on an attempt to submit
  a notification:
    (!)SEND via SMTP: virusalert@example.com -> <virusalert@example.com>...
        501 5.1.7 Bad sender address syntax
    (!)FAILED to notify admin: 501 5.1.7 Failed, id=40690-23,
      from MTA([::1]:10027): 501 5.1.7 Bad sender address syntax
  Notification was not sent, the rest of the processing was unaffected;
  reported by Peter Pechnik, Thomas Mueller, and Stefan Förster;

- fetch_modules: only suppress the "Can't locate ... in @INC" diagnostics
  if exactly the requested module is missing, but do show the error if some
  subordinate module is missing and preventing the requested module to be
  loaded;

- do_unrar: recognize an information line with a '<->';

- fixed a syntax error in LDAP.ldif;  by Quanah Gibson-Mount

- fixed a bug in SpamdClient; reported by Filip Valder


NEW FEATURES

- added a configuration variable @client_ipaddr_policy, which maps smtp
  client's IP address lookup lists to a policy bank name. This allows for
  loading a policy bank based on a client IP address, and generalizes a
  formerly hard-wired mapping of @mynetworks_maps into 'MYNETS'.
  The list is traversed in order, the first matching networks list stops
  the search and its associated policy name is used. Suggested by Jo Rhett.

  The default setting retains backward compatibility:

    @client_ipaddr_policy = map { $_ => 'MYNETS' } @mynetworks_maps;

  but please keep in mind that this assignment is made during startup
  before evaluating a config file, so if amavisd.conf changes the
  @mynetworks_maps list, the assignment to @client_ipaddr_policy needs to
  be re-evaluated to retain a desired default. This is not necessary when
  @mynetworks_maps is left untouched but only its component @mynetworks
  is changed.

  Example:
    @client_ipaddr_policy = (
      [qw( 0.0.0.0/8 [::] 127.0.0.0/8 [::1] )]            => 'LOCALHOST',
      [qw( !172.16.1.0/24 172.16.0.0/12 192.168.0.0/16 )] => 'PRIVATENETS',
      [qw( 192.0.2.0/25 192.0.2.129 192.0.2.130 )]        => 'PARTNER',
      \@some_other_networks  => 'OTHER',
      \@mynetworks           => 'MYNETS',
    );

- large messages beyond $sa_mail_body_size_limit are now partially passed
  to SpamAssassin and other spam scanners for checking: a copy passed to
  a spam scanner is truncated near or slightly past the indicated limit.
  Large messages are no longer given an almost free passage through spam
  checks.

  Note that message truncation can invalidate a DKIM or DK signature.
  If using (non-default) SpamAssassin rules to assign score points to mail
  with no valid signatures from authors which are expected to always provide
  a valid signature, the message truncation can cause false positives on
  these rules. As a workaround, to a truncated message passed to spam
  scanners, amavisd inserts a header field:
    X-Amavis-MessageSize: mmmmm, TRUNCATED to nnnnn
  which can be captured by SpamAssassin rules, e.g.:
    header __TRUNCATED X-Amavis-MessageSize =~ m{\A[^\n]*TRUNCATED}m
  and used in rules like NOTVALID_EBAY to prevent them from triggering.

  Starting with version 3.3.0 of SpamAssassin, its DKIM plugin understands
  the issue and receives undamaged DKIM signature objects directly from
  amavisd, so the above workaround is not needed. Also, a hit on a __TRUNCATED
  rule is automatically generated (explicit header rule is not necessary),
  just in case it might be useful for some purpose.

- supports passing an extra argument suppl_attrib to $spamassassin->parse,
  as recognized by SpamAssassin 3.3.0, passing a set of DKIM signature
  objects to a SpamAssassin's plugin DKIM, which saves having to do the
  same signature verification operation again within a plugin, and provides
  uncrippled signatures to SpamAssassin even when a large message is
  truncated by amavisd and only partially submitted to spam analysis;

- add global variables $sa_configpath and $sa_siteconfigpath (undef by
  default), which are passed to SpamAssassin as options 'rules_filename'
  and 'site_rules_filename' during its initialization call; this makes
  it easier to run multiple instances of amavisd, each with a different
  SpamAssassin configuration, using the same amavisd configurations file
  by taking advantage of option -i;  suggested by Noah Baker;

- report process resource usage at log level 2 by calling getrusage(1)
  if a perl module Unix::Getrusage is available;

- a configuration variable @spam_scanners is added, along with a module
  Amavis::SpamControl::ExtProg (which is only loaded if needed).
  This is similar in concept to @av_scanners list, and allows using
  amavisd with different spam scanners, not just with SpamAssassin.
  The default setting is backward compatible:

    @spam_scanners = (
      ['SpamAssassin', 'Amavis::SpamControl::SpamAssassin'],
    );

  The first element of each tuple is a scanner name, the second is a module
  name to be invoked, it must implement a method new(). Remaining arguments
  are passed to a module as arguments in a call to its new(). The exact
  syntax and semantics of these arguments is module-specific and may change
  in future versions as more experience is gained.

  Currently supported spam scanners are:

  - SpamAssassin: backward compatible, uses the module Mail::SpamAssassin
    directly as before;

  - SpamdClient: a client to spamd, equivalent to a spamc usage; the main
    reason for existence of this module is to allow amavisd to serve as
    a test client for exercising spamd; not envisaged for production use;

  - CRM114: spawns an external program 'crm'. A well trained crm114 system
    gives good results (even with a global database). An alternative is to
    use a CRM114 plugin to SpamAssassin, with a benefit of autolearning
    and combining its results with other rules, but at some processing cost;

  - DSPAM: spawns an external program 'dspam';

  Spam score and test results from all spam scanners are added together,
  currently it makes most sense to only have one of these entries enabled
  at a time. A possible (artificial, not particularly useful) configuration
  with multiple entries is illustrated by the following setting:

  @spam_scanners = (
    ['SpamAssassin', 'Amavis::SpamControl::SpamAssassin' ],

    ['SpamdClient',  'Amavis::SpamControl::SpamdClient' ],

    ['CRM114', 'Amavis::SpamControl::ExtProg', 'crm',
      [ qw(-u /var/amavis/home/.crm114 mailreaver.crm
           --dontstore --report_only --stats_only
           --good_threshold=8 --spam_threshold=-8) ],
      mail_body_size_limit => 64000, score_factor => -0.20,
    ],

    ['DSPAM',  'Amavis::SpamControl::ExtProg', $dspam,
      [ qw(--stdout --classify --deliver=innocent,spam
           --mode=tum --tokenizer=chained,noise
           --user), $daemon_user ],
      # use option --feature instead of --tokenizer with dspam < 3.8.0
      mail_body_size_limit => 64000, score_factor => 1,
    ],
  );

  A module Amavis::SpamControl::ExtProg implements an interface to external
  spawned programs. These are expected to receive a mail message on their
  stdin, and produce a result on their stdout (and errors on stderr). The
  result typically consists of some header fields the spawned spam scanner
  wishes to report to a caller, but can also be a complete rewritten header
  section or a complete rewritten mail message. The ExtProg module just
  collects the information it needs from the output of a scanner and discards
  the rest (i.e. an external scanner can not rewrite a message), so to avoid
  unnecessary processing, it is best to configure an external scanner to
  only return what is needed.

  Currently some post-processing of CRM114 and DSPAM results is hard-wired
  into the ExtProg module. Collected header fields are typically inserted
  into a passed message, subject to a list of allowed header fields
  in %allowed_added_header_fields. Some important header fields are also
  added to a quarantined message, but a different mechanism is involved
  ($msginfo->supplementary_info, the same mechanism as used in obtaining
  tags from SpamAssassin).

  The module Amavis::SpamControl::ExtProg expects two required parameters:
  a path to a program to spawn, and a ref to a list of command line arguments.
  Following these two arguments there may be options in a form of key/value
  pairs. Unrecognized options are ignored. Currently the only two options are:

    mail_body_size_limit ... the ExtProg module only feeds up to about this
      number of bytes (or slightly more) of a message to a spam scanner;
      if unspecified or undefined a default limit is $sa_mail_body_size_limit,
      and if that is undefined, an entire message is passed regardless of
      its size;

    score_factor ... a floating point number by which a score produced by a
      spam scanner is multiplied to yield a final score (with a SpamAssassin
      semantics, values near or below 0 are ham, values near or above 5 are
      spam). Note that crm114 uses opposite sign semantics, so a score_factor
      for this scanner should be negative. The dspam scanner produces
      hard-wired score -1 (innocent) or 10 (spam), which is then multiplied
      by score_factor to yield a final score.


OTHER

- supports a SpamAssassin plugin CRM114, thanks to Jules M, and to
  Martin Schütte for his CRM114 plugin for SpamAssassin;

- updated AV virus scanner entry for ESET Software ESETS Command Line Interface
  to version 3.0, commenting out entries for old versions 2.7 and 2.71.12;
  thanks to Hugo Slabbert;

- provide a workaround for a Perl 5.8.9 bug #62502, where O_WRONLY, O_APPEND
  and other Fcntl constants can become tainted; the bug could manifest
  itself as a taint problem during file-based quarantining, during MIME
  decoding, decoding archives and decompressing mail parts, and possibly
  elsewhere. The bug is triggered by a legitimate code in Archive::Zip and
  affects subsequent operations in amavisd for the lifetime of the child
  process. This only affects perl 5.8.9;  the 5.8.8 and 5.10.0 are fine.

- provide a workaround for a Perl I/O bug, where a bounce killer could abort
  with: "inspect_a_bounce_message failed: Error reading mail header section:
    Bad file descriptor at /usr/local/sbin/amavisd line 11486"

- uncommented the qr'^MAIL$' in @keep_decoded_original_maps (amavisd.conf
  and amavisd.conf-sample); seems it is becoming increasingly more important
  for virus scanners to also see the complete undecoded message; suggested
  by Michael Scheidell and others;

- added qr'^Safebrowsing\.' to the @virus_name_to_spam_score_maps list,
  suggested by Michael Scheidell;

- no longer unconditionally pre-loads the following SpamAssassin modules,
  as not all sites are using SQL-based bayes and AWL database:
    Mail::SpamAssassin::BayesStore::SQL
    Mail::SpamAssassin::BayesStore::MySQL
    Mail::SpamAssassin::BayesStore::PgSQL
    Mail::SpamAssassin::SQLBasedAddrList

  These modules will be dynamically loaded if needed by SpamAssassin
  after daemonization (which will be logged as "extra modules loaded after
  daemonizing/chrooting:"). If running chrooted, these modules may not be
  available in a jail, so their loading can be forced by including their
  names in the @additional_perl_modules list (in amavisd.conf), either as
  absolute file paths or as module names, e.g.:

    @additional_perl_modules = qw(
      Mail::SpamAssassin::BayesStore::SQL
      Mail::SpamAssassin::BayesStore::MySQL
      Mail::SpamAssassin::SQLBasedAddrList
    );

- when inserting a warning into a defanged mail body, crop very long
  diagnostics 'WARNING: bad headers - ...' to some sane size;

- when all virus scanners failed, let a 451 smtp response message only
  say 'ALL VIRUS SCANNERS FAILED' or 'NO VIRUS SCANNERS AVAILABLE',
  but leave out a detailed failure reason for each failing scanner,
  along with line numbers; suggested by David Schweikert;

- reduce log level of a test in TempDir::prepare for a number of links
  left on a directory after purging it, seems like it does not play well
  with a file system on Mac OS X, producing an occasional warning:
    TempDir::prepare:
      directory /var/amavis/tmp/amavis-2009... has 2 subdirectories
  reported by Matthias Schmidt;

- do not add a per-recipient contents category CC_UNCHECKED to recipients
  which have virus checking bypassed, and subsequently do not insert
  $undecipherable_subject_tag into their Subject; suggested by Jorgen Lundman;

- more precise bypassing of spam checks: bypass spam checks if it is already
  known that a message will be blocked due to banned contents; do not bypass
  spam checks for virus lovers, even if a message is infected;

- when checking if a valid DKIM signature is an author domain signature,
  treat address localpart as case sensitive, according to ADSP and RFC 5321;

- testkeys command: improved reporting of signing failures;

- removed X-Virus-Scanned from a list of DKIM-signed header fields;

- turn on the 'require_rules' option when initializing SpamAssassin
  to match behaviour with spamd and a spamassassin command;

- make sure a temporary directory name supplied through AM.PDP protocol
  is really a directory before deleting it;

- files_to_scan: make sure a file encountered during directory traversal
  is not a symlink before changing its protection (chmod);

- do_ascii: chmod a file only if it is a regular file (not a symlink)
  and is not readable;

- do_7zip: remove the -p option with its dummy password, looks like it
  has been removed and now produces an 'Incorrect command line' error;

- log (at log level 2) a list of loaded SpamAssassin plugins during startup;
  suggested by Giuseppe Ghibò;

- convert_keysfile: do not print @dkim_signature_options_bysender_maps
  assignment when a list of options is empty and thus redundant;

- convert_keysfile: make '*' in the first field equivalent to '*@*';

- internal: when deciding whether to skip spam scanning and pen pals checks
  test for is_in_contents_category(CC_VIRUS) instead of @virusnames;

- internal: removed unused method infected() from package
  Amavis::In::Message::PerRecip;

- internal: store_mgr() now signals errors instead of returning a status;
  update callers of store_mgr() accordingly;

- amavisd.conf-default: document that a default value of $bounce_killer_score
  is 0;  pointed out by Michael Scheidell;


---------------------------------------------------------------------------
                                                          December 15, 2008
amavisd-new-2.6.2 release notes

MAIN NEW FEATURES SUMMARY

- bounce killer: improved detection of nonstandard bounces;
- bounces to be killed no longer waste SpamAssassin time;
- tool to convert dkim-filter keysfile into amavisd configuration;
- compatibility with SpamAssassin 3.3 (CVS head) regained;
- rewritten and expanded documentation section on DKIM signing and
  verification in amavisd-new-docs.html;


COMPATIBILITY WITH 2.6.1

- apart from small differences in logging and notifications, the
  version 2.6.2 is compatible with 2.6.1, with its configuration file
  and its environment;

- virus scanner entries were updated (as described below, most notably by
  adding a regexp flag m), so be sure to update existing configuration file;
  updated virus scanner entries can be used with 2.6.1 too;

- the %sql_clause default has changed in detail (see below), if its value
  is overridden in a configuration file the setting may need updating;


BUG FIXES

- when feeding a message by SMTP back to MTA and MTA rejects a recipient as
  invalid and an smtp connection cache is enabled, the SMTP protocol can get
  out of step, rejecting the next message in the same connection with a
  "503 5.5.1 Error: nested MAIL command"; this only affects (hopefully) rare
  sites where recipient validation is performed after content filtering
  instead of before content filtering; reported by Richard Smits;

- logging routines reporting warnings failed to include a diagnostics message
  in a log, instead only a dry '_WARN:' or '_DIE:' with no explanation was
  logged; a bug was introduced in 2.6.1; reported by Mike Cappella;

- amavisd-release: add a 'partition_tag' attribute to a release request if
  a specified quarantine name ends up in a partition tag string in square
  brackets; this feature was announced in 2.6.1 release notes, but never
  made it into a distribution;

- amavisd-report failed on reading a message from SQL quarantine:
    dispatch_from_quarantine failed: read: sql select failed,
      DBD::Pg::st fetchrow_arrayref failed: no statement executing
  reported by Achraf Tangui;

- while evaluating compiled regular expressions (qr), perl 5.10.0 ignores
  flag m when present in the final expression but not in the qr itself,
  causing messages containing multiple viruses not to report any virus
  names (mail is still considered infected, but list of names is empty).
  Changed regular expressions in virus entries by appending a /m flag
  to regular expressions in the 6th element of each entry. According to
  Perl maintainers this was a bug in 5.8.x and earlier, and the behaviour
  of perl 5.10.0 is now according to specs; reported by Martin Huber;

- envelope sender address for administrator- and recipient notifications
  ($mailfrom_notify_admin, $mailfrom_notify_spamadmin, $mailfrom_notify_recip,
  %mailfrom_notify_admin_by_ccat, %mailfrom_notify_recip_by_ccat) was
  not expanded when their value is left unspecified in a configuration
  file and defaults to parsing of $hdrfrom_notify_* settings. This leads
  to MTA rejecting a notification from 'postmaster@${myhostname}' by a
  '501 5.1.7 Bad sender address syntax'. Reported by Aleksey Chudov,
  Jonas Jacobsson, Durk Strooisma, and Adam;

- remove unintentionally hard-coded SSL certificate and key file locations
  stored in variables $smtpd_tls_key_file and $smtpd_tls_cert_file, they
  are now configurable through a configuration file as intended;

- a macro 'rfc2822_sender' now returns a Sender address in a quoted form,
  just like its cousin 'rfc2822_from';

- when stopping or restarting amavisd, check a PID file for being stale
  _before_ testing whether a process exists, not the other way around;
  previously an unlucky starting amavisd process could hit a:
    Can't send SIG 0 to process [nnnn]: Operation not permitted
  which prevented its startup when a stale PID was reused by an unrelated
  process; reported by Zhang Huangbin;

- error reporting improvement: localize variables $@ and $! in all DESTROY
  methods, thus preventing these variables from being clobbered behind
  the scenes (e.g. by calling eval or system routines from DESTROY),
  which could cause a surprising empty (or unrelated) error message
  being reported by surrounding eval blocks;

- avoid problematic perl constructs open('|-') and open('-|') which fail
  to catch certain fork errors, or waits indefinitely when resources
  are tight; just explicitly create a pipe and call fork in subroutines
  run_command, run_command_consumer and in run_as_subprocess. The change
  possibly also solves some mystery cases where amavisd would appear
  to hang when resources are tight (running out of swap space or near a
  maxprocesses limit) instead of reporting a fork failure. Problem with
  fork failing without giving a reason for failure reported by Uwe Kiewel;

- amavisd.conf-default: definition of %sql_clause default was out of date;
  reported by Roland;

- releasing a non-existent message from an SQL quarantine produced an
  inappropriate error message about a subsequent failure, instead of
  reporting a missing record; reported by Rick (rn). Also let SQL treat
  a NULL in mail_text.partition_tag as 0 by using coalesce() - changed
  a $sql_clause{'sel_quar'} from:
    SELECT mail_text FROM quarantine
      WHERE partition_tag=? AND mail_id=?
      ORDER BY chunk_ind
  into:
    SELECT mail_text FROM quarantine
      WHERE coalesce(partition_tag,0)=coalesce(?,0) AND mail_id=?
      ORDER BY chunk_ind
  to facilitate transition from not having a partition_tag defined
  (resulting in NULL partition_tag fields in SQL) into using it as a
  numeric value (e.g. a week-of-the-year number);

- modified AV entry for a grisoft.com virus scanner by adding a regexp
  flag /m to let ^ match at any line beginning of a possibly multi-line
  response from a virus scanner; problem reported by John Beranek;

- recognize any 'ERROR:' result from a file(1) utility - not just an
  'ERROR: Corrupted', and do not treat its exit status 1 as fatal,
  but just log a warning;

- protect logging from being recursively re-entered when an error occurs
  during writing of a log entry;


NEW FEATURES

- bounce killer: improved parsing of nonstandard bounce messages (from
  qmail, spamarrest.com and similar) yields more effective protection
  against third-party bounces, including those without a Message-ID.

  An analysis of 1000 previously passed bounces showed that 2/3 of those
  are now recognized and blocked, bringing a bounce killer rate to 94 % of
  all received bounces (with about 4 % of passed unverifiable bounces not
  carrying an original mail header, and a tiny trickle of true bounces),
  while still ensuring that bounces (in response to our genuine outbound
  mail) and message disposition notifications (MDN, RFC 3798) are still
  received reliably.

  As a reminder: bounce killer is enabled by setting $bounce_killer_score
  to a large value, e.g. 100. This value is added to a final spam score if
  a message analysis determines this is a bounce to a third-party message,
  i.e. a backscatter. Spam score of genuine bounces is not affected.
  If a $bounce_killer_score value is above 20 and we know for certain
  the bounce will be killed, SpamAssassin scanning is bypassed, saving
  substantial resources when under a backscatter storm.

  A pre-requisite for proper operation of a bounce killer is a working
  SQL logging database (pen pals), or that outbound DSN messages
  have a Message-ID with a fully qualified domain name matching the
  @local_domains_maps list of lookup tables. Parts decoding must also
  not be disabled ($bypass_decode_parts=0), which is a default.
  Conditions are easily met when all mail from local users is submitted
  through a domain's official mailer, which goes hand in hand with the
  requirement for DKIM signing and for other similar anti-spoofing
  techniques (SPF, whitelisting by IP address in Received trace, ...).

  The $bounce_killer_score should not be enabled when not all outgoing
  mail can be identified either by a local domain name in Message-ID or
  by being registered in pen pals SQL database, otherwise genuine bounces
  and returning MDN messages will be considered spam.

- to facilitate transition of DKIM signing from dkim-milter to amavisd-new,
  a new command-line tool is available (the extra utility code is not
  loaded during normal operation), taking a file name as its argument,
  e.g.:

    # amavisd convert_keysfile /var/db/dkim/keysfile.txt

  and writing to stdout a set of lines that may be directly included into
  amavisd.conf configurations file, matching semantics of a dkim-filter
  keys file. It can be useful during transition, or for those who prefer
  to specify signing keys and sender-to-key mappings as a file in a
  syntax compatible with options -K -k of dkim-filter, and can live with
  limitations of such syntax. See dkim-filter(8) man page for details
  on the syntax.

  The produced output consists of signing key declarations (calls to a
  procedure dkim_key), where each call normally corresponds to exactly
  one DNS resource record publishing a corresponding DKIM public key.
  When necessary output also produces an assignment to a list of lookup
  tables @dkim_signature_options_bysender_maps, which supplies non-default
  mappings of sender domains to signing keys, e.g. when third-party
  signatures are desired.

  From the dkim-filter man page: The keyfile should contain a set of lines
  of the form sender-pattern:signing-domain:keypath where sender-pattern
  is a pattern to match against message senders (with a special character
  "*" interpreted as "zero or more characters"), signing-domain is the
  domain to announce as the signing domain when generating signatures
  (or a '*', implying author's domain), and keypath is a path to the
  PEM-formatted private key to be used for signing messages which match
  the sender-pattern. The selector used in the signature will be the
  filename portion of keypath. A line starting with "/" is interpreted as
  a root directory for keys, meaning the keypath values after that line
  in the file are taken relative to that path. If a file referenced by
  keypath cannot be opened, the filter will try again by appending ".pem"
  and then ".private". '#'-delimited comments and blank lines are ignored.

- DKIM verification now logs a note (at log level 2) when a signature
  timestamp is in future;

- allow expiration time (tag x) to be requested with DKIM signing,
  it is now supported since Mail::DKIM 0.29;

- when determining which DKIM-signing key should be applied or which
  disclaimer options to apply, consider also addresses in all Resent-Sender
  header fields. The search order is: From, followed by Resent-From and
  Resent-Sender address pairs traversed top-down by resent blocks,
  followed by Sender, and by envelope sender;

- amavisd-report no longer lets amavisd strip header fields found in a
  quarantined message which were previously inserted by amavisd; most of
  X-Spam-* and X-Amavisd-* header fields are now retained in a reported
  message; suggested by Achraf Tangui;

- support IPv6 when connecting over an INET socket to virus scanners;

- support SMTP, LMTP and TCP_LOOKUP protocols also over Unix sockets;

- added an LDAP attribute amavisArchiveQuarantineTo to code and to
  LDAP.schema;  a patch was provided by Anand Palaniswamy (back in
  October 2006); prompted by Quanah Gibson-Mount, both of zimbra.com.

- new file in the package: LDAP.ldif, same schema as in LDAP.schema, but
  in ldif format; contributed by Quanah Gibson-Mount and independently
  also by Michael Hall;

- @remove_existing_spam_headers_maps is now a per-recipient list of lookup
  tables, so pre-existing X-Spam* header fields may be selectively removed
  according to preferences of individual recipients or sub-domains, e.g.:

    @remove_existing_spam_headers_maps = ({
      'user@example.com' => 0,
      'user@office.example.net' => 1,
      '.office.example.net' => 0,
      '.' => 1,  # all the rest
    });

- added a macro b64encode, which could be used in log template to
  facilitate log parsing, perhaps by using the following in a $log_templ:
    [? [:header_field|Subject]||, \
    Subject: [:b64encode|[:header_field|Subject|100]]]#
  Suggested by Rajkumar S;

- added a macro HEADER as a synonym for a macro header_field
  for compatibility with SpamAssassin;

- added a configuration variable $logline_maxlen (default value is 980,
  lower bound is 50), allowing user to customize syslog line wrapping
  threshold; based on a patch by Charles A. Scheidecker;

- when loading a policy bank, most entries from an associative array (hash)
  being loaded entirely replace entries of the same key in the currently
  active policy bank, but entries which are references to a hash are
  normally merged with existing hashes, replacing only specified key/values
  but leaving remaining (non-existent in a new hash) key/values pairs
  unchanged. In some rare cases it would be more desirable to entirely
  replace existing hashes, which so far was not possible.

  For this purpose a hack was introduced: if a hash in a policy bank being
  loaded contains a key name 'REPLACE' (uppercase) and its value is true,
  this hash replaces a current hash, instead of being merged with it.

  For example, a policy bank 'DITCH' when loaded replaces a hash
  %final_destiny_by_ccat entirely, leaving only a key CC_CATCHALL there:

    $policy_bank{'DITCH'} = {
      final_destiny_by_ccat => { REPLACE=>1, CC_CATCHALL() => D_DISCARD },
    };

  Without specifying a  REPLACE=>1  remaining key/value pairs in a hash
  %final_destiny_by_ccat would stay unchanged and only the CC_CATCHALL
  key/value pair would be replaced by a new setting (which may not be
  desirable):
    $policy_bank{'DITCH'} = {
      final_destiny_by_ccat => { REPLACE=>0, CC_CATCHALL() => D_DISCARD },
    };
  or equivalently:
    $policy_bank{'DITCH'} = {
      final_destiny_by_ccat => { CC_CATCHALL() => D_DISCARD },
    };

- rewritten and expanded documentation section on DKIM signing and
  verification in amavisd-new-docs.html;


OTHER

- tested with perl 5.10.0;

- package Amavis::IO::FileHandle now supports a method READ (i.e. invoked
  by a perl functions sysread through a tied hash), which is needed by
  SpamAssassin revisions since 2008-09-25 (3.3), bringing a little speedup
  to transferring a message from amavisd to SpamAssassin, and avoiding a
  Perl I/O bug (perl bug 39060; SA: bug 5985) on some installations;

- updated @virus_name_to_spam_score_maps to recognize new malware name
  formats used by some popular third-party ClamAV signatures (Sanesecurity,
  MSRBL, MBL); thanks to Mike Cappella, Gary V, Wijatmoko U. Prayitno,
  Steve Basford, Luca Gibelli, Bill Landry, Henrik K;

- keep only one (unique) copy of each malware/spam name when infection
  is downgraded to spam through @virus_name_to_spam_score_maps or when
  reported as a virus;

- macro F now only shows the first (if any) banned leaf part name,
  preceded by comments from a banning rule regexp (if any), instead of
  a list of multiple banned parts each with its full MIME/archive path.

  Note that Perl syntax for a comment within a regexp is: (?# ... )
  For example, given the following rule...

    $banned_filename_re = new_RE(
      qr'^\.(exe-ms|dll)$(?# rule #9)',  # banned file(1) types
    );

  ... a macro expansion of macros banning_rule_key, banning_rule_comment,
  banning_rule_rhs, banned_parts and F will be:

    banning_rule_key:      (?-xism:^\\.(exe-ms|dll)$(?# rule #9))
    banning_rule_comment:  rule #9
    banning_rule_rhs:      1
    banned_parts:
        multipart/mixed | application/octet-stream,.exe,.exe-ms,videos.exe
    F:  rule #9:application/octet-stream,.exe,.exe-ms,videos.exe

  Likewise an SMTP response (with D_REJECT) would match a macro F as
  before and would yield:

    554 5.7.0 Reject, id=42721-01 - BANNED: rule #9:application/octet\
      -stream,.exe,.exe-ms,videos.exe

  A default administrator and recipient notification (still using a macro
  F in their template), a main log entry, as well as a DSN and a rejection
  message, will now be shorter and hopefully less confusing to an end user.
  A full list of banned part paths (as previously produced by a macro F)
  is now available under a new name as a macro 'banned_parts' and can be
  used in custom templates to retain previous behaviour if desired.
  Suggested by Andreas Schulze and Peer Heinlein;

- remove a 'LIMIT 1' from default $sql_clause{'sel_penpals_msgid'} and
  from $sql_clause{'sel_penpals'} clauses, it is redundant and it happens
  to make a MySQL 5.1 optimizer choose a slow plan;
  investigated by Michael Scheidell;

- changed a default $sql_select_policy from:
    SELECT *,                 users.id FROM users LEFT JOIN policy ON ...
  into a:
    SELECT users.*, policy.*, users.id FROM users LEFT JOIN policy ON ...

  MySQL and PostgreSQL are happy with a 'SELECT *, users.id', but Oracle
  wants 'SELECT users.*, policy.*, users.id', which is also acceptable
  to MySQL and PostgreSQL and shouldn't make any difference;
  problem reported and a solution provided by Chris Bryant;

- optimize storage of DKIM signing keys when multiple calls to dkim_key()
  (from amavisd.conf) specify the same file to be associated with different
  keys - now only one copy of a private key is kept in memory;

- sanitize (strip) bare CR characters in mail before DKIM-signing a message
  and when forwarding it over SMTP (or LMTP) protocol which prohibits CR
  characters outside of CRLF pairs. Previously a DKIM signature generated
  by amavisd on messages with embedded bare CR characters broke when passed
  back through Postfix (following a principle of garbage-in, garbage-out).
  This was mainly an issue when a message was incorrectly sanitized or
  a disclaimer added by an external program such as altermime, which (due
  to a bug in versions 0.3.10 and older) could inappropriately introduce
  CR characters into a message. Reported by Patrick Wong;

- retain original rfc822 quoting of envelope sender address when forwarding
  mail, instead of using a sanitized version (de-quoted & re-quoted);

- insert autolearn=... information field into an X-Spam-Status header field,
  similar to how SpamAssassin does it; suggested by Jonathan Skanes;

- an SQL field msgs.spam_level now receives a sum of SA score plus a minimum
  of internally generated score boosts across all message recipients, to
  facilitate coarse assessment by third party utilities without having
  to look into msgrcpt records; previously it only reflected a SA score
  (but field msgrcpt.bspam_level remain unchanged, storing a sum for each
  individual recipient as before);

- insert "AM:BOOST=boost_scores_list" into a list of triggered spam tests
  to make visible the internally generated per-recipient spam score boosts
  (like from: pen pals, soft white/black-listing, bounce killer) in the log
  and in the X-Spam-Status header field. The 'tests' list in X-Spam-Status
  or in the log (macro %T) can now look like:
    tests=[AM:BOOST=+1.3+0.51-1.1, BAYES_99=3.6, ...]
  Multiple summands appear in multi-recipient messages where boost scores
  differ between recipients (the list is squashed, only unique values are
  shown). Apparent mismatch in score addition pointed out by John Beranek.

- when quarantining and generating notification for administrator and
  recipients, and the per-recipient contents category differs from a
  per-message summarized contents category, use the per-recipient contents
  category for lookups into settings; a desirable side effect is that
  recipients which are bypassing some tests (like tests for virus or spam)
  no longer receive a recipient notification for cases they are not
  interested in; undesired behaviour pointed out by Erin D. Hughes;

- drop log level of 'smtp resp to NOOP' and related messages from 2 to 3
  to reduce log clutter; reported by kfx;

- log a warning during startup when DKIM verification is not enabled
  (when $enable_dkim_verification is at its default value of undef).
  To quench down the warning and keep DKIM verification disabled, set
  the $enable_dkim_verification explicitly to 0;

- when mail with banned part is to be passed but defanged, provide a more
  informative warning in the text part:
    WARNING: banning rules detected suspect part(s),
    do not open unless you know what you are doing
  suggested by Gerald Macinenti;

- amavisd-agent: Content*Msgs* now take as a 100% reference the InMsgs$2
  counter instead of Content$1Msgs;

- when exec in a forked process fails, call POSIX::_exit with exit status
  6 (SIGABRT) instead of 8 which has different meanings on different OS;

- ensure a BDB cursor is unlocked in put_initial_snmp_data() even in case
  of errors or signals during writing of the initial sys* set of SNMP
  variables;

- provide a generous but firm 4 MB sanity limit on a header section size to
  avoid excessive storage requirements while parsing and storing a runaway
  header section; the limit also protects DKIM signature verifier on huge
  headers; exceeded limit does not affect other mail checks and forwarding,
  only access to individual header fields beyond the limit is crippled and
  DKIM signatures would most likely be invalidated;

- do not pre-load module Mail::SPF::Query with versions of SpamAssassin
  3.2.0 or later, it has been replaced by Mail::SPF;

- internal: modify mail_to_local_mailbox and do_quarantine to better deal
  with suppressing multiple quarantining to the same mailbox, e.g. when
  two quarantining methods are active but point to the same file;

- internal: brush up I/O modules for consistency: open method should
  implicitly close a previously open file, print method should print all
  its arguments, read methods now support reading to a buffer at an offset;

- internal: change most calls to lookup() into calls to a newer lookup2()
  for added flexibility, adding option 'Label' to some calls to facilitate
  debugging;

- internal: passing options to lookup2 (and to other subordinate lookup
  methods) as a hash instead of a hashref;

- internal: renamed Amavis::In::Message::PerRecip methods:
  banned_keys -> banning_rule_key,  banned_rhs -> banning_rule_rhs,
  added: banning_rule_comment and banning_reason_short;

- internal: replace subroutine unique with two: unique_list and unique_ref;

- internal: remove dependency on a module IO::Wrap;

- internal: many rather cosmetic changes for consistency, updated comments;

- README.sql-mysql: add 'ALTER table' suggestions to change CHAR to BINARY
  and VARCHAR to VARBINARY data types; suggested by Peter Huetmannsberger:


---------------------------------------------------------------------------
                                                              June 29, 2008
amavisd-new-2.6.1 release notes


BUG FIXES

- avoid a bounce-killer's false positive when a message is multipart/mixed
  with an attached message/rfc822 (looking like a qmail or a MSN bounce)
  and having attached a message with a foreign Message-ID - by restricting
  the check to messages with an empty sender address or a 'postmaster' or
  'MAILER-DAEMON' author address;

- privileges were dropped too early when chrooting, causing chroot to fail
  (a workaround was to specify a jail directory through a command line
  option -R); reported by Helmut Schneider;

- fix unwarranted 'run_av error: Exceeded allowed time' error when using
  a virus scanned Mail::ClamAV; reported by Chaminda Indrajith;

- fix a bug in helper-progs/amavis-milter.c where atoi could be reading
  from a non-null terminated string which could result in wrong milter
  return status, or even cause a read-access violation;
  reported by Shin-ichi Nagamura;

- dsn_cutoff_level was ignored if SpamAssassin was not invoked (e.g. on
  large messages) even if recip_score_boost was nonzero, causing a DSN
  not to be suppressed for internally generated large score values;
  reported by Bernd Probst;

- add back the 'Ok, id=..., from MTA(...):' prefix to an MTA status responses
  on forwarded mail when generating own SMTP status response (it was lost
  in code transition from 2.5.4 to 2.6.0); reported by Thomas Gelf;

- replaced '-ErrFile=>*STDOUT' with '-ErrFile=>\*STDOUT' in a call to
  BerkeleyDB::Env::new in amavisd-nanny and amavisd-agent; seems it
  was failing in some setups (even though it was in accordance with
  a BerkeleyDB module documentation); reported by Leo Baltus;

- README.sql-mysql: fixed an SQL data type mismatch between maddr.id (used as
  a foreign key) and msgs.sid & msgrcpt.rid; they all should be of the same
  type, either integer unsigned or bigint unsigned; a schema as published
  in README.sql-mysql could not be built because of a conflict in a data
  type; reported by Leonardo Rodrigues Magalhães and Zhang Huangbin;


NEW FEATURES

- recognize an additional place-holder %P in a template used to build
  a file name in file-based quarantining, for example:

    $spam_quarantine_method = 'local:Week%P/spam/%m.gz';

  A %P is replaced by a current partition tag, which makes it easier to
  better organize a file-based quarantine by including a partition tag
  (e.g. an ISO week number) in a file name or a file path.

  For the record, here is a complete list of place-holders currently
  recognized in filename templates:
    %P  =>  $msginfo->partition_tag
    %b  =>  $msginfo->body_digest
    %m  =>  $msginfo->mail_id
    %n  =>  $msginfo->log_id
    %i  =>  iso8601 timestamp of a message reception time by amavisd
    %%  =>  %

  The following example organizes spam quarantine into weekly subdirectories:
    cd /var/virusmails
    mkdir -p W01/spam W02/spam ... W53/spam  (weeks 01..53)
    chown -R vscan:vscan W01 W02 ... W53     (weeks 01..53)
  amavisd.conf:
    $spam_quarantine_method = 'local:W%P/spam/%m.gz';
    $sql_partition_tag =
      sub { my($msginfo)=@_; sprintf("%02d",iso8601_week($msginfo->rx_time)) };

- add a macro %P as a synonym for a macro 'partition_tag', mainly for
  completeness with the added place-holder %P in a file name template;


OTHER

- disabled a do_ascii decoder in the default @decoders list:
    #  ['asc', \&Amavis::Unpackers::do_ascii],
    #  ['uue', \&Amavis::Unpackers::do_ascii],
    #  ['hqx', \&Amavis::Unpackers::do_ascii],
    #  ['ync', \&Amavis::Unpackers::do_ascii],
  The do_ascii is invoking a module Convert::UUlib which in turn calls
  a troublesome library uulib, which has a history of security problems
  and on occasion misinterprets a text file as some encoded text,
  causing false positives (e.g. making it look like an executable);
  a recent false positive on base64-decoding reported by Jeffrey Arbuckle;
  a recent DoS (looping in uulib) reported by Thomas Ritterbach;

- added a rule into $map_full_type_to_short_type_re to cope with another
  example of misclassification by a file(1) utility, where a plain text
  file is considered a DOS executable:
    [qr/^DOS executable \(COM\)/ => 'asc'],  # misclassified?
  An example was provided by Leonardo Rodrigues Magalhães;

- until the issue is better understood, revert the use of 'my_require'
  and go back to the standard but less informative 'require';  some people
  were reporting problems with my_require (loading of some Perl modules can
  fail, apparently depending on a current directory where amavisd is started
  from); reports by Tuomo Soini, Max Matslofva, Bill Landry;

- use the $myproduct_name value in generated Received header field
  instead of a hard-wired 'amavisd-new'; suggested by Thomas Gelf;

- added missing required header fields to some test mail messages in a
  directory test-messages to quench down a complaint about a bad header;

- changed SQL default clauses in %sql_clause (upd_msg, sel_quar, sel_penpals)
  to always join tables using both the partition_tag and the mail_id fields,
  previously just the mail_id field was used in a join. The change has no
  particular effect (and is not really necessary) on existing 2.6.0 databases
  where a primary key is mail_id (it is just a redundant extra condition),
  but saves a day when a primary key is a composite: (partition_tag,mail_id),
  which may be a requirement of an SQL partitioning mechanism.
  Thanks to Thomas Gelf for his testing of MySQL partitioning, reporting
  deficiency in amavisd SQL schema (primary keys) which did not meet MySQL
  requirements for partitioning, and suggestions;

- an AM.PDP release request can specify an additional optional attribute:
    partition_tag=xx
  where a requester can supply a partition_tag value of a message to be
  released. This helps to uniquely identify a message in case where an SQL
  database did not enforce a mail_id field to be unique (as may be necessary
  with some partitioning schemes).

  If a partition_tag information is readily available to a requester, it
  is advised that the attribute is included in a request even if mail_id
  is known to be unique. This may expedite a search and provide a double
  check to a validity of a request. For backward compatibility amavisd
  performs a query on msgs.mail_id for a partition_tag value if it is
  missing form a request, the query uses an SQL clause in a new entry
  $sql_clause{'sel_msg'}.  If exactly one record matches, then everything
  is fine, and releasing may proceed. If multiple records with the same
  mail_id exist the release request is aborted with a message asking user
  to supply a disambiguating partition_tag=xx attribute;

- a quarantine id for an SQL-quarantined message as logged in a main
  log entry is changed from:
    quarantine: aX3C4f6btXgX
  to:
    quarantine: aX3C4f6btXgX[25]
  i.e. a partition_tag in brackets is appended to mail_id.

  Correspondingly the amavisd-release is also changed to be able to parse
  'aX3C4f6btXgX[25]', splitting it into mail_id and partition_tag, and
  providing each as a separate attribute in an AM.PDP release request;

- README.sql-mysql: changed SQL datatype VARCHAR into VARBINARY for
  data fields mail_id, secret_id and quar_loc, and CHAR into BINARY for
  msgs.content and msgs.quar_type to preserve case sensitivity on string
  comparison operators; suggested by Thomas Gelf;

  The same change should eventually be done on README.sql-pg too, but as
  PostgreSQL is more picky than MySQL on matching a field data type to a
  supplied data value, the change of a data type would need to be reflected
  in SQL calls in amavisd. This will have to wait until some future version
  of amavisd-new, having to undergo more testing than I have available
  before the 2.6.1 release.


Background information on UNIQUE constraint in table SQL msgs

Amavisd does not know and need not be aware of what is a primary
key or what are UNIQUE constraints in SQL table msgs. When generating
a mail_id for a message being processed, amavisd tries to INSERT
a record with a randomly generated mail_id into table msgs (using
SQL clause in $sql_clause{'ins_msg'}). If the operation fails,
another mail_id is generated and attempt repeated, until it eventually
succeeds. Thus it depends entirely on SQL's decision whether a
particular record is allowed or would break some UNIQUE constraint.
So, by only changing a declaration on table msgs (PRIMARY KEY or
adding a CONSTRAINT), it changes what keys amavisd will be allowed
to insert and what kind of duplicates would be allowed.

Classically the msgs.mail_id is a PRIMARY KEY and as such it is unique.
This was a requirement for versions of amavisd up to and including 2.6.0.
Starting with 2.6.1 the JOINs have been tightened to include a
partition_tag besides mail_id in a relation, which makes it possible
to loosen a unique requirement on msgs.mail_id and only require a
pair (partition_tag,mail_id) to be unique. In other words, this way
the mail_id is only needed to be unique within each partition tag value.

This change allows a partitioning scheme to meet requirements on
MySQL partitioning. For non-partitioned databases the change shouldn't
make any difference, and one is free to choose between having mail_id
unique across the entire table or just within each partition_tag value.

Changing a primary key to (partition_tag,mail_id) brings consequences
to quarantining, in particular to releasing from an SQL quarantine,
where it no longer suffices to specify mail_id=xxx in AM.PDP request,
but may be necessary to specify also a partition_tag=xx to distinguish
between SQL-quarantined messages which happen to have the same mail_id.


---------------------------------------------------------------------------
                                                             April 23, 2008
amavisd-new-2.6.0 release notes

MAIN NEW FEATURES SUMMARY

- integrated DKIM signing and verification; see sections
  A QUICK START TO DKIM VERIFICATION and A QUICK START TO DKIM SIGNING
  by the end of this release note;
- loading of policy banks based on valid DKIM-signed author's address
  can be used for reliable whitelisting, for bypassing banned checks, etc.
- bounce killer feature: uses a pen pals SQL lookup to check inbound DSN;
- SQL logging and quarantining tables have a new field 'partition_tag';
- captures SpamAssassin logging, more flexibility specifying SA log areas;
- collects and logs SpamAssassin timing breakdown report (requires SA 3.3);
- releasing from a quarantine can push a released message to an attachment;
- new experimental code for abuse reporting using formats: ARF/attach/plain;
- TLS support on the SMTP client and server side;
- connection caching by an SMTP client;
- amavisd-nanny and amavisd-agent now re-open a database on amavisd restarts;
- amavisd-nanny and amavisd-agent new command line option: -c count;
- updated p0f-analyzer.pl to support source port number in queries;
- amavisd can send queries either to p0f-analyzer.pl or directly to p0f;


COMPATIBILITY WITH 2.5.4

- when using SQL for logging (e.g. for a pen pals feature) or for
  quarantining, SQL tables tables maddr, msgs, msgrcpt and quarantine need
  to be extended by a new field 'partition_tag';  see below for details;

- when SQL logging (pen pals) or SQL lookups are used, one can choose a
  binary or a character data type for fields users.email, mailaddr.email,
  and maddr.email; now may be a good opportunity to change a data type
  to binary (string of bytes);  see below for details;

- when using SQL for logging, a default for $sql_clause{'upd_msg'}
  has changed, so if a configuration file replaces this SQL clause
  by a non-default setting, it needs to be updated;

- perl module Mail::DKIM is now required when DKIM verification or signing
  is enabled or when spam checking by SpamAssassin is used and a DKIM plugin
  is enabled; a required version of this module is 0.31 (or later);

- because privileges are now dropped sooner, pid and lock files as
  generated by Net::Server can no longer be located in a directory which
  is not writable by UID under which amavisd is running (e.g. /var/run).
  A location of these files is controlled by $pid_file and $lock_file
  settings, and by default are placed in $MYHOME, which still satisfies
  the new requirement;

- white and blacklisting now takes into account both the SMTP envelope
  sender address, as well as the author address from a header section
  (address(es) in a 'From:' header field). Note that whitelisting
  based only on a sender-specified address is mostly useless nowadays.
  For a reliable whitelisting see @author_to_policy_bank_maps below,
  as well as a set of whitelisting possibilities in SpamAssassin (based
  on DKIM, SPF, or on Received header fields);

- if using custom hooks, some of the internal functions have changed,
  in particular the semantics of a method orig_header_fields - use new
  functions get_header_field() or get_header_field_body() instead;
  see updated sample code amavisd-custom.conf, and see entries labeled
  'internal' below;

- a configuration variable $append_header_fields_to_bottom is now obsolete;
  the variable is still declared for compatibility with old configuration
  files, but its value is ignored: new header fields are always prepended,
  i.e. added to the top of a header section;

- semantics of a command line option 'debug-sa' has changed due to a merge
  of SpamAssassin logging with a mainstream amavisd logging mechanism.
  A command 'amavisd debug-sa' is now equivalent to 'amavisd -d all' with
  an implied redirection of all logging to stderr. Previously it only rerouted
  SpamAssassin logging to stderr but did not affect normal amavisd logging,
  which still followed the usual $DO_SYSLOG and $LOGFILE settings.

  Also, a SpamAssassin log level 'info' is now turned on by default (as was
  previously achievable by a command line option '-d info'), and shows merged
  with a normal amavisd logging at level 1 or higher.

  The following table shows mapping of SpamAssassin log levels to amavisd
  log levels, and for completeness also shows mapping of amavisd log levels
  to syslog priorities (which has not changed since previous version):

    SA     amavisd  syslog
    -----  -------  -----------
             -3     LOG_CRIT
             -2     LOG_ERR
    error    -1     LOG_WARNING
    warn      0     LOG_NOTICE
    info      1     LOG_INFO
              2     LOG_INFO
    dbg       3     LOG_DEBUG
              4     LOG_DEBUG
              5     LOG_DEBUG

- an additional requirement for loading a policy bank 'MYUSERS' is that
  'originating' flag must be on, which typically means that mail must
  be coming from internal networks or from authenticated roaming users
  to be able to load a policy bank 'MYUSERS';


BUG FIXES

- run_av: limit the number of filenames given as arguments to a command
  line scanner to stay within a safe (POSIX) program argument space limit,
  run a command line scanner multiple times if necessary. This required
  a larger change in the program (run_av, ask_av) which is why the fix
  was listed for a long time on a TODO list and not implemented so far.
  The problem affected command line virus scanners which are unable to
  traverse a directory by themselves and need a list of filenames as
  arguments (such as KasperskyLab's aveclient and kavscanner, MkS_Vir mks,
  and CyberSoft VFind). Actual problem reported by Danny Richter;


NEW FEATURES

- DKIM signing and verification - see sections below: A QUICK START
  TO DKIM VERIFICATION and A QUICK START TO DKIM SIGNING. Not to forget
  upgrading Mail::DKIM to 0.31 (or later) and adding the following
  to amavisd.conf;
    $enable_dkim_verification = 1;
    $enable_dkim_signing = 1;

- SQL tables tables maddr, msgs, msgrcpt and quarantine are extended by
  a new field 'partition_tag'. When amavisd creates new records in these
  tables, a current value of a configuration variable $sql_partition_tag
  (or its value from policy banks) is written into 'partition_tag' fields.
  An undefined value translates to 0. The 'partition_tag' field is usually
  declared in a schema as an integer, but in principle could be any data
  type, such as a string.

  A value of 'partition_tag' field may be used to speed up purging of
  old records by using partitioned tables (MySQL 5.1 +, PostgreSQL 8.1 +).
  A sensible value is a week number of a year, or some other slowly changing
  value, allowing to quickly drop old table partitions without wasting
  time on deleting individual records. Records in all tables carrying the
  'partition_tag' field are self-contained within each value of a field.
  In other words, foreign keys never reference a record in a subordinate
  table with a value of a 'partition_tag' field different from the referencing
  record. Consequently, mail addresses in table maddr are also self-contained
  within a partition tag, implying that the same mail address may appear in
  more than one maddr partition (using different 'id's), and that tables
  msgs and msgrcpt are guaranteed to reference a maddr.id within their own
  partition tag. Too fine a granularity of partition tags (e.g. changing a
  value daily) wastes space in table maddr by storing multiple copies of
  the same mail address.

  The $sql_partition_tag may be a scalar (usually an integer or a string),
  or a reference to a subroutine, which will be called with an object of
  type Amavis::In::Message as argument (giving access to information about
  a message being processed), and its result will be used as a partition
  tag value. Possible/typical usage (in amavisd.conf):

    $sql_partition_tag =
      sub { my($msginfo)=@_; iso8601_week($msginfo->rx_time) };

  yields an ISO 8601 (EN 28601) week number (1..53) corresponding to a mail
  reception timestamp in a local time zone. This week number definition is
  equivalent to PostgreSQL extract(week from ...), and MySQL week(date,3).

  Another possible use of 'partition_tag' field is to let a policy bank set
  its specific value (a fixed value or a subroutine) for $sql_partition_tag.
  This would allow for example labeling of SQL records for mail originating
  from inside with a different partition_tag value, compared to entries for
  incoming mail, and consequently let them be stored in a separate partition
  if desired.

  Amavisd process itself does not use the 'partition_tag' field for its
  own purposes, all records regardless of their 'partition_tag' value
  are available for example to pen pals lookups, as before. The field is
  provided only as a convenience to SQL database maintenance, and can be
  ignored by smaller sites where current practice of database maintenance
  is fast enough. If SQL partitioning is not in use (or not intended to
  be used in a near future), it is more economical to use a fixed value
  (such as 0, which is a default) for the $sql_partition_tag. Using week
  numbers as partition tags adds about 50 % to the number of records in
  table maddr, the exact number depends on retention period and a ratio
  of regular vs. infrequent mail addresses observed.

  To convert tables of an existing database, please use ALTER command.
  Here is a conversion example (MySQL or PostgreSQL, probably others):

    ALTER TABLE maddr      ADD partition_tag integer DEFAULT 0;
    ALTER TABLE msgs       ADD partition_tag integer DEFAULT 0;
    ALTER TABLE msgrcpt    ADD partition_tag integer DEFAULT 0;
    ALTER TABLE quarantine ADD partition_tag integer DEFAULT 0;

  As the maddr.email is no longer guaranteed to be unique, but a pair
  of (maddr.partition_tag, maddr.email) is unique, the constraint and
  an associated index needs to be changed:

  => PostgreSQL:
  ALTER TABLE maddr
    DROP CONSTRAINT maddr_email_key,
    ADD  CONSTRAINT maddr_email_key UNIQUE (partition_tag,email);

  => MySQL:
  ALTER TABLE maddr
    DROP KEY email,
    ADD  UNIQUE KEY part_email (partition_tag,email);

  Should a need arise to revert to amavisd-new-2.5.4 while keeping the new
  partition_tag field, the 'SELECT id FROM maddr ...' may become slow due to
  dropped index on a field maddr.email, which is replaced by an index on a
  pair (maddr.partition_tag, maddr.email). The following change to amavisd
  2.5.4 solves the problem:

@@ -901,2 +901,2 @@
     'sel_adr' =>
-      'SELECT id FROM maddr WHERE email=?',
+      'SELECT id FROM maddr WHERE partition_tag=0 AND email=?',

  The use of partitioned tables to speed up purging of old records was
  suggested by Robert Pelletier.


- when SQL logging (pen pals) or SQL lookups are used, one can choose a
  binary or a character data type for fields users.email, mailaddr.email,
  and maddr.email; now may be a good opportunity to change a data type
  to binary (string of arbitrary bytes, no character set associated).

  Background: values of these fields come from SMTP envelope or from a
  mail header section of processed mail. Even though RFC 2821 and RFC 2822
  restrict these addresses to 7-bit ASCII, there is nothing preventing
  a malicious or misguided sender from supplying any 8-bit byte values.
  If SQL fields are declared as VARCHAR or CHAR, a character set is
  associated with data and its rules apply, e.g. control characters may
  not be permitted, or UTF-8 byte sequences are validated, or a restriction
  to codes below 128 apply. Depending on strictness of an SQL server on
  validating data, a violation of character set rules may lead to aborting
  an SQL operation and failing of mail processing. Even though new standards
  for e-mail addresses are being negotiated allowing for UTF-8 encoding, an
  actual e-mail address may still supply arbitrary bytes, which may violate
  UTF-8 byte sequence rules.

  A new configuration variable $sql_allow_8bit_address now controls how
  amavisd passes e-mail addresses to SQL.

  If a value is true, then it is expected that SQL tables will accept
  strings of arbitrary bytes for these fields, without associating a
  character set with data. No data sanitation is done by amavisd. An
  appropriate SQL data type is 'VARBINARY' or with PostgreSQL a 'BYTEA'.

  If a value of $sql_allow_8bit_address is false (which is a default for
  compatibility) then amavisd performs sanitation before passing data to SQL:
  control characters and characters with codes above 127 are converted to '?',
  which brings strings within ASCII character set restrictions. A suitable
  SQL data type is VARCHAR or CHAR. Note that some information is lost in
  this case.

  The following clauses can convert pre-2.6.0 tables into the now preferred
  and more universal form:

  MySQL:
    ALTER TABLE users    CHANGE email email varbinary(255);
    ALTER TABLE mailaddr CHANGE email email varbinary(255);
    ALTER TABLE maddr    CHANGE email email varbinary(255);

  PostgreSQL:
    ALTER TABLE users    ALTER email TYPE bytea USING decode(email,'escape');
    ALTER TABLE mailaddr ALTER email TYPE bytea USING decode(email,'escape');
    ALTER TABLE maddr    ALTER email TYPE bytea USING decode(email,'escape');

  If a binary data type is chosen for these three fields, the setting
  $sql_allow_8bit_address MUST be set to true to let the amavisd program
  use the appropriate data type in SQL commands, otherwise PostgreSQL will
  complain with:
    'types bytea and character varying cannot be matched'
  when amavisd tries to execute SQL commands. MySQL is more forgiving and
  does not complain about a data type mismatch, so one may get away with a
  mismatch, although it is appropriate to eventually make it right.

  If a change of a data type of these fields is chosen while using some
  third-party management interface to SQL data set (e.g. MailZu), make sure
  the management interface supports the changed data type. This is primarily
  a concern with PostgreSQL which is more strict in requiring a match
  between field data types in tables and data in SQL clauses.

  The need for a change was pointed out by Xavier Romero, reporting that
  PostgreSQL SQL lookups with pre-2.6.0 versions of amavisd can fail when
  8-bit data appears in SMTP envelope addresses:

    lookup_sql: sql exec: err=7, 22021, DBD::Pg::st execute failed: ERROR:
      invalid byte sequence for encoding "UTF8"


- bounce killer feature: uses a pen pals SQL lookup to check inbound DSN,
  attempting to match it with a previous outbound message. If a Message-ID
  found in an attachment of the inbound DSN matches a Message-ID of a
  message previously sent from our system by a current recipient of the DSN,
  the DSN message is spared, otherwise it receives $bounce_killer_score
  spam score points (0 by default, i.e. disabled) and can be blocked as
  spam (although technically it is just a misdirected bounce, not spam).

  A received delivery status notifications is parsed looking for attached
  header section of an original message in an attempt to find a Message-ID.
  A standard DSN structure (RFC 3462, RFC 3464) is recognized, as well as
  a few nonstandard but common formats. Other automatic reports and bounces
  with unknown structure and no attached header section are ignored for
  this purpose (are subject to other regular checks). Unfortunately there
  are still many nonstandard mailers around (12+ years after DSN format
  standardization) and many ad-hoc filtering solutions which do not supply
  the essential information.

  A message is unaffected by this check and the DSN message is considered
  a genuine bounce if a Message-ID can be found in an SQL log database
  matching a previous message sent by a local user (which is now a recipient
  of a DSN), either using a normal pen pals lookup (no extra SQL operations
  are necessary), or if a domain part of the Message-ID is one of local
  domains.

  On the other hand, if the attached DSN header does look like a complete
  original header but it does not meet the above criteria, then it is
  assumed that the message is a backscatter to a faked address belonging
  to our local domains, and $bounce_killer_score spam score points are
  added, so the message can be treated as spam (subject to spam kill level
  and other spam settings).

  The only user-configurable setting is $bounce_killer_score (also member
  of policy banks), its default value is 0. To activate the bounce killer
  feature, set the $bounce_killer_score to a positive number, e.g. 100.
  A bounce killer score does not contribute to SpamAssassin's auto-learning.

  A pre-requisite for proper operation of a bounce killer is a working SQL
  logging database (pen pals), or at least that all outbound DSN messages
  have a Message-ID with a domain matching the @local_domains_maps list of
  lookup tables. The condition is easily met when all mail from local users
  is submitted through a domain's official mailer, which goes hand in hand
  with the requirement for DKIM signing and for other similar antispoofing
  techniques (SPF, whitelisting by IP address in Received trace, ...).

  A couple of SNMP-like counters are added to facilitate assessing
  effectiveness of the feature (e.g. viewed by amavisd-agent utility):
    InMsgsBounce                   21310    333/h     9.9 % (InMsgs)
    InMsgsBounceKilled             19967    312/h    93.7 % (InMsgsBounce)
    InMsgsBounceRescuedByDomain        7      0/h     0.0 % (InMsgsBounce)
    InMsgsBounceRescuedByOriginating 242      4/h     1.1 % (InMsgsBounce)
    InMsgsBounceRescuedByPenPals      67      1/h     0.3 % (InMsgsBounce)
    InMsgsBounceUnverifiable        1027     16/h     4.8 % (InMsgsBounce)

  More information on operations can be obtained from a log, search for:
    inspect_dsn:
    bounce killed
    bounce rescued by penpals
    bounce rescued by domain
    bounce unverifiable

  The feature was suggested by Scott F. Crosby.

  See also http://www.postfix.org/BACKSCATTER_README.html,
  http://wiki.apache.org/spamassassin/VBounceRuleset and
  a SpamAssassin man page Mail::SpamAssassin::Plugin::VBounce
  for additional ideas on fighting joe-jobbed backscatter mail.


- a new configuration variable @author_to_policy_bank_maps (also a member
  of policy banks) is a list of lookup tables (typically only a hash-type
  lookup table is used), which maps author addresses(es) (each address in
  a 'From:' header field - typically only one) to one or more policy bank
  names (a comma-separated list of names).

  A match can only occur if a valid DKIM author domain signature or a valid
  DKIM third-party signature is found, so in as much as one can trust the
  signing domain, loading of arbitrary policy banks can be safe, offering
  a flexibility of whitelisting against spam (absolute or just contributing
  score points), bypassing of checks (banned, virus, bad-header), using
  less restrictive banned rules for certain senders, by-sender routing,
  turning quarantining/archiving on/off, and other tricks offered by the
  existing policy bank loading mechanisms.

  When a message has a valid DKIM (or DomainKeys) author domain signature
  (i.e. when a 'From:' address matches a signing identity according to DKIM
  (RFC 4871) or DomainKeys (RFC 4870) rules), a lookup key is an unchanged
  author address and the usual lookup rules apply (README.lookups - hash
  lookups).

  When a valid third-party signature is found, a lookup key (author address)
  is extended by a '/@' and a lowercased signing domain, as shown in the
  example below.

  The semantics is very similar to a whitelist_from_dkim feature in
  SpamAssassin, but is more flexible as is allows any dynamic amavisd
  setting to be changed depending on author address, not just skipping
  of spam checks.

  A few examples of a SpamAssassin's whitelist_from_dkim (as in local.cf)
  along with equivalent amavisd @author_to_policy_bank_maps entries follow.

  To whitelist any From address with a domain example.com when a message
  has a valid author domain signature (i.e. a signature by the same domain):
    SA:  whitelist_from_dkim  *@example.com
    am:  'example.com' => 'WHITELIST',
  which is equivalent to a lengthy but redundant:
    SA:  whitelist_from_dkim  *@example.com  example.com
    am:  'example.com/@example.com' => 'WHITELIST',

  Similar to above, but applies to subdomains of example.com carrying
  a valid author domain signature (i.e. signature BY THE SAME SUBDOMAIN):
    SA:  whitelist_from_dkim  *@*.example.com
    am:  '.example.com' => 'WHITELIST',
  Note that in amavisd hash lookups a '.example.com' implies a parent
  domain 'example.com' too, while in SpamAssassin and in Postfix maps
  a parent domain needs its own entry if desired.

  To whitelist From addresses from subdomains of example.com which carry
  a valid third-party signature of its parent domain:
    SA:  whitelist_from_dkim  *@*.example.com  example.com
    am: '.example.com/@example.com' => 'WHITELIST',

  To whitelist any From address as long as a message has a valid DKIM
  or DomainKeys signature by example.com, i.e. a third-party signature.
  Typical for mailing lists or discussion groups which sign postings.
    SA:  whitelist_from_dkim  *@*  example.com
    am:  './@example.com' => 'WHITELIST',

  Here is a complete example that can be included in amavisd.conf:

  @author_to_policy_bank_maps = ( {
  # 'friends.example.net'      => 'WHITELIST,NOBANNEDCHECK',
  # 'user1@cust.example.net'   => 'WHITELIST,NOBANNEDCHECK',
    '.ebay.com'                => 'WHITELIST',
    '.ebay.co.uk'              => 'WHITELIST',
    'members.ebay.co.uk/@ebay.co.uk' => 'WHITELIST',
    'ebay.at'                  => 'WHITELIST',
    'ebay.ca'                  => 'WHITELIST',
    'ebay.fr'                  => 'WHITELIST',
    'ebay.de'                  => 'WHITELIST',
    'members.ebay.de/@ebay.de' => 'WHITELIST',
    '.paypal.co.uk'            => 'WHITELIST',
    '.paypal.com'              => 'WHITELIST',  # author domain signatures
    './@paypal.com'            => 'WHITELIST',  # 3rd-party sign. by paypal.com
    'alert.bankofamerica.com'  => 'WHITELIST',
    'ealerts.bankofamerica.com'=> 'WHITELIST',
    'amazon.com'               => 'WHITELIST',
    'amazon.de'                => 'WHITELIST',
    'amazon.co.uk'             => 'WHITELIST',
    'cisco.com'                => 'WHITELIST',
    '.cnn.com'                 => 'WHITELIST',
    'skype.net'                => 'WHITELIST',
    'welcome.skype.com'        => 'WHITELIST',
    'cc.yahoo-inc.com'         => 'WHITELIST',
    'cc.yahoo-inc.com/@yahoo-inc.com' => 'WHITELIST',
    '.linkedin.com'            => 'MILD_WHITELIST',
    'google.com'               => 'MILD_WHITELIST',
    'googlemail.com'           => 'MILD_WHITELIST',
    './@googlegroups.com'      => 'MILD_WHITELIST',
    './@yahoogroups.com'       => 'MILD_WHITELIST',
    './@yahoogroups.co.uk'     => 'MILD_WHITELIST',
    './@yahoogroupes.fr'       => 'MILD_WHITELIST',
    'yousendit.com'            => 'MILD_WHITELIST',
    'meetup.com'               => 'MILD_WHITELIST',
    'dailyhoroscope@astrology.com' => 'MILD_WHITELIST',
  } );

  $policy_bank{'MILD_WHITELIST'} = {
    score_sender_maps => [ { '.' => [-1.8] } ],
  };
  $policy_bank{'WHITELIST'} = {
    bypass_spam_checks_maps => [1],
    spam_lovers_maps => [1],
  };
  $policy_bank{'NOVIRUSCHECK'} = {
    bypass_decode_parts => 1,
    bypass_virus_checks_maps => [1],
    virus_lovers_maps => [1],
  };
  $policy_bank{'NOBANNEDCHECK'} = {
    bypass_banned_checks_maps => [1],
    banned_files_lovers_maps  => [1],
  };


- smtp client connection caching is a new feature which allows smtp client
  code in amavisd to keep an SMTP session to MTA open after forwarding a
  message or a notification, so that a next mail message that needs to be
  sent by this child process can avoid re-establishing a session and the
  initial greeting/EHLO (and TLS) handshake.

  A current value of a global settings $smtp_connection_cache_enable
  controls whether a session will be retained after forwarding a message
  or not. Its default initial value is true.

  A global setting $smtp_connection_cache_on_demand controls whether amavisd
  is allowed to dynamically change the $smtp_connection_cache_enable setting
  according to its estimate of the message frequency. The heuristics is
  currently very simple: if time interval between a previous task completion
  by this child process and the arrival of a current message is 5 seconds
  or less, the $smtp_connection_cache_enable is turned on (which will affect
  the next message); if the interval is 15 seconds or more, it is turned off.
  The default value of the $smtp_connection_cache_on_demand is true, thus
  enabling the adaptive behaviour.

  On a busy server the connection caching can save some processing time.
  Savings are substantial if client-side TLS is enabled, otherwise just a
  few milliseconds are saved. On an idle server the feature may unnecessarily
  keep sessions to MTA open (until MTA times them out), so one can disable
  the feature by setting both controls to false (to 0 or undef).

  To monitor the connection caching effectiveness, some SNMP-like counters
  were added, so amavisd-agent may display something like:

    OutConnNew                      2764    319/h    98.2 % (OutMsgs)
    OutConnQuit                     2521    291/h    89.5 % (OutMsgs)
    OutConnReuseFail                   7      1/h     0.2 % (OutMsgs)
    OutConnReuseRecent                21      2/h     0.7 % (OutMsgs)
    OutConnReuseRefreshed             31      4/h     1.1 % (OutMsgs)
    OutConnTransact                 2816    325/h   100.0 % (OutMsgs)


- client-side TLS support is added, i.e. on forwarding a passed mail back
  to MTA. Currently only encryption is supported, no client certificates
  are offered. A $tls_security_level_out is a per-policy-bank setting which
  controls client-side TLS, its value is either undefined (default), or a
  string:

    undef ... client-side TLS is disabled (a default setting);
    'may' ... TLS is used if MTA offers a STARTTLS capability (RFC 3207),
              otherwise a plain text SMTP session is established;
    'encrypt' TLS is used if MTA offers a STARTTLS capability, otherwise
              amavisd refuses to forward a message.

  The client-side TLS imposes some performance penalty on passing a message
  back to MTA, although it is still reasonably fast: a benchmark indicates
  a drop in transfer rate by about a factor of 2, from 22 MB/s (no TLS)
  to 9 MB/s (with TLS). The smtp client connection caching (see previous item)
  should preferably be left enabled (permanently or opportunistically), as
  TLS negotiation adds significantly to the initial SMTP handshake time.


- server-side TLS support is added, i.e. on accepting mail from MTA.
  Encryption is supported, server (i.e. amavisd) offers its certificate,
  but client certificates are not verified. A $tls_security_level_in is
  a per-policy-bank setting which controls server-side TLS, its value
  is either undefined (default), or a string:

    undef ...  server-side TLS is disabled, STARTTLS capability is
               not offered;
    'may' ...  STARTTLS capability is offered by amavisd, but client is
               not required to enter TLS, plain text sessions are permitted;
    'encrypt'  STARTTLS capability is offered and enforced by amavisd,
               any SMTP command other than STARTTLS, NOOP, EHLO or QUIT
               is rejected.

  If $tls_security_level_in is enabled (any value other than undef or 'none'),
  amavisd offers a certificate to a connecting client requesting TLS, so a
  path to a certificate and to its private key must be provided through two
  global settings: $smtpd_tls_cert_file and $smtpd_tls_key_file, e.g.:

    $smtpd_tls_cert_file = "$MYHOME/cert/amavisd-cert.pem";
    $smtpd_tls_key_file  = "$MYHOME/cert/amavisd-key.pem";

  The private key should be guarded as secret (not world-readable).
  A self-signed certificate is acceptable by most mailers.

  Server-side TLS imposes a significant performance penalty on accepting
  a message from MTA. A benchmark indicates a drop in transfer rate by a
  factor of 10, from about 10 MB/s (no TLS) to 1 MB/s (using TLS), so it
  should only be enabled with a good reason or for experimentation.


- enhanced a subroutine delivery_status_notification (along with
  dispatch_from_quarantine and msg_from_quarantine) to produce a message
  in one of several formats (derived from a message being processed, or
  from a quarantined message). Its new arguments can be strings as follows:
    $request_type:  dsn, release, requeue, report
    $msg_format:    dsn, arf, attach, plain, resend
    $feedback_type: abuse, fraud, miscategorized, not-spam, opt-out,
                    opt-out-list, virus, other (according to ARF draft)

  Per-policy settings $report_format and $release_format control the format
  of a generated message. Their value can be one of the following strings,
  although not all combinations make sense:

   'arf' .... an abuse report is generated according to
              draft-shafranovich-feedback-report-04: "An Extensible
              Format for Email Feedback Reports"; a plain-text part
              contains text from a template;
   'attach'.. generates a report message as plain text according to
              a template, with an original message attached;
   'plain'... generates a simple (flat) mail with an only MIME part
              containing a text from a template, followed inline by
              original message (some service providers can't handle
              abuse reports with attachments, e.g. Yahoo!);
   'resend'.. original message is forwarded unchanged, except for an
              addition of header fields Resent-From, Resent-Sender,
              Resent-To, Resent-Date and Resent-Message-ID;
   'dsn' .... (for internal use) a delivery status notification is
              generated according to rfc3462, rfc3464 and rfc3461;

  When a request_type is 'release' or 'requeue', the format of a generated
  message is governed by a per-policy setting $release_format according to
  the table above. Only the 'attach', 'plain' and 'resend' values are useful.
  A default setting is:
    $release_format = 'resend';  # with alternatives: attach, plain, resend
  A plain-text part (if used) is taken from a $notify_release_templ template
  and a sending address is obtained from %hdrfrom_notify_release_by_ccat.

  When a request_type is 'report', the format of a generated message is
  governed by a per-policy setting $report_format according to the table
  above. Only the following settings are useful: arf, attach, plain, resend.
  A default setting is:
    $report_format = 'arf';      # alternatives: arf, attach, plain, resend
  A plain-text part (if used) is obtained from a $notify_report_templ
  template, and a sending address from %hdrfrom_notify_report_by_ccat.

  It is possible to automatically generate abuse reports from custom hooks
  by calling delivery_status_notification() and mail_dispatch(). Extreme
  care must be taken to only produce legitimate abuse reports (about true
  fraud and true spam), sent only to parties that are truly responsible for
  a message being reported. Non-repudiation is a key factor here - trust
  only header fields covered by a valid DKIM signature, or generated by
  your own MX MTA (such as an IP address of the last hop), and only report
  messages received from a network which officially belongs to the party
  (according to whois). Rate-limiting should be used, and abuse reports on
  the same abuser should only be sent once in a time interval of several
  hours. A SQL database can be used to maintain a list of recently reported
  abusers, thus preventing excessive reports.


- introduced a variation of a message release from a quarantine, allowing
  a releaser to send an abuse report based on a quarantined message.
  It is implemented by:

  * enhancing a subroutine delivery_status_notification as described
    in the previous item;

  * extending AM.PDP protocol with a 'request=report' attribute
    which can be used in place of a 'request=release',

  * enhancing the 'amavisd-release' utility program to allow sending an
    attribute 'request=release' or 'request=requeue' or 'request=report'
    based on its program name. By making a soft or hard link named
    'amavisd-report' linking to 'amavisd-release', the utility will
    send a 'request=report' in place of the usual 'request=release',
    e.g.:
      # ln -s amavisd-release amavisd-report
      # ln -s amavisd-release amavisd-requeue
      $ amavisd-report spam/k/kg2P0rP9Lpu3.gz '' abuse@example.com


- releasing from a quarantine can push a released message to an attachment
  (Content-Type: message/rfc822), with a configurable template for a header
  section and the plain-text part; select by: $release_format='attach';
  suggested by Patrick Ben Koetter;

- detect and save a new attribute SOURCE from an XFORWARD smtp command;
  the value is also accepted as AM.PDP protocol attribute 'client_source'.
  Possible values are: 'LOCAL', 'REMOTE', or '[UNAVAILABLE]', the information
  corresponds to 'local_header_rewrite_clients' postfix setting and is
  not supposed to be used for security decisions according to Postfix
  documentation (which makes it less interesting for our purposes);

- added client and server support for a PORT attribute of an XFORWARD command,
  allowing MTA to pass a TCP port number of a remote client to a content
  filter (and back if necessary); the PORT attribute is made available
  with Postfix version 2.5 (20071004); a source port number is also
  accepted as an AM.PDP protocol attribute 'client_port';

- updated p0f-analyzer.pl now supports a source port number information in
  queries while preserving backward compatibility with previous versions
  of amavisd-new. Version 2.6.0 of amavisd requires a new version of
  p0f-analyzer.pl (supplied in the 2.6.0 distribution) if operating system
  fingerprinting is enabled. A source port number information in a query
  allows p0f-analyzer.pl to locate a matching entry in its cache faster and
  also more accurately when multiple connections are present from clients
  behind NAT using the same IP address. The source port number is made
  available to a content filter since Postfix version 2.5 (20071004);

- besides the ability to send queries to p0f-analyzer.pl, amavisd now also
  supports sending queries directly to a p0f program over a Unix socket
  using a p0f query protocol. There is a bug in p0f-2.0.8 (and probably in
  earlier versions) which makes it send back incorrect results at times, i.e.
  results belonging to some other unrelated session, so a patch to p0f-2.0.8
  MUST be applied in order to use a direct querying mechanism - author has
  been notified. The patch is supplied: p0f-patch.

  There are currently no advantages (and some disadvantages) in choosing
  direct queries to p0f, compared to sending queries to p0f-analyzer.pl,
  so this new method is not currently recommended. Disadvantages are:
  * p0f uses a linear search over its list of recent sessions (at least
    as of version 2.0.8), whereas p0f-analyzer.pl uses a fast hash lookup;
  * p0f keeps a relatively small list of recent sessions which is limited
    by the number of slots (size can be specified on a command line, but
    is limited by a linear search time), whereas p0f-analyzer.pl expires
    old entries according to time since entered and is thus independent
    of a current mail rate;
  * a direct p0f query protocol uses packed binary data and its on-the-wire
    representation may depend on a compiler used, so it may be incompatible
    with queries sent by amavisd, whereas the p0f-analyzer.pl queries and
    replies use a more environment-independent textual representation.

  To let amavisd sent queries directly to p0f, specify a p0f socket path:
    $os_fingerprint_method = 'p0f:/var/amavis/home/p0f.sock';
  and specify an IP address and a port number on which MTA is listening:
    $os_fingerprint_dst_ip_and_port = '[192.0.2.3]:25';
  because p0f requires this information in a query and the information
  is not made available to a content filter via XFORWARD command
  (the p0f-analyzer.pl does not need this information).

  To send queries to p0f-analyzer.pl (traditional and recommended), use:
    $os_fingerprint_method = 'p0f:127.0.0.1:2345';
  as before. The $os_fingerprint_dst_ip_and_port in this case is not needed
  and is ignored.


- usually a sending address in spam messages is faked and it is desirable
  to suppress most if not all bounces by keeping $sa_dsn_cutoff_level low,
  but sometimes it may be possible to be more certain of the validity of
  a sending address, and when such mail is considered spam, it may still be
  desirable to send a non-delivery notification, knowing that a notification
  will most likely be addressed to a genuine sender.

  Two new settings are provided for this purpose:
    @spam_crediblefrom_dsn_cutoff_level_bysender_maps and
    @spam_crediblefrom_dsn_cutoff_level_maps
  (with their default being $sa_crediblefrom_dsn_cutoff_level),
  complementing the existing @spam_dsn_cutoff_level_bysender_maps and
  @spam_dsn_cutoff_level_maps.

  It is expected that $sa_crediblefrom_dsn_cutoff_level would be set somewhat
  higher than $sa_dsn_cutoff_level, allowing for more bounces to be generated
  for spam from likely-to-be-genuine senders (possibly false positives).

  The choice between taking a cutoff value from one or the other pair of
  settings depends on an attribute $msginfo->sender_credible - when it is
  true (e.g. some nonempty string) the *spam_crediblefrom_* settings will
  be used instead of the baseline @spam_dsn_cutoff_level_*maps.

  An initial value of a sender_credible attribute as provided by amavisd
  is true if either the 'originating' flag is true (e.g. mail from inside),
  or if dkim_envsender_sig attribute is true, e.g. a domain of a valid
  DKIM signature matches envelope sender address, otherwise it is false.
  A user-provided custom hook code is free to change the value of
  sender_credible attribute. An exact value does not matter (it is only
  interpreted as a boolean), but serves for logging purposes. Heuristics
  may be based on some tests provided by SpamAssassin, on DKIM signatures,
  on p0f results, on policy banks, etc.

  Here is one complete example of a custom hook, which turns on the
  sender_credible attribute based on some criteria. Note that some of
  the referenced SpamAssassin tests may not yet be available in the
  last officially released version of SpamAssassin.

  added to amavisd.conf:
    include_config_files('/etc/amavisd-custom.conf');

  /etc/amavisd-custom.conf :

    package Amavis::Custom;
    use strict;
    sub new { my($class,$conn,$msginfo) = @_; bless {}, $class }
    sub after_send {
      my($self,$conn,$msginfo) = @_;
      if ($msginfo->sender ne '') {
        my(@cred); local($1);
        my($tests) = $msginfo->supplementary_info('TESTS');
        $tests = ''  if !defined($tests) || $tests eq 'none';
        push(@cred,'orig')   if $msginfo->originating;
        push(@cred,$1)       if $tests =~ /\b(RCVD_IN_DNSWL_HI)\b/;
        push(@cred,$1)       if $tests =~ /\b(RCVD_IN_DNSWL_MED)\b/;
        push(@cred,$1)       if $tests =~ /\b(RP_MATCHES_RCVD)\b/;
        my($os_fingerprint) = $msginfo->client_os_fingerprint;
        if ($os_fingerprint !~ /^Windows XP(?![^(]*\b2000 SP)/) {
          push(@cred,'dkim') if $msginfo->dkim_envsender_sig;
          push(@cred,$1)     if $tests =~ /\b(SPF_PASS)\b/;
        }
        $msginfo->sender_credible(join(",",@cred))  if @cred;
      }
    }
    1;  # insure a defined return


- a new setting $reputation_factor (also a member of policy banks) with
  a value between 0 and 1 (default 0.2), controlling an amount of 'bending'
  of a calculated spam score towards a fixed score assigned to a signer
  identity (i.e. its 'reputation') through @signer_reputation_maps;
  the formula is: adjusted_spam_score = f*reputation + (1-f)*spam_score;
  which has the same semantics as auto_whitelist_factor in SpamAssassin AWL;


- a new setting @signer_reputation_maps (also a member of policy banks) may
  contain a list of lookup tables (typically just one hash lookup table),
  mapping a signing identity to a score, which is typically a long term
  average spam score of all messages signed by this signing identity.
  Based on a lookup result and a formula given above ($reputation_factor),
  the resulting value (positive or negative) is added to the spam score.

  Here is an example setting:

@signer_reputation_maps = (
{ 'ebay.fr'                  => -10.95,
  'ebay.ca'                  =>  -9.57,
  'ebay.co.uk'               =>  -8.59,
  'ebay.com'                 =>  -8.03,
  'ebay.at'                  =>  -3.59,
  'ebay.de'                  =>  -3.38,
  'reply3.ebay.com'          =>  -4.57,
  'reply.ebay.com'           =>  -3.20,
  'paypal.com'               =>  -6.66,
  'intl.paypal.com'          =>  -3.70,
  'email.paypal.co.uk'       =>  -0.67,
  'alert.bankofamerica.com'  =>   1.35,

  'ucsd.edu'                 =>  -7.89,
  'izb.knu.ac.kr'            =>  -7.51,
  'ijs.si'                   =>  -4.44,
  'tu-graz.ac.at'            =>  -5.44,
  'tugraz.at'                =>  -4.03,
  'aitech.ac.jp'             =>  -3.03,
  'univie.ac.at'             =>  -2.99,
  'uni-bremen.de'            =>  -2.80,
  'uu.se'                    =>  -2.54,
  'univ-tours.fr'            =>  -2.06,
  'phys.huji.ac.il'          =>  -2.01,
  'cern.ch'                  =>  -1.69,

  'prime.gushi.org'          =>  -9.85,
  'dostech.ca'               =>  -9.31,
  'resistor.net'             =>  -9.18,
  'kitterman.com'            =>  -9.05,
  'schetterer.org'           =>  -9.04,
  'hege.li'                  =>  -8.96,
  'fouter.net'               =>  -8.84,
  'inetmsg.com'              =>  -8.81,
  'charite.de'               =>  -8.81,
  'porcupine.org'            =>  -8.75,
  'secnap.net'               =>  -7.99,
  'netoyen.net'              =>  -7.58,
  'state-of-mind.de'         =>  -6.93,
  'gmurray.org.uk'           =>  -5.39,
  'mtcc.com'                 =>  -4.93,
  'messiah.edu'              =>  -4.91,
  'consulintel.es'           =>  -2.16,
  'delphij.net'              =>   1.06,

  'channing-bete.com'        =>  -9.11,
  'megan.vbhcs.org'          =>  -8.64,
  'scent-team.com'           =>  -8.32,
  'suedfactoring.de'         =>  -8.15,
  'sendmail.net'             =>  -5.14,
  'cisco.com'                =>  -4.95,
  'hermes-softlab.com'       =>  -3.77,
  'altn.com'                 =>  -2.16,
  'amazon.com'               =>   0.09,
  'eurescom.eu'              =>  -0.63,
  'skype.net'                =>  -1.50,
  'welcome.skype.com'        =>  -0.34,
  'newsdesk.world-nuclear-news.org'=> -0.74,
  'youtube.com'              =>   1.11,
  'email.innocentive.com'    =>   1.98,
  'update.hallmark.com'      =>   2.26,
  'newsletters.trendmicro.com'=>  3.02,
  'mail.communications.sun.com'=> 3.73,
  'alerts.hp.com'            =>   0.51,
  'email.greenpeace.org'     =>   2.04,
  'avaaz.org'                =>   3.51,
  'mail.cnn.com'             =>   4.12,
  'm-w.com'                  =>   4.81,
  'medcompare.com'           =>   2.46,
  'biocompare.com'           =>   3.48,
  'dentalcompare.com'        =>   4.58,
  'news.biomedcentral.com'   =>   2.89,

  'yahoo.com'                =>  -0.53,
  'yahoo.se'                 =>  -1.48,
  'yahoo.de'                 =>  -1.33,
  'yahoo.co.uk'              =>   0.85,
  'yahoo.ca'                 =>   1.13,
  'yahoo.no'                 =>   1.22,
  'yahoo.es'                 =>   2.04,
  'yahoo.ie'                 =>   4.48,
  'yahoo.fr'                 =>   6.35,
  'yahoo.it'                 =>   7.09,
  'yahoo.dk'                 =>   7.10,
  'yahoo.co.in'              =>   5.34,
  'yahoo.com.cn'             =>   4.34,
  'yahoo.com.ar'             =>   5.48,
  'yahoo.co.jp'              =>   9.25,
  'yahoo.com.au'             =>   9.30,
  'yahoo.com.hk'             =>  13.97,
  'yahoo.cn'                 =>  21.94,
  'yahoo-inc.com'            =>  -1.57,
  'yahoogroups.com'          =>  -1.76,
# 'yahoogroups.co.uk'        =>   0.10,
# 'yahoogroupes.fr'          =>   5.99,
  'yahoogroups.de'           =>  19.96,
  'yahoogrupos.com.br'       =>  17.41,
  'gmail.com'                =>  -3.52,
  'googlegroups.com'         =>  -3.10,
  'googlemail.com'           =>   3.42,
  'google.com'               =>   1.47,
  'prodigy.net'              =>  -8.91,
  'amis.net'                 =>  -2.38,
  'earthlink.net'            =>  -2.27,
  'btinternet.com'           =>  -1.96,
  'pacbell.net'              =>  -0.96,
  'rogers.com'               =>   2.05,
  'ipost.com'                =>   2.40,
  'incertum.net'             =>  -9.80,
  'yousendit.com'            =>  -4.70,
  'news.yousendit.com'       =>   3.38,
  'abv.bg'                   =>  -4.57,
  'uclouvain.be'             =>  -4.48,
  'birthdayalarm.com'        =>  -4.32,
  'geni.com'                 =>  -3.50,
  'mail120.subscribermail.com'=> -2.58,
  'mail6.subscribermail.com' =>  -1.97,
  'spock.com'                => -11.67,
  'meetup.com'               =>  -1.94,
  '123greetings.com'         =>  -1.92,
  'rocketmail.com'           =>  -1.91,
  'arcamax.com'              =>  -0.81,
  'skynet.be'                =>  -0.10,
  'news.virtualtourist.com'  =>   3.58,
  'bighip.com'               =>  10.53,
  'investorsinsight.com'     =>  12.19,
  'lspromos2007online.com'   =>  12.41,
  'postmaster-direct.com'    =>  12.71,
  'smsacfriends.com'         =>  12.88,
  'specialtyofficial.com'    =>  13.03,
  'usafisnews.org'           =>  13.82,
  'freelotto.com'            =>  15.59,
  'partnershopping.net'      =>  19.46,
  'muffinlocate.com'         =>  19.49,
  'stallrust.com'            =>  19.71,
  'sugargrowth.com'          =>  19.75,
  'washusual.com'            =>  20.01,
  'poursmock.com'            =>  20.02,
  'overseeinvest.com'        =>  20.19,
  'waveholer.com'            =>  20.27,
  'headattomic.com'          =>  20.32,
  'moneysuffer.com'          =>  20.84,
  'ibnyes.com'               =>  20.95,
  'honorfamous.com'          =>  20.96,
  'trapdull.com'             =>  20.96,
  'solvehigh.com'            =>  21.57,
  'tracerope.com'            =>  21.68,
  'yesalumni.com'            =>  21.71,
  'internetpromotional.net'  =>  23.16,
  'domaingln11track.com'     =>  23.69,
  'news-central-99.com'      =>  24.00,
  'sports-bobble-heads.com'  =>  24.69,
  'dans-fishing-adventure.com'=> 26.39,
  'myhottdeals.net'          =>  26.65,
  'nitroda.com'              =>  28.75,
  'spaninns.com'             =>  29.08,
  'pinaycamgirls.net'        =>  29.24,
  'aspsbulletins.com'        =>  13.06,
  'latestsbulletins.com'     =>  13.35,
  'bulletinshops.com'        =>  13.40,
  'academicsbulletins.com'   =>  13.49,
  'tigersbulletins.com'      =>  14.13,
  'nakedsbulletins.com'      =>  14.17,
  'paintedsbulletins.com'    =>  14.33,
  'opensbulletins.com'       =>  14.58,
  'domainsbulletins.com'     =>  14.61,
  'seniorssbulletins.com'    =>  14.72,
  'dodgesbulletins.com'      =>  15.23,
  'mindsbulletins.com'       =>  15.96,
  'researchsbulletins.com'   =>  15.98,
  'salessbulletins.com'      =>  16.12,
  'netsbulletins.com'        =>  16.83,
  'virtualsbulletins.com'    =>  17.14,
  'petbulletins.com'         =>  17.30,
  'citysbulletins.com'       =>  18.46,
  'wearesurveys.net'         =>  23.36,
  'takeoursurveys.net'       =>  24.50,
  'thankyousurveys.net'      =>  24.62,
  'greetingssurveys.info'    =>  24.63,
  'allaboutsurveys.net'      =>  25.71,
  'internetssurvey.info'     =>  25.98,
  'theinternetsurveys.net'   =>  26.14,
  'netsurveysnet.net'        =>  26.85,
  'surveydept.info'          =>  23.39,
  'survysample.info'         =>  25.82,
  'gosurrvey.info'           =>  26.02,
  'surrvytime.info'          =>  26.41,
  'thedailyinfo.info'        =>  21.96,
  'thenetinfo.info'          =>  23.27,
  'nettinfo.info'            =>  27.41,
  'theinfoguide.info'        =>  29.91,
  'alloursamples.info'       =>  22.71,
  'officeofferonline.info'   =>  24.77,
  'cashsuggestion.info'      =>  26.84,
  'insaneofferdeal.info'     =>  26.87,
  'rewardcenterrs.info'      =>  30.04,
  'gifttsgroup.info'         =>  31.48,
  'ourgiftworld.info'        =>  32.46,
  'giftwinninngs.info'       =>  34.11,
  'mygiftwinninngs.net'      =>  31.12,
  'gifttsgroup.net'          =>  33.05,
  'giftwinninngs.net'        =>  34.95,
});


- drop privileges sooner if possible - right after reading config file and
  before forking;

- allow inserting X-Quarantine-ID header field into passed (and quarantined)
  mail for local recipients only; remote recipients should not be made aware
  that we may have a copy in a quarantine; reported by Robert Fitzpatrick;

- check for multiple occurrences of RFC 2045 and RFC 2183 MIME header fields
  (in addition to checks on RFC 2822 header fields):
    MIME-Version Content-Type Content-Transfer-Encoding
    Content-ID Content-Description Content-Disposition
  and the RFC 3834 header field: Auto-Submitted

- capture SpamAssassin logging and integrate it into the usual amavisd log;
  suggested by Jeff Moss;

- when parsing SpamAssassin log areas/facilities, recognize negations
  (a name prefixed by 'no') and remove duplicates, last entry wins, e.g.
    amavisd -d rules,noall,norules,dcc,norules,rules debug-sa
  is equivalent to:
    amavisd -d noall,dcc,rules debug-sa

- a SpamAssassin debug level 'info' is now implicitly prepend to a list of
  SpamAssassin facilities; it may be overridden by explicitly negating it,
  e.g. 'amavisd -d noinfo';

- when a command line argument 'debug-sa' is present, or if $sa_debug is
  true, a SpamAssassin debug level 'all' is prepend to a list of SpamAssassin
  facilities, which would bring SpamAssassin log level to 'dbg';  it may be
  overridden by negating it, e.g. 'amavisd -d noall,plugins,rules debug-sa';

- include milliseconds in a log timestamp when logging is directed to stderr;

- create a custom hook object sooner, so that loading a policy bank from a
  custom hook becomes useful (but not soon enough to influence partition_tag);

- added a custom hook after_send, which may suppress DSN, send reports,
  quarantine, etc;

- fetch additional information (tag) 'TIMING' from SpamAssassin, making it
  available through macro 'supplementary_info' (if a version of SpamAssassin
  in use provides it - available since 3.3.0);

- a SpamAssassin TIMING-SA report (timing breakdown by sections) is now
  collected and logged at log level 2 when available; the information is
  available since version 3.3.0 of SpamAssassin (currently in development
  and available through SVN);

- add a global configuration variable $listen_queue_size (undef by default)
  which is passed as an option 'listen' to Net::Server, which in turn passes
  it on to listen(2) as a 'backlog' parameter. The Net::Server provides
  a default value of SOMAXCONN in the absence of a valid integer in
  $listen_queue_size (e.g. 128, but on Solaris it defaults to 5, which
  is too small for some purposes). Suggested by David Schweikert.
  A workaround for a small SOMAXCONN default on Solaris is provided
  by Net::Server 0.98 (?).

- in the absence of an smtp client's IP address (normally received by XFORWARD
  smtp command from Postfix, or in the 'client_address' attribute of AM.PDP),
  parse the topmost one or two Received header fields and use the first
  valid IP address found there; based on a suggestion by Richard Bishop;

- new macros (useful in notifications and $log_template):
  - 'week_iso8601'  returns an ISO 8601 week number (between 1 and 53);
  - 'partition_tag' returns a current value of a $sql_partition_tag variable;
  - 'dkim'          reports various DKIM verification results;
  - 'report_format' gives one of the: dsn, arf, attach, plain, resend
  - 'feedback_type' is expected to give one of the ARF (draft) strings:
                    abuse, fraud, miscategorized, not-spam, opt-out,
                    opt-out-list, virus, other
  - 'rfc2822_from'  an e-mail address from a From header field;
  - 'rfc2822_sender' an e-mail address from a Sender header field, or empty;
  - 'tls_in'        returns TLS ciphers in use by an SMTP session if mail came
                    to amavisd through a TLS-encrypted session, otherwise empty
  - 'limit'         takes two arguments: a string size limit and some string,
                    returning the string from the second argument unchanged
                    if its size is below the limit, or cropped to the size
                    limit, with '[...]' appended;
  For details see README.customize.

- new configuration setting $allow_fixing_long_header_lines, also member
  of policy banks, defaults to true - provides control over truncation of
  header section lines longer than 998 characters as limited by RFC 2822.
  The $allow_fixing_improper_header must also be true for fixing to take
  place. Previously it was only possible to turn off all header fixes,
  but not specifically just the long header truncation;

- strip X-Spam-* headers and other prepended header fields when releasing
  a quarantined message;

- turn on message part attributes 'C' (crypted) and 'U' (undecipherable)
  if a MIME Content-Type of that body part is <anything>/encrypted;
  (note: if $defang_undecipherable is turned on, this would push a
  received PGP/GPG-encrypted MIME top-part into an attachment, just
  as with other password-protected archives);

- fetch additional information (tags) DCCB and DCCR from a SpamAssassin
  DCC plugin, making them available through a macro 'supplementary_info';

- amavisd-nanny and amavisd-agent now reopen a database if/when the underlying
  database file is re-created (i.e. when its inode changes), as is the case
  when amavisd restarts; based on a patch by Rob Foehl;

- amavisd-nanny and amavisd-agent got a new command line option: -c count,
  which can restrict the number of iterations for display;
  usability deficiency pointed out by John Evans;

- amavisd-nanny and amavisd-agent will use a value from an environment
  variable AMAVISD_DB_HOME (if it exists) as a database home directory,
  otherwise fall back to a built-in default '/var/amavis/db';
  suggested by Leo Baltus;



OTHER

- added an AV entry for a new version of a ESET File Security (for Linux and
  FreeBSD) command line scanner (ESET Software ESETS Command Line Interface
  v 2.71.12); the nod32cli utility has been replaced by esets_cli;
  update provided by Willi Gruber;

- keep time of a message reception (or creation) in rx_time as a floating
  point value as provided by Time::HiRes::time in order to avoid discrepancy
  in SNMP-like counters showing elapsed times; suggested by David Schweikert;

- store additional attributes in per-message and per-recipient objects,
  reducing a need for repeated lookups;

- to save time the: tag, tag2, tag3 and kill levels are not looked up when
  a recipient is bypassing spam checks;

- no longer reverse-resolve an IP address obtained from a Received header
  field on infected mail: it does not work for IPv6, it can be stuck for
  prolonged periods waiting for a response from a non-responsive DNS server,
  and is only used for logging/notifications (macros %e and %o) on infected
  mail, so it is not too bad to drop it;

- obey the always_bcc_by_ccat even when releasing from a quarantine;
  thanks to Tomas Horacek;

- for consistency with other quarantine methods: store recipient address
  (e.g. a quarantine mailbox e-mail address) as a quarantine location
  even if a quarantine method is 'smtp:' or 'lmtp:';

- a quarantined message now receives one additional header field: an
  X-Envelope-To-Blocked. An X-Envelope-To still holds a complete list
  of envelope recipients, but the X-Envelope-To-Blocked only lists its
  subset (in the same order), where only those recipients are listed
  which did not receive a message (e.g. being blocked by virus/spam/
  banning... rules). This facilitates a release of a multi-recipient
  message from a quarantine in case where some recipients had a message
  delivered (e.g. spam lovers) and some had it blocked;

- a release request now takes its default recipients list from a header
  field X-Envelope-To-Blocked, no longer from X-Envelope-To. This avoids
  releasing a message to recipients which have already received it in
  the first place, e.g. spam lovers. For backward compatibility, if
  X-Envelope-To-Blocked header field is not found in a quarantined
  message, the recipients list defaults to X-Envelope-To as before.
  A release request can still provide its explicit list of recipients
  to override a default, like before. Loosely based on suggestions
  by Christer, by Paolo Schiro and others;

- when mail is received from a helper program such as a milter, update
  a true mail size ($msginfo->msg_size) according to size definition
  in RFC 1870, adjusting for CRLF line terminators;

- updated SMTP enhanced status response codes to an AUTH command
  according to RFC 4954 (SMTP Service Extension for Authentication);

- quote_rfc2821_local: within qcontent all non-qtext characters should be
  represented as quoted-pairs (RFC 2822); in addition to " and \ (which were
  already handled), this includes NUL, CR, LF, HT, SP and 8-bit characters;

- macros T, C and B now bring e-mail addresses in quoted form and in angle
  brackets, notification templates no longer add angle brackets around
  %T and %C;

- when defanging mail body no longer insert our own Sender header
  field on a pretense that it helps with DKIM resigning - according to
  ADSP (ex SSP) the DKIM/ADSP does not care for the Sender header field
  (unlike a historical DomainKeys);

- always provide X-Amavis-PolicyBank header field in a copy of a mail as
  submitted to SpamAssassin, even if a policy bank path is empty - this
  allows for simpler SpamAssassin rules to avoid being tricked by a
  presence of such header field inserted by third parties;

- add missing installs of amavisd-nanny and amavisd-agent utilities
  to amavisd-new.spec; suggested by Eddy Beliveau;

- internal: original header section is no longer kept in two copies (in
  orig_header and in orig_header_fields). Instead, orig_header now holds
  an array of header *fields* (previously: array of header *lines*), and
  orig_header_fields now stores a by- header-field-name hash of indices
  into orig_header (previously it held copies of header field bodies).
  To facilitate access to individual header fields and allow for top-down
  and bottom-up search for a n-th occurrence of a header field, two new
  access methods are provided: get_header_field and get_header_field_body;
  these are optimized for a quick access to the *last* header field
  (previously the *first* one was kept easily accessible);

- internal: when specific header fields are looked up in an original header
  section (such as From, To, Subject, Message-ID, ...) now the *last* (the
  most to the bottom) occurrence of a header field (instead of the first)
  is used for better compatibility with DKIM which searches for header
  fields bottom-up;

- internal: when a message is received, a current setting of a boolean
  attribute $originating (global or from current policy banks) is now copied
  to an Amavis::In::Message object and becomes a property of a message;
  this allows for other message objects (like notifications, quarantine)
  to have their own individual setting of this attribute, for example
  notifications are always flagged as originating and as such are eligible
  for DKIM signing;

- internal: provide an Amavis::MIME::Body::OnOpenFh package which acts as
  a MIME::Body -type object (read-only) with an underlying representation
  in an existing (permanently open) temporary mail file, avoiding a need to
  open it by file name on a separate file handle.  It is useful (simpler,
  faster) when defanging (pushing original mail to an attachment), or when
  generating notifications or reports which contain an original mail;

- internal: new subroutines init_child and rundown_child in the interface
  module Amavis::SpamControl::SpamAssassin, which call SpamAssassin plugin
  methods "spamd_child_init" and "spamd_child_post_connection_close";
  this is required for correct operation of some SpamAssassin plugins
  such as the Mail::SpamAssassin::Plugin::DBI; thanks to Michael Scheidell
  for pointing out that plugin;

- internal: renamed a subroutine string_to_mime_entity into build_mime_entity
  and generalize its functionality to make it useful for generating reports;

- internal: generalized subroutine delivery_status_notification which can
  now also prepare message in a format of a feedback report (ARF) or just
  as a plain included (inline) original mail;

- internal: a subroutine passed to edit_header() may return undef, in which
  case a header field will be deleted instead of being replaced/edited;

- internal: sub lookup_sql incompatible change to the order of arguments;

- internal: a small speedup in receiving mail contents over SMTP or LMTP;

- internal: abandon package Amavis::Lock, do the four calls to flock directly;

- internal: move subroutines dealing with processes from module Amavis::Util
  into a new module Amavis::ProcControl;

- internal: reduce buffer sizes in some copying loops from 64kB back to 32kB,
  larger buffers do not perform any better;

- documentation: amavisd.conf-default: add a list of legacy dynamic
  configuration variables which can be used in policy banks;
  thanks to Gary V;

- terminology: use a term 'header section' (in comments, log entries and
  templates) instead of a 'header' to go along with the 2822upd draft;


A QUICK START TO DKIM VERIFICATION

Starting with 2.6.0, verification of DKIM signatures (and historical
DomainKeys signatures) is provided directly by amavisd (not only by a
SpamAssassin plugin DKIM). A required version of a perl module Mail::DKIM
is 0.31 or later. Signature verification is sufficiently fast so there
